2026-03-02  Gavin Smith <gavinsmith0123@gmail.com>

	Texinfo 7.3

2026-03-02  Gavin Smith <gavinsmith0123@gmail.com>

	* configure.ac: update version to 7.3.
	* doc/refcard/txirefcard.tex: 2026

2026-03-02  Gavin Smith <gavinsmith0123@gmail.com>

	* README-hacking: update

2026-03-02 Patrice Dumas  <pertusus@free.fr>

	* tta/C/texi2any.c (PATH_SEP): fix typo and avoid using tab.

2026-02-29 Patrice Dumas  <pertusus@free.fr>

	* INSTALL: do not document TEXINFO_XS=requiredifenabled, it is too
	soon, the feature may not be kept in this form.

2026-02-28  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Image Syntax, Command List):
	Reword to avoid underful hboxes when processing with TeX.

2026-02-28  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/info-stnd.texi (Custom Key Bindings): Place URL in footnote,
	to prevent issue with line breaking in the PDF (as font is smaller
	in the footnote).

2026-02-28  Gavin Smith <gavinsmith0123@gmail.com>

	* INSTALL: edit

2026-02-28  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/refcard/txirefcard.tex: update to add new commands.

2026-02-28  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.texi
	(Document Metadata) Add missing index entry for @documentinfo.
	(@titlefont @center @sp): Fix typo.

2026-02-28 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/texinfo.c (txi_tree_transformation_table): make static
	const, it is only used in this file.

	* tta/C/main/command_data.awk, tta/C/main/command_data.c,
	tta/C/main/element_types.awk, tta/C/main/element_types.c,
	tta/C/main/utils.c: add explicit const for constant structures.

2026-02-28 Patrice Dumas  <pertusus@free.fr>

	Correct path separator for XDG directories and ctexi2any

	* tta/perl/texi2any.pl (add_config_paths), tta/C/texi2any.c
	(add_config_paths): use PATH paths separator for XDG base directory
	specification directories lists.

	* tta/C/Makefile.am (C_libtexinfo_sources), tta/C/main/system.h
	(O_BINARY): add system.h for the O_BINARY definition, which can be
	shared among diverse code files.

	* tta/C/main/utils.c, tta/C/main/utils.h: define paths related macros
	in utils.c and use system.h.

	* tta/C/texi2any.c, tta/C/Makefile.am (ctexi2any_CPPFLAGS)
	(teximakehtml_CPPFLAGS): set PATH_SEP based on O_BINARY and __CYGWIN__
	and not based on configure generated PATH_SEPARATOR, as PATH_SEPARATOR
	is for the shell used for the compilation, while we need some value
	that can also be valid for a native command as described in the
	Texinfo manual.  Report from Eli Zaretskii.

2026-02-28  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/info-stnd.texi: use @r in index entries where appropriate
	and eliminate duplicate or incorrect index entries.

2026-02-28  Gavin Smith <gavinsmith0123@gmail.com>

	TEXINFO_OUTPUT_FORMAT documentation

	* doc/texinfo.texi
	(Customization Variables and Options, Output Format Selection):
	Split discussion of the possible values of TEXINFO_OUTPUT_FORMAT
	into its own node.  Comment out second index entry for
	"TEXINFO_OUTPUT_FORMAT".  Fix example.

2026-02-28  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.texi: eliminate many duplicate index entries,
	so that e.g. "info texinfo ENABLE_ENCODING" goes to a part
	of the file where "ENABLE_ENCODING" is directly mentioned.

2026-02-27  Gavin Smith <gavinsmith0123@gmail.com>

	* js/info.css: move declarations for sidebar into section
	for sidebar.  many of these appear to have been added to the
	file without regard for the pre-existing structure of the file.

2026-02-27  Gavin Smith <gavinsmith0123@gmail.com>

	* js/info.css (#slider): increase opacity.

2026-02-27  Gavin Smith <gavinsmith0123@gmail.com>

	* js/info.css (div.toc-sidebar): Specify "width: 100%" to
	prevent the scroll bar potentially occurring only half-way
	across the width of the sidebar TOC, which would happen if
	there were only short section titles which didn't need to
	wrap across lines.

2026-02-27  Gavin Smith <gavinsmith0123@gmail.com>

	* js/info.css: remove setting of background colour for some
	elements within the sidebar, as all this appears to accomplish
	is some small rectangles within the sidebar being coloured in a
	slightly different shade of grey to the rest of it.

2026-02-27  Gavin Smith <gavinsmith0123@gmail.com>

	* js/info.js (Sidebar): check if short toc is defined before
	attempting to remove it.

2026-02-27  Gavin Smith <gavinsmith0123@gmail.com>

	js: Fix scrolling to top of scroll bar for Top node

	* js/info.js (init_sidebar) <scan_toc, add_header>:
	Use "toc-index" for ID of link at top of sidebar, as "index"
	is not unique and so scrolling to the top of the sidebar can
	fail when the user navigates to the Top node.

2026-02-27  Gavin Smith <gavinsmith0123@gmail.com>

	* js/info.js (Sidebar): Remove short contents as well as contents
	from Top node.

2026-02-27  Gavin Smith <gavinsmith0123@gmail.com>

	* js/info.css (div[node]): Change "overflow" setting back to "auto",
	as a scrollbar was missing on the Top node.

2026-02-27  Gavin Smith <gavinsmith0123@gmail.com>

	* README-hacking: minor changes to section on checking with valgrind

2026-02-27  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/Makefile.am (EXTRA_DIST): distribute doc/image.pdf to
	allow texinfo-tex-test.texi to be built.

2026-02-27  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo-tex-test.texi (@multitable):
	Remove a second test case of @multitable inside @quotation.
	It's not clear this added anything beyond the first test case.

2026-02-27  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo-tex-test.texi (Line macros):
	Add a heading line to separate a test case.  This makes it more
	clear when the "macro use/macro output" pairs end.

2026-02-27 Patrice Dumas  <pertusus@free.fr>

	* configure.ac, tta/configure.ac: correct a comment, AC_PROG_INSTALL
	is used by gettext.  Report from Gavin.

2026-02-27  Gavin Smith <gavinsmith0123@gmail.com>

	Special gnulib patch for wctype.in.h for MinGW

	* gnulib/lib/wctype.in.h, tta/gnulib/lib/wctype.in.h:
	Apply update from Bruno Haible to fix build issue on old MinGW.
	This file will be updated automatically when we do gnulib updates
	in the future, but we want to limit gnulib updates before the release
	as there has already been a lot of testing with the current version
	of the code.

2026-02-27  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/perl/t/08misc_commands.t (definfoenclose_command_on_section_line):
	Skip test.

2026-02-25 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/node_name_normalization.c
	(convert_to_normalized_internal): use the equivalent builtin command
	obtained by calling element_builtin_data_cmd for checks and as
	command_normalization_text index.  This is important if the element is
	a user-defined @-command, such as a definfoenclosed command.  Report
	by Hilmar Preusse and analysis by Gavin.
	  https://mail.gnu.org/archive/html/bug-texinfo/2026-02/msg00110.html

	* tta/perl/Makefile.tres, tta/perl/t/08misc_commands.t
	(definfoenclose_command_on_section_line): test definfoenclose defined
	command on section line.

2026-02-21 Patrice Dumas  <pertusus@free.fr>

	Download country codes and regenerate related codes

	* tta/maintain/regenerate_documentlanguages-loc.pl: update url. 

2026-02-21 Patrice Dumas  <pertusus@free.fr>

	* README-hacking: describe the possibility to set
	PERL_DESTRUCT_LEVEL=2 in the environment.  Add an example of valgrind
	call on t/z_misc/*.t tests.

2026-02-21 Patrice Dumas  <pertusus@free.fr>

	* util/texinfo.dtd (set, clear, unmacro, clickstyle): fix mixed
	content specification.

	* util/texinfo.dtd (publication, maketitle, documentinfo): add.

2026-02-21 Patrice Dumas  <pertusus@free.fr>

	Update tta/C/ppport.h

2026-02-21 Patrice Dumas  <pertusus@free.fr>

	* tta/tests/other/list-of-tests
	(accented_lang_index_collation_documentlanguage_collation): set
	MESSAGE_ENCODING=UTF-8 to have the same error messages for Perl and C.

2026-02-21 Patrice Dumas  <pertusus@free.fr>

	Avoid encoding error messages for error and warning messages

	* tta/C/main/utils.h (enum iconv_error_handling), tta/C/main/utils.c
	(encode_with_iconv): add error_handling for cases of bytes that cannot
	be converted, to get either an error with a message (previous
	default), no error and bytes skipped, or no error and a ? mark added
	for each error.  Rename silent_status argument as iconv_status.

	* tta/C/main/utils.c (encode_string): add error_handling argument.
	Update callers.

	* tta/C/main/errors.c (error_message_text), tta/C/main/txi_config.c
	(GNUT_encode_message): use ieh_mark to get marks in the error messages
	for bytes that cannot be converted and no encoding error messages.

2026-02-21 Patrice Dumas  <pertusus@free.fr>

	Fix memory leak and other memory issues found by valgrind

	* tta/C/convert/format_html.c (mini_toc_internal): free text.

	* tta/C/main/translations.c (free_lang_translation): free
	lang_translation->encoded_lang.

	* tta/C/convert/html_converter_finish.c (html_free_converter):
	free self->translated_special_unit_info_texinfo,
	self->files_css_import_lines and self->files_css_rule_lines.

	* tta/C/convert/html_converter_finish.c (html_free_converter):
	free main_units_direction_names after calling
	html_free_direction_icons_array, as html_free_direction_icons_array
	uses main_units_direction_names.

	* tta/C/main/manipulate_indices.c (destroy_collator): free coll.sv
	only if the collation type is not ctn_locale_collation as the
	collator is a union.

2026-02-21 Patrice Dumas  <pertusus@free.fr>

	* tta/configure.ac (AC_PROG_INSTALL, AC_PROG_MAKE_SET)
	(AC_PROG_LN_S, AC_PROG_MKDIR_P): call those autoconf macros in
	tta/configure.ac too.

2026-02-21 Patrice Dumas  <pertusus@free.fr>

	* tta/C/Makefile.am (install-exec-hook), tta/perl/Makefile.am
	(install-exec-hook): cd to the directory where the link is done,
	otherwise if LN_S is cp, the file copied is the file from the source
	directory.  Report from Eli Zaretskii and solution from the Automake
	LN_S documentation, as also found by Gavin.

2026-02-20 Patrice Dumas  <pertusus@free.fr>

	* NEWS, doc/texinfo.texi (Generic Translator @command{texi2any}),
	tta/README: qualify the C texi2any implementation as being
	experimental.

	* README-hacking: add information on manual testing that texi2any
	is relocatable.

	* tta/TODO: update with Eli information on ctexi2any on Windows.

2026-02-20 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/texinfo.c (txi_setup_main_load_interpreter): minor
	move of code, add/improve comments.

	* tta/C/main/call_perl_function.c (call_eval_load_texinfo_modules):
	change converter_datadir variable name to modules_dir.

	* tta/perl/load_txi_modules.pl: sync with texi2any.pl.

	* tta/perl/texi2any.pl (set_subdir_directories): add an explicit
	$datadir argument.

2026-02-20 Patrice Dumas  <pertusus@free.fr>

	Make ctexi2any relocatable. Pass datadir from/to Perl and C

	* tta/C/main/utils.c (messages_and_encodings_setup): add datadir
	argument to make relocatable.

	* tta/C/convert/texinfo.c (txi_setup_main_load_interpreter),
	tta/C/main/document.c (setup_txi_paths_information)
	(setup_texinfo_main): pass datadir to messages_and_encodings_setup.

	* tta/perl/Makefile.am (ModulePath.pm),
	tta/perl/Texinfo/ModulePath.pm.in ($datadir, $converter, init),
	tta/perl/load_txi_modules.pl (BEGIN), tta/perl/texi2any.pl (BEGIN),
	tta/C/main/call_perl_function.c (call_modulepath_init)
	(call_eval_load_texinfo_modules), tta/perl/Texinfo/XSLoader.pm (init),
	tta/perl/XSTexinfo/parser_document/DocumentXS.xs (init): pass datadir
	through ModulePath.pm and XSLoader.pm init to C, or pass datadir from
	C to Perl through call_modulepath_init.

	* tta/C/texi2any.c (set_subdir_directories, main): make relocatable.

	* tta/swig/texinfo.i (txi_ext_inline_setup): add and use datadir
	optional argument.

	* tta/C/main/document.c (setup_txi_paths_information): make static.

2026-02-19 Patrice Dumas  <pertusus@free.fr>

	Make perl scripts relocatable for datadir

	* tta/perl/load_txi_modules.pl ($datadir, BEGIN), tta/perl/texi2any.pl
	($datadir, BEGIN): set $datadir in BEGIN block, to the relocatable
	location if relevant.

2026-02-19 Patrice Dumas  <pertusus@free.fr>

	Make clear that substituted strings in texi2any.pl are expanded

	* tta/perl/Makefile.am (do_subst), tta/perl/load_txi_modules.pl,
	tta/perl/texi2any.pl: strings are not substituted by configure, but by
	Makefile, and therefore the variables are fully expanded.  Modify code
	to be in line, instead of having constructs that would only make sense
	if configure was used to substitute strings.  Do not substitute
	datarootdir and prefix as they are not used anywhere.  Remove eval for
	datadir and sysconfdir setting.

2026-02-19 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/call_html_perl_function.c
	(call_file_id_setting_redirection_file_names): fix incorrect code
	leftover.

2026-02-19  Gavin Smith <gavinsmith0123@gmail.com>

	Call perl_only_strndup

	* tta/C/convert/call_html_perl_function.c
	(call_file_id_setting_redirection_file_names):
	Call build_perl_info.c:perl_only_strndup as strndup is not
	defined on MinGW.  Report from Eli and fix from Patrice.

2026-02-18  Gavin Smith <gavinsmith0123@gmail.com>

	* README-hacking: tweak sample git hook not to operate
	on experimental/* branches.

2026-02-18  Gavin Smith <gavinsmith0123@gmail.com>

	* update-version.sh, README-hacking: do more in "make update-version"
	automatically.

2026-02-18  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texi2any_api.texi (Customizing Output-Related Names):
	Add missing menu entry.

2026-02-17  Gavin Smith <gavinsmith0123@gmail.com>

	pretest 7.2.92

	* configure.ac: version

2026-02-15 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/t/init_files_tests.t
	(add_lower_case_redirection_file_names): skip test as it fails on
	case-insensitive systems.

2026-02-15 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Makefile.tres, tta/perl/t/init_files_tests.t
	(prepend_number_redirection_file_names), tta/perl/Makefile.am
	(test_files),
	tta/perl/t/init/test_customize_redirection_file_names.pm: add a test
	of redirection_file_names with numbers prepended to file names.

2026-02-14 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Makefile.tres, tta/perl/t/init_files_tests.t
	(add_lower_case_redirection_file_names), tta/perl/Makefile.am
	(test_files),
	tta/perl/t/init/lowercase_file_names_and_redirections.pm: add a test
	of redirection_file_names with file names and targets lowercasing.

2026-02-14 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/converter_types.h (HTML_FILE_ID_SETTING_NAMES_LIST)
	(CONVERTER): sort HTML_FILE_ID_SETTING_NAMES_LIST in code.

2026-02-14 Patrice Dumas  <pertusus@free.fr>

	Add a customization function for node redirection files

	* doc/texi2any_api.texi (Customizing Node Redirection Files),
	tta/C/convert/call_html_perl_function.c
	(call_file_id_setting_redirection_file_names),
	tta/C/convert/convert_html.c (html_node_redirections),
	tta/C/main/converter_types.h (HTML_FILE_ID_SETTING_NAMES_LIST),
	tta/perl/Texinfo/Convert/HTML.pm
	(%customizable_file_id_setting_references)
	(_node_redirections): add the file_id_setting redirection_file_names
	customization function to have a possibility to set the list of node
	redirection files.  Based on a report from Jonas Hahnfeld.

2026-02-14  Tony Battersby <tonyb@cybernetics.com> (tiny change)

	* info/terminal.c: use modern prototypes for curses
	
	This fixes compile errors with -std=gnu23 (which is the default
	with gcc 15) on systems that do not have termcap.h.

2026-02-12  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (@documentlanguage): grammar fix.

2026-02-12  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/refcard/txirefcard.tex (@documentlanguage): remove statement
	that en_US is the default for @documentlanguage, as this is not
	strictly correct.  report from Vincent Lefevre.

2026-02-12  Gavin Smith <gavinsmith0123@gmail.com>

	Do not output empty body lang attribute
	
	* tta/perl/Texinfo/Convert/HTML.pm (_setup_output):
	Do not set BODY_ELEMENT_ATTRIBUTES to lang="" if the documentlanguage
	is undefined.

	* tta/perl/Texinfo/Convert/HTML.pm (_file_header_information):
	Return body attribute string with leading space, or as an empty
	string.  Callers updated.
	
	* tta/C/convert/html_prepare_converter.c (html_setup_output),
	* tta/C/convert/format_html.c (file_header_information):
	Make the same change.
	
	The lang="" attribute is unnecessary, and potentially causes
	the wrong fonts to be used on Firefox, according to a report
	from Vincent Lefevre <vincent@vinc17.net>.

2026-02-08  Gavin Smith <gavinsmith0123@gmail.com>

	Fix "Free to wrong pool" error

	* tta/C/convert/build_html_perl_state.c (build_html_translated_names):
	Use non_perl_strdup and non_perl_free.

	Report from Eli.

2026-02-06 Patrice Dumas  <pertusus@free.fr>

	* tta/configure.ac: remove HAVE_ICONV AM_CONDITIONAL, it is not used
	anymore.

2026-02-07  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/perl/Texinfo/Indices.pm (Texinfo::CollateStub::getSortKey):
	Call utf8::encode on output in order to avoid "Wide character"
	error on Red Hat Linux, Rocky Linux and CentOS, when Unicode::Collate
	is not installed.
	
	Report from Nelson Beebe.

2026-02-06 Patrice Dumas  <pertusus@free.fr>

	* tta/swig/perl/Makefile.am, tta/swig/python/Makefile.am: remove if
	HAVE_ICONV, a more relevant conditional is tested in a containing
	directory.

2026-02-06 Patrice Dumas  <pertusus@free.fr>

	* tta/configure.ac (use_shared_txi_libraries), tta/perl/Makefile.am
	(ModulePath.pm), tta/perl/Texinfo/ModulePath.pm.in
	($use_shared_txi_libraries), tta/perl/Texinfo/XSLoader.pm (BEGIN): fix
	typo in use_shared_txi_libraries variable name.

2026-02-06  Gavin Smith <gavinsmith0123@gmail.com>

	pretest 7.2.91

2026-02-06  Gavin Smith <gavinsmith0123@gmail.com>

	* NEWS: elaborate on raw-utf8-output

2026-02-06  Gavin Smith <gavinsmith0123@gmail.com>

	No --enable-* flags for Perl SWIG

	* tta/configure.ac: Access SWIG Perl installation setting and
	directories as shell variables, rather than --enable-* flags.

	* configure.ac: remove AC_ARG_ENABLE for SWIG Perl flags.

	* tta/swig/README: document the variables here as they do not
	appear in the output of configure --help.

2026-02-03 Patrice Dumas  <pertusus@free.fr>

	* tta/configure.ac, tta/perl/Makefile.am (ModulePath.pm),
	tta/perl/Texinfo/ModulePath.pm.in ($used_shared_txi_libraries),
	tta/perl/Texinfo/XSLoader.pm  (BEGIN): pass used_shared_txi_libraries
	instead of build_C_code to ModulePath.pm, and use it in XSLoader.pm
	to set $disable_C_libraries.

2026-02-03  Gavin Smith <gavinsmith0123@gmail.com>

	Re-jig BUILD_C_CODE condition

	* tta/configure.ac: Add conditional USE_SHARED_TXI_LIBRARIES to
	be used when build targets depend on the C auxiliary libraries.
	Require iconv to be found to set this.
	(Suggestion from Patrice to make reason clearer for use of condition.)

	Always set BUILD_C_CODE if any C code is being built.
	
	* tta/Makefile.am: Don't build in C or SWIG directories if
	USE_SHARED_TXI_LIBRARIES is false.
	
	* tta/perl/XSTexinfo/Makefile.am: use BUILD_C_CODE condition around
	building XSParagraph.la and MiscXS.la so that they are built under the
	same condition as that of gnulib upon which they depend.
	
	This mismatch led to a build failure on macOS 26, where iconv was not
	found and the other XS modules were not built.  Report from Bruno.
	
	Use USE_SHARED_TXI_LIBRARIES instead of BUILD_C_CODE for other
	*.la targets.

2026-02-01 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/XSLoader.pm (init): die if
	TEXINFO_XS=requiredifenabled, the module name is defined and the
	extension was not loaded.  Report from Gavin.

2026-02-01 Patrice Dumas  <pertusus@free.fr>

	* INSTALL, tta/README: move information related to the texi2any
	implementation in C to tta/README.

2026-02-01 Patrice Dumas  <pertusus@free.fr>

	* tta/configure.ac, tta/perl/Makefile.am (ModulePath.pm),
	tta/perl/Texinfo/ModulePath.pm.in ($build_C_code): pass build_C_code
	instead of enable_txi_libraries.  Remove enable_txi_libraries.

	* tta/perl/Texinfo/XSLoader.pm (BEGIN, $disable_C_libraries): set
	$disable_C_libraries based on build_C_code.

	* tta/perl/Texinfo/XSLoader.pm (init): handle especially the case of
	defined($additional_libraries) and $disable_C_libraries.
	Add FIXME as the TEXINFO_XS=requiredifenabled case is incorrect for
	modules without fallback.

2026-02-01 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/XSTexinfo/Makefile.am: use BUILD_C_CODE instead of
	HAVE_ICONV, it should be clearer and more robust.

2026-02-01  Gavin Smith <gavinsmith0123@gmail.com>

	* configure.ac: bump version to 7.2.91.

2026-02-01 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/XSLoader.pm (init): do not check $disable_XS in
	TEXINFO_XS requiredifenabled case, it cannot happen anymore.

2026-02-01 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/XSLoader.pm (init): with
	TEXINFO_XS=requiredifenabled, if XS is disabled, reset
	TEXINFO_XS=omit.  Based on Gavin patch, used for requiredifenabled
	and without ever setting $TEXINFO_XS to required.

2026-02-01 Patrice Dumas  <pertusus@free.fr>

	* configure.ac, tta/configure.ac: move code around to be more
	similar.  Use the same descriptions in AS_HELP_STRING.

2026-02-01 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Example/IXIN.pm,
	tta/perl/Texinfo/Example/IXINSXML.pm, tta/perl/Makefile.am
	(dist_convertmodules_DATA): move IXIN.pm and IXINSXML.pm to
	Texinfo/Example.

2026-02-01  Gavin Smith <gavinsmith0123@gmail.com>

	gnulib update
	
	* (top level), tta: run gnulib-tool --add-import.

2026-01-31  Gavin Smith <gavinsmith0123@gmail.com>

	* configure.ac: move AC_ARG_WITH and AC_ARG_ENABLE declarations
	for SWIG nearer the end of the file so they appear later in the
	output of "./configure --help".

2026-01-31 Patrice Dumas  <pertusus@free.fr>

	* doc/texi2any_api.texi (Specific Functions for Specific Elements),
	tta/C/convert/converter.c, tta/C/main/convert_utils.c
	(comma_index_subentries_tree_internal, comma_index_subentries_tree)
	(free_comma_index_subentries_tree),
	tta/perl/Texinfo/Convert/Converter.pm,
	tta/perl/Texinfo/Convert/Utils.pm (_comma_index_subentries_tree)
	(comma_index_subentries_tree): move comma_index_subentries_tree to
	Utils.pm and to main/convert_utils.c.

2026-01-31 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Report.pm (format_line_message): do not do anything
	special if 'file_name' is undef, it should not happen.

2026-01-31 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/DebugTree.pm, tta/perl/Texinfo/Indices.pm,
	tta/perl/Texinfo/Report.pm: change formatting of function beginning,
	use exists or defined if the value is not needed.

	* tta/perl/Texinfo/Common.pm, tta/perl/Texinfo/Config.pm: change in
	spacing.

	* tta/perl/Texinfo/Common.pm: use exists or defined if the value is
	not needed.

	* tta/perl/Texinfo/XSLoader.pm: change in spacing, minor change in
	code, add a prototype.

2026-01-30  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/info-stnd.texi (Hooks): Document that the hook program is
	manual-not-found.cmd on MS-Windows.

2026-01-29 Patrice Dumas  <pertusus@free.fr>

	* tta/Makefile.am (SUBDIRS): recurse in swig only if BUILD_C_CODE is
	true.

2026-01-29  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/perl/Texinfo/Tests.pm (is_diff): Reverse arguments
	to Text::Diff::diff so that output diff shows change made
	from reference result to obtained result.

2026-01-29 Patrice Dumas  <pertusus@free.fr>

	* tta/configure.ac: build C code only if iconv is present, since all
	the libraries require iconv.

2026-01-29  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/configure.ac: reorder file to put checks that aren't
	specific to C code earlier in the file.

2026-01-29  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/configure.ac: place message inside conditional

2026-01-29  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/configure.ac: output a message to mark the end of
	configuring under tta/perl/CheckXS.

2026-01-29 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/call_perl_function.c
	(call_translations_translate_string),
	tta/C/main/translations.c (translate_string, cache_translate_string):
	pass and use encoded lang in translate_string.  Also pass encoded lang
	to call_translations_translate_string.

2026-01-29 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/build_html_perl_state.c
	(switch_perl_lang_translations): set encoded lang to an empty string
	if undef, to match with what is done for lang.

2026-01-29  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/C/Makefile.am: Remove all uses of HAVE_ICONV conditional.
	From Patrice.

2026-01-29  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/configure.ac (BUILD_C_CODE): Specify with AM_CONDITIONAL.
	* tta/Makefile.am: Use it to include tta/gnulib and tta/C in
	subdirectories to be built.

2026-01-29 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/PlainTexinfo.pm,
	tta/perl/Texinfo/Convert/TexinfoMarkup.pm, tta/perl/Texinfo/Tests.pm:
	change the formatting of the beginning of functions.

2026-01-28 Patrice Dumas  <pertusus@free.fr>

	Separate XS module for Texinfo::Convert::Texinfo

	* tta/perl/Texinfo/Convert/TexinfoNonXS.pm (convert_to_texinfo),
	tta/perl/Texinfo/Convert/TexinfoXS.pm (convert_to_texinfo),
	tta/perl/Texinfo/Convert/Texinfo.pm (BEGIN, convert_to_texinfoNonXS),
	tta/perl/XSTexinfo/convert/ConvertToTexinfoXS.xs
	(plain_texinfo_convert_tree), tta/perl/XSTexinfo/convert/ConvertXS.xs,
	tta/perl/XSTexinfo/Makefile.am (xs_LTLIBRARIES, CLEANFILES)
	(EXTRA_DIST, ConvertToTexinfoXS_la_*): add TexinfoNonXS.pm and
	TexinfoXS.pm with the convert_to_texinfo implementation without and
	with XS.  Move the plain_texinfo_convert_tree XS interface function to
	a new XS file used only for the Texinfo::Convert::Texinfo module,
	ConvertToTexinfoXS.xs.  Add a BEGIN block in Texinfo.pm to load the
	Perl modules and XS module and remove the function override.  Rename
	_convert_to_texinfo as convert_to_texinfoNonXS and leave it in the
	main Texinfo.pm module as it may be called by both TexinfoNonXS.pm and
	TexinfoXS.pm.

	* tta/perl/Texinfo/Convert/PlainTexinfo.pm (convert_tree): adapt for
	change in Texinfo::Convert::Texinfo.

2026-01-28  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/configure.ac:
	Only configure in perl/CheckXS subdirectory
	with --enable-perl-xs=check (the default).

2026-01-28 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/Texinfo.pm: change formatting of function
	beginning.  Use defined or exists when the value is not used.

2026-01-28 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Document.pm (import),
	tta/perl/Texinfo/Structuring.pm (%XS_overrides)
	(print_document_listoffloats),
	tta/perl/XSTexinfo/parser_document/DocumentXS.xs,
	tta/perl/XSTexinfo/parser_document/StructuringTransfoXS.xs
	(print_document_listoffloats): move print_document_listoffloats to
	Structuring.pm, where it belongs more logically, depending on
	structuring code.

2026-01-28 Patrice Dumas  <pertusus@free.fr>

	requiredifenabled takes only into account runtime information

2026-01-28 Patrice Dumas  <pertusus@free.fr>

	* tta/configure.ac (enable_txi_libraries), tta/perl/Makefile.am
	(ModulePath.pm), tta/perl/Texinfo/ModulePath.pm.in: pass the
	information on Texinfo libraries being built.

2026-01-27 Patrice Dumas  <pertusus@free.fr>

	* INSTALL, tta/perl/Texinfo/XSLoader.pm (init, override): add
	TEXINFO_XS=requiredifenabled possibility, to try xs, abort if enabled
	in configure and by TEXINFO_XS_* and not loadable.

2026-01-27 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/convert_html.c: minor change in comments and message.

2026-01-26 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/get_perl_info.c
	(get_language_document_hv_sorted_indices),
	tta/perl/XSTexinfo/convert/ConvertXS.xs
	(get_converter_indices_sorted_by_index): use hv_store_ent and
	hv_fetch_ent to use SV for language in case it contains non-ASCII
	characters.

2026-01-26  Gavin Smith <gavinsmith0123@gmail.com>

	* info/makedoc.c (process_one_file):
	prevent a warning with gcc -Wstringop-overflow.

2026-01-26 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/utils.c (encode_with_iconv, encode_string): replace the
	silent integer argument by a status argument, such that, if set, the
	function is silent and the information that there was an error in
	encoding is returned.

	* tta/C/convert/get_converter_perl_info.c
	(copy_sv_options_for_convert_text), tta/C/main/build_perl_info.c
	(build_convert_text_options), tta/C/main/convert_to_text.c
	(destroy_text_options, copy_options_for_convert_text),
	tta/C/main/convert_to_text.h (TEXT_OPTIONS),
	tta/perl/Texinfo/Convert/Text.pm (copy_options_for_convert_text): add
	COMMAND_LINE_ENCODING to text options.

	* tta/perl/Texinfo/Convert/Text.pm (_convert),
	tta/perl/Texinfo/Convert/Utils.pm (switch_lang_translations)
	(definition_category_tree), tta/perl/Texinfo/Transformations.pm
	(complete_tree_nodes_menus_in_document, regenerate_master_menu),
	tta/perl/Texinfo/Translations.pm (new_lang_translation): add
	new_lang_translation in Perl too, and use it to initialize lang
	translations arrays.  In addition to hiding to some extent the
	implementation details, it allows to mark in the code where the
	lang translations are initialized.

	* tta/C/convert/build_html_perl_state.c
	(switch_perl_lang_translations, build_html_translated_names),
	tta/C/main/convert_utils.c (definition_category_tree),
	tta/C/main/translations.c (new_lang_translation, get_lang_translation),
	tta/C/main/tree_types.h (LANG_TRANSLATION), tta/C/parsetexi/indices.c
	(complete_indices), tta/C/tree_elements/get_perl_tree_elements.c
	(get_lang_translations_sv), tta/perl/Texinfo/Convert/Utils.pm
	(switch_lang_translations, definition_category_tree),
	tta/perl/Texinfo/Translations.pm (translate_string)
	(cache_translate_string, complete_indices): pass COMMAND_LINE_ENCODING
	trought to new_lang_translation.  In new_lang_translation encode lang
	and pass it in lang translations objects.  Use the encoded lang in
	translate_string to set environment varibles, as should be.

	* tta/tests/Makefile.onetst, tta/tests/other/Makefile.am (EXTRA_DIST),
	tta/tests/other/list-of-tests
	(accented_lang_index_collation_documentlanguage_collation),
	tta/tests/other/accented_lang_index_collation.texi: new test of
	DOCUMENTLANGUAGE_COLLATION set with @documentlanguage with non-ascii
	non-latin1 characters.

2026-01-26  Gavin Smith <gavinsmith0123@gmail.com>

	* INSTALL: list having a non-default locale installed as a
	dependency of translations by texi2any.

2026-01-26  Gavin Smith <gavinsmith0123@gmail.com>

	Remove gnulib glob module and dependencies.
	
	Reverts change on 2026-01-12.

2026-01-26  Gavin Smith <gavinsmith0123@gmail.com>

	Avoid glob function

	* tta/C/convert/html_prepare_converter.c (load_htmlxref_files):
	Rewrite not to use glob as this doesn't exist on mingw and would
	require adding gnulib modules to use portably.

2026-01-25  Gavin Smith <gavinsmith0123@gmail.com>

	Force translations to be enabled on OpenBSD.

	* tta/perl/Texinfo/Translations.pm [openbsd]:
	Override POSIX::setlocale before "use Locale::Messages;" to a dummy
	function that returns a value other than "C".

2026-01-25  Gavin Smith <gavinsmith0123@gmail.com>

	* info/display.c: add comment

2026-01-25  Gavin Smith <gavinsmith0123@gmail.com>

	* info/pcterm.c (rpl_nl_langinfo): Set "raw-utf8-output" variable to
	'On' by default if console codepage is 65001.
	* doc/info-stnd.texi (Variables) <raw-utf8-output>: Document default
	setting.

	Suggestion from Eli.

2026-01-25  Bruno Haible <bruno@clisp.org>

	* install-info/install-info.c (split_entry): Change type of ptr and endptr
	to conform to ISO C 23.

2026-01-23 Patrice Dumas  <pertusus@free.fr>

	Update POD for tree elements

2026-01-23 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/texi2any.pl: exchange the order in a condition.

	* INSTALL: edit to explain that PERL_EXT_* variables values are used
	only if XS modules are used,

	Update POD documentation.

2026-01-22  Gavin Smith <gavinsmith0123@gmail.com>

	* info/filesys.c (filesys_read_info_file):
	Add check that off_t variable is non-negative before using
	value in argument to 'read'.  This is to avoid a gcc warning.

2026-01-22  Gavin Smith <gavinsmith0123@gmail.com>

	* info/Makefile.am: distribute manual-not-found.cmd and
	gnu-manuals.awk even if HOST_IS_WINDOWS is false.

2026-01-22  Gavin Smith <gavinsmith0123@gmail.com>

	* info/info-hooks-default/manual-not-found.in:
	add note to keep inline awk program synched with separate file.

2026-01-22  Eli Zaretskii <eliz@gnu.org>

	* info/info-hooks-default/manual-not-found.cmd: new
	* info/info-hooks-default/gnu-manuals.awk: new

2026-01-22  Gavin Smith <gavinsmith0123@gmail.com>

	info: Add raw-utf8-output.

	* info/variables.c (VARIABLE_ALIST):
	Add "raw-utf8-output" user variable.
	* info/display.c (raw_utf8_output_p): new.

	(printed_representation): If raw_utf8_output_p is set, do not
	use locale functions to process UTF-8 output.

	* doc/info-stnd.texi (Variables): Add raw-utf8-output.
	* NEWS: announce

	Report from Eli for codepage 65001 on MSVCRT runtime on MS-Windows.

2026-01-22 Patrice Dumas  <pertusus@free.fr>

	Search for C libraries directly in the directory they are in

	* tta/perl/Texinfo/ModulePath.pm.in ($libraries_dir): set
	$libraries_dir to the directory C libraries are in, instead of putting
	the directory in front of @INC.

	* tta/perl/Texinfo/XSLoader.pm (_find_file_in_inc): rename _find_file
	as _find_file_in_inc.

	* tta/perl/Texinfo/XSLoader.pm (load_libtool_library, init): move call
	of _find_file_in_inc to init.  Find directly C libraries in
	$Texinfo::ModulePath::libraries_dir.

2026-01-21 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/ManipulateTree.pm: remove menu directions, they do
	not exist anywhere.

	* tta/perl/Texinfo/ManipulateTree.pm (_copy_tree): copy
	def_index_element and def_index_ref_element even if other_trees is not
	set, as in C.

	* tta/perl/Texinfo/ManipulateTree.pm: improve/update comments.

2026-01-21 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/XSLoader.pm (XS_parser_enabled): check that
	TEXINFO_XS_PARSER is not 0 instead of comparing to 1.  It makes more
	sense since the default is true, it matches the documentation and
	the other variables.

	* tta/perl/t/z_misc/test_fill_gaps_in_sectioning.t: use
	Texinfo::XSLoader::XS_parser_enabled.

	* tta/perl/t/z_misc/test_tree_copy.t: remove unused code.

2026-01-21  Eli Zaretskii <eliz@gnu.org>

	Minor MinGW-related cleanups
	
	* info/pcterm.c (rpl_nl_langinfo): Treat CP_UTF8 and CP_UTF7
	return values from GetConsoleOutputCP specially.
	(wcwidth) [not defined HAVE_WCWIDTH]: remove definition.
	(pc_put_text, pc_write_chars): declare argument as const char *.

	* info/scan.c [__MINGW32__]: Declare rpl_nl_langinfo here.
	* info/util.c [__MINGW32__]: Remove declaration of rpl_nl_langinfo.
	Allow gnulib wcwidth to be used.

2026-01-21  Eli Zaretskii  <eliz@gnu.org>

	* .gitattributes: Checkout all *.cmd files with CRLF EOLs.

	* info/t/config/texinfo/info-hooks/manual-not-found.cmd: Use CRLF
	end-of-line format.

2026-01-20 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/XSLoader.pm ($loaded_additional_libraries): make
	the variable local to the file.

	* tta/perl/Texinfo/XSLoader.pm (init): use defined when the value is
	not needed.
	Try to (pre) load a library only one, do not retry if it failed.

	* tta/perl/Texinfo/Config.pm: stylistic change.

2026-01-20 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/ConfigXS.pm (BEGIN), tta/perl/Texinfo/DocumentXS.pm
	(BEGIN): load XS modules only if there will be overriden functions
	later on.

2026-01-20 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/call_perl_function.c (call_eval_load_texinfo_modules):
	fix name of Perl variable read from C.

2026-01-20 Patrice Dumas  <pertusus@free.fr>

	* README-hacking: note on manual testing of .la installed files
	removing.

2026-01-20  Eli Zaretskii <eliz@gnu.org>

	* info/run-external.c (get_output_from_program) [!PIPE_USE_FORK]:
	Use 'filename' argument in popen call, rather than argument 0.
	Add check for null argument.
	[!PIPE_USE_FORK && __MINGW32__]: Change / to \ in command name
	before calling popen.

	* info/t/config/texinfo/info-hooks/manual-not-found.cmd:
	Add dummy file.

2026-01-20  Gavin Smith <gavinsmith0123@gmail.com>

	info: read compressed input via fork/execlp.

	* info/filesys.c (filesys_read_compressed, filesys_read_from_stream):
	Split out filesys_read_from_stream.  Close stream with fclose rather
	than pclose.

	(COMPRESSION_ALIST, compress_suffixes): Store command options
	as separate strings, rather than in a single space separated
	string.
	(filesys_decompressor_for_file): Return type changed.

	(filesys_read_compressed): Obtain command line by concatenating
	strings in compress_suffixes with spaces.
	[PIPE_USE_FORK]: Use fork and execlp to run decompressor program,
	rather than popen.  This avoids any need to sanitise the argument
	to popen.
	[!PIPE_USE_FORK]: Run popen as before.

2026-01-20 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/XSLoader.pm (_find_file): rename
	added_converter_libdir as added_xsdir.  Fix the xsdir value set by
	postpending XS_extension.
	Use defined to test if the function arguments are unset.
	Minor stylistic changes.

2026-01-20 Patrice Dumas  <pertusus@free.fr>

	C libraries and XS modules installed in subdirs of converter libdir

	* tta/C/Makefile.am (librarydir, library_LTLIBRARIES),
	tta/perl/XSTexinfo/Makefile.am (xsdir),
	tta/perl/Texinfo/ModulePath.pm.in (init): add librarydir in
	C/Makefile.am as the lib subdir of libdir/texi2any and use it for
	libraries installation, define xsdir in XSTexinfo/Makefile.am as the
	XS_extension subdir of libdir/texi2any.  Update paths in
	Texinfo/ModulePath.pm.in.
	In addition to separating C libraries from XS modules, this also
	allows to keep a bin directory added by libtool at the same level
	within libdir/texi2any.

2026-01-20 Patrice Dumas  <pertusus@free.fr>

	* tta/swig/perl/Makefile.am (EXTRA_DIST),
	tta/swig/perl/Texinfo_SWIG_Interface_Tests.pm, tta/swig/perl/t/*.t:
	rename tta/swig/perl/_Texinfo_Tests.pm as
	Texinfo_SWIG_Interface_Tests.pm.

2026-01-20 Patrice Dumas  <pertusus@free.fr>

	* tta/swig/perl/Makefile.am (nodist_perlarch_DATA): install Texinfo.pm
	in perlarch, as it seems to be the usual convention for Perl modules
	loading XS modules.

	* tta/swig/perl/_Texinfo_Tests.pm: change formatting of functions
	beginning.

	* tta/swig/perl/parse_refold.pl (BEGIN): sync better with
	_Texinfo_Tests.pm code.  Try to load MakeMaker generated files even if
	t2a_builddir is not set.

	Changes in comments.

2026-01-20 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/document.h (INSTALLED_PATHS): rename converterdatadir as
	converter_datadir.  Update users.

	* tta/C/convert/texinfo.c (txi_setup_main_load_interpreter),
	tta/C/main/call_perl_function.c (call_modulepath_init)
	(call_eval_load_texinfo_modules), tta/C/main/document.c
	(setup_txi_paths_information, setup_texinfo_main), tta/C/texi2any.c
	(main), tta/perl/Texinfo/ModulePath.pm.in ($converter_datadir)
	($converter_libdir, init), tta/perl/Texinfo/XSLoader.pm
	(load_libtool_library), tta/perl/load_txi_modules.pl (BEGIN),
	tta/perl/texi2any.pl (BEGIN): rename converterdatadir as
	converter_datadir, xsdir, converterxsdir and converterlibdir as
	converter_libdir and lib_dir as perl_modules_dir.

2026-01-20 Patrice Dumas  <pertusus@free.fr>

	* doc/texi2any_api.texi (Adding Text And Global Output Units
	Directions, Sectioning Commands Elements and Document Structure)
	(Node Elements and Document Structure)
	(Setting Global Directions From Document Information),
	tta/perl/init/documentation_examples.pm: improve documentation of
	Global output units addition and association to node name.

2026-01-19  Gavin Smith <gavinsmith0123@gmail.com>

	* info/configfiles.c (run_info_hook) [__MINGW32__]:
	Append .cmd extension to hook file name.  From Eli.

2026-01-18 Patrice Dumas  <pertusus@free.fr>

	Replace backslashes by forward slashes in paths canonicalization

	* tta/C/main/utils.c (file_separator_canonpath): rename canonpath as
	file_separator_canonpath and modify to put only forward slash in
	output file name.  Update callers.

	* tta/perl/Texinfo/Common.pm (file_separator_canonpath),
	tta/perl/Texinfo/Convert/Converter.pm (determine_files_and_directory),
	tta/perl/Texinfo/Convert/Text.pm (output), tta/perl/texi2any.pl: add
	file_separator_canonpath as a wrapper around File::Spec->canonpath
	that replace backslashes by forward slashes on Windows.  Report and
	analysis from Eli Zaretskii.

2026-01-18 Patrice Dumas  <pertusus@free.fr>

	* tta/C/parsetexi/input.c (parser_encode_file_name): rename
	encode_file_name as parser_encode_file_name for consistency with Perl
	functions names, as it corresponds to _encode_file_name in Perl
	Parser.  Update callers.

	Add ALTIMP comments.  Move some code around.

2026-01-18 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/translations.c (switch_messages_locale): add a message if
	no locale other than C/POSIX is found.  Report from Bruno Haible.

2026-01-18 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Translations.pm (_switch_messages_locale): add a
	message if no locale other than C/POSIX is found.  Report from Bruno
	Haible.

2026-01-18 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Translations.pm (_switch_messages_locale): turn
	$working_locale to a file scoped variable.

2026-01-18 Patrice Dumas  <pertusus@free.fr>

	* tta/C/Makefile.am: add comments and move code to clarify why we add
	-I$(srcdir) to AM_CPPFLAGS.

2026-01-18 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/CheckXS/TestXS.pm (BEGIN): unset
	$Texinfo::XSLoader::disable_XS such as not to depend on value
	previously set by configure+make.

2026-01-18 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/XSLoader.pm (_message): rename _fatal as _message.

2026-01-18 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/Plaintext.pm (import),
	tta/perl/Texinfo/Convert/Unicode.pm (import),
	tta/perl/Texinfo/ParserNonXS.pm (import), tta/perl/Texinfo/XSLoader.pm
	(XS_parser_enabled, override): check if disable_XS is set in XSLoader
	override, and if so do not attempt to override any function.

2026-01-18  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/configure.ac (AC_CONFIG_HEADERS): Put config.h in tta,
	not tta/C.  In the former location, it would not be updated
	automatically by autoheader by Makefile rules, due to being
	in a subdirectory.

2026-01-17 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/XSLoader.pm (BEGIN): set disable_XS if
	$Texinfo::ModulePath::enable_xs is 'no'.  Gavin idea.

	* tta/perl/texi2any.pl, tta/perl/t/test_utils.pl: remove BEGIN blocks
	that set disable_XS, as it is done in XSLoader now.

2026-01-17 Patrice Dumas  <pertusus@free.fr>

	* NEWS, configure.ac (using-c-texi2any), doc/texinfo.texi (Generic
	Translator @command{texi2any}), tta/configure.ac (c-texi2any),
	INSTALL: rename --enable-c-texi2any as --enable-using-c-texi2any and
	change the help string.  Report and idea from Eli Zaretskii.

2026-01-17 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Makefile.am (Texinfo/ModulePath.pm),
	tta/perl/Texinfo/ModulePath.pm.in ($enable_xs): set enable_xs to the
	value set by configure.

	* tta/perl/t/test_utils.pl (BEGIN): add a BEGIN block to disable XS if
	$Texinfo::ModulePath::enable_xs is 'no'.

	* tta/perl/texi2any.pl (BEGIN): if @enable_xs@ was not substituted,
	use the $Texinfo::ModulePath::enable_xs value to determine if XS
	should be disabled.

2026-01-17 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/Plaintext.pm (import),
	tta/perl/Texinfo/Convert/Unicode.pm (import),
	tta/perl/Texinfo/ParserNonXS.pm (import): do not load MiscXS functions
	if $Texinfo::XSLoader::disable_XS is true.

	* tta/perl/Texinfo/Translations.pm (import),
	tta/perl/Texinfo/XSLoader.pm (XS_parser_enabled): have
	XS_parser_enabled return false if !$disable_XS.
	Load XS in Translations.pm only if XS_parser_enabled returns true.

2026-01-17 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Config.pm, tta/perl/Texinfo/Document.pm,
	tta/perl/Texinfo/ManipulateTree.pm,
	tta/perl/Texinfo/Transformations.pm: use my for XS_overrides hashes.

2026-01-17 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/texi2any.pl: handle especially unicode/UTF-8 codepage on
	Windows.  Report and check from Eli Zaretskii.

2026-01-16 Patrice Dumas  <pertusus@free.fr>

	Distinguish locale encoding and output messages encoding

	* tta/C/convert/texinfo.c (txi_set_base_default_options),
	tta/C/texi2any.c (main), tta/perl/texi2any.pl: distinguish locale
	encoding from console output encoding.  Set MESSAGE_ENCODING to
	console output encoding.
	On Windows, set console output encoding with GetConsoleOutputCP().
	Idea from Eli Zaretskii.

	* tta/C/texi2any.c (main): handle especially UTF-8 codepage on
	Windows.  Idea and code from Eli Zaretskii.

2026-01-16 Patrice Dumas  <pertusus@free.fr>

	Use COMMAND_LINE_ENCODING to encode executed command-lines

	* doc/texi2any_api.texi (Encoding File Path Strings),
	doc/texinfo.texi (Global Customization Variables),
	tta/perl/Texinfo/Convert/LaTeX.pm (convert_math_to_images),
	tta/perl/ext/highlight_syntax.pm (highlight_process),
	tta/perl/ext/latex2html.pm (l2h_to_html), tta/perl/ext/tex4ht.pm
	(tex4ht_process_format): use COMMAND_LINE_ENCODING encoding to
	to encode command-line before executing a command.  This is done to
	simplify setting the right encoding on Windows, but it is also more
	consistent as the same variable is used to decode from the
	command-line.

2026-01-16 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/convert_html.c,
	tta/C/convert/html_prepare_converter.c, tta/C/main/tree_types.h,
	tta/C/parsetexi/parser.c, tta/m4/txi_perl_conf.m4,
	tta/perl/Texinfo/Convert/HTML.pm, tta/perl/texi2any.pl: improve
	comments, remove TODO and replace with notes, add TODO.

	* tta/perl/Texinfo/OutputUnits.pm: change in spacing.

2026-01-16 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/t/test_utils.pl (test): rename $errors as $dir_errors.
	Use defined in conditions when the value is not needed.

	* tta/perl/t/test_utils.pl (test), tta/C/main/output_unit.c
	(print_output_units_details): move a TODO where it is more relevant.
	Change in comments.

2026-01-15 Patrice Dumas  <pertusus@free.fr>

	* Pod-Simple-Texinfo/t/Pod-Simple-Texinfo.t (protected - external pod
	as url): add comment to explain that the test fails with old
	Pod::Simple::XHTML (before 2011 or 2012).  Report from Nelson Beebe.

2026-01-15 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/xs_utils.c (non_perl_realloc): add.

	* tta/C/main/build_perl_info.c (output_unit_to_perl_hash),
	tta/C/main/get_perl_info.c (html_get_direction_icons_sv)
	(find_index_entry_subentry),
	tta/perl/XSTexinfo/convert/get_html_perl_info.c
	(html_converter_get_customization_sv): use non_perl_* for data that is
	not allocated or that is freed in a file that does not include
	Perl headers.

	* tta/C/main/xs_utils.c: remove non_perl_xasprintf, xasprintf is
	already defined in a file that does not include Perl headers.

2026-01-15 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/translations.c (switch_messages_locale): do not try to
	setenv LANG if setenv LC_ALL failed, as the only possibility for
	failure is being out of memory.  Report from Bruno Haible.

2026-01-15 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/api_to_perl.c (show_sv_hv, get_sv_hv),
	tta/C/main/get_perl_info.c (find_index_entry_subentry): add missing
	dTHX.  Report and code from Eli Zaretskii.

2026-01-15 Patrice Dumas  <pertusus@free.fr>

	* tta/C/texi2any.c: define WIN32_LEAN_AND_MEAN when including Windows
	headers to have a more minimal set of includes and avoid clashing
	symbol names.  Code from Eli Zaretskii.

2026-01-15 Patrice Dumas  <pertusus@free.fr>

	* tta/configure.ac (PERL_EXTUTILS_EMBED_*): remove error messages on
	stderr and substitute backslashes by forward slashes for mingw where
	those file separators may be emited and then cause Bash to produce
	nonsensical file names.  Report and code by Eli Zaretskii.
	The modified code is in comments because we do not need those
	variables, but it is a good thing to keep the possibility to use
	ExtUtils::Embed output.

2026-01-14 Patrice Dumas  <pertusus@free.fr>

	* tta/configure.ac: unset perl_conf* variables if XS is disabled.
	Set perl_conf_LIB_LDFLAGS to platform_LDFLAGS as platforms needing
	-no-undefined probably still need this flag.  Based on a report by
	Bruno.

2026-01-13 Patrice Dumas  <pertusus@free.fr>

	* tta/m4/txi_perl_conf.m4 (perl_conf_LIBS): remove PERL_CONF_perllibs,
	it could add wrong flags on some platforms, and was not needed before.
	Report from Eli Zaretskii.

2026-01-13 Patrice Dumas  <pertusus@free.fr>

	* tta/m4/txi_perl_conf.m4 (perl_conf_LDFLAGS): add PERL_CONF_ccdlflags
	by making perl_conf_LDFLAGS a copy of perl_conf_LIB_LDFLAGS.

	* tta/C/Makefile.am (libperlembed_libtexinfo_main_la_LIBADD)
	(libtexinfo_main_la_LIBADD, ctexi2any_LDADD), tta/configure.ac,
	tta/m4/txi_embedded_perl.m4, tta/swig/python/Makefile.am: remove
	unused PERL_EXTUTILS_EMBED_ccopts.  Replace PERL_EXTUTILS_EMBED_ldopts
	by perl_conf_LIBS.

2026-01-12 Patrice Dumas  <pertusus@free.fr>

	* tta: add glob module from gnulib, missing on mingw.  Report from
	Bruno.
	Run gnulib-tool --add-import glob.

2026-01-11 Patrice Dumas  <pertusus@free.fr>

	* tta/C/api_for_swig/*.c, tta/C/Makefile.am
	(C_libtexinfo_main_sources), tta/swig/perl/Makefile.am,
	tta/swig/python/Makefile.am: move tta/C/swig to tta/C/api_for_swig.
	Gavin idea.

2026-01-11 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/texi2any.pl: comment out use Devel::Peek, it is only used
	in commented out debugging codes.

	* configure.ac (perl_version_requirement), tta/configure.ac
	(refcount_checks): do not test for Devel::Peek presence, now that it
	is not used anymore.

2026-01-11 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/ManipulateTree.pm (%XS_overrides, SvREFCNT),
	tta/perl/XSTexinfo/parser_document/StructuringTransfoXS.xs (SvREFCNT):
	implement SvREFCNT XS interface to get the SvREFCNT.  Add a second
	argument to return this value if there is no XS.

	* tta/perl/Texinfo/Convert/Converter.pm
	(perl_converter_remove_output_units),
	tta/perl/Texinfo/ManipulateTree.pm (_print_tree_elements_ref)
	(_element_remove_references): call ManipulateTree.pm SvREFCNT.

	* tta/perl/Texinfo/OutputUnits.pm (release_output_units_list): do not
	show the SvREFCNT, it is not that useful and adds a dependency.

2026-01-11 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/t/z_misc/same_converter_init.t ($default_test_level):
	set $default_test_level based on Texinfo::ModulePath, which is in turn
	based on configure DEFAULT_TEST_LEVEL and use it for TEST value.
	Report from Bruno.

2026-01-11  Gavin Smith <gavinsmith0123@gmail.com>

	info: Remove OSC sequences from manpages

	* info/man.c (ecma_48_osc_sequence): New function.
	(clean_manpage): Call it to remove OSC sequences (output
	by groff to show the location of hyperlinks in manpages).
	
	Report from G. Branden Robinson.

2026-01-11  Gavin Smith <gavinsmith0123@gmail.com>

	* info/util.c (ansi_escape, ansi_sgr_escape): Rename.

2026-01-11  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/Makefile.am (wwwdoc-build): Reference (as-yet non-existent)
	CSS file under the Texinfo area on www.gnu.org, rather than CSS
	Gnulib directly.  This means we will be easily able to fix any
	CSS problems without relying on Gnulib and/or GNU webmasters to
	make changes, and without regenerating and re-uploading entire
	HTML manuals.

2026-01-11  Gavin Smith <gavinsmith0123@gmail.com>

	* README-hacking: add note to "git push" before doing release.

2026-01-10 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/convert_utils.c (clear_tree_added_elements): remove
	unused CONVERTER argument.  Update callers.

2026-01-10 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/converter.c, tta/C/main/convert_utils.c
	(clear_tree_added_elements, free_tree_added_elements)
	(destroy_tree_added_elements): move to convert_utils.c.

2026-01-10 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/Unicode.pm (unicode_text),
	tta/perl/XSTexinfo/MiscXS.xs (xs_unicode_text): add prototype.

	* tta/C/main/node_name_normalization.c,
	tta/perl/Texinfo/Convert/NodeNameNormalization.pm: change variable
	names from root to element.

	* tta/perl/Texinfo/Convert/NodeNameNormalization.pm,
	tta/perl/Texinfo/Convert/Unicode.pm: reformat functions beginning.
	Use defined or exists in conditions when not interested in the value.

2026-01-10 Patrice Dumas  <pertusus@free.fr>

	Changes in comments, remove/downgrade FIXME to TODO

2026-01-10 Patrice Dumas  <pertusus@free.fr>

	* tta/maintain/generate_code_commands_values.pl: move functions
	code around.  Add a comment expliciting that some code need to be
	synced with tta/perl/Texinfo/Convert/Unicode.pm code.  Change names
	for more readable code.  Use defined or exists in conditions when not
	interested in the value.

2026-01-10 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Document.pm (set_labels_identifiers_target): do not
	reset identifiers_target, it should have been initialized at document
	creation.

	* tta/perl/Texinfo/Document.pm: reformat functions beginning.  Use
	defined or exists in conditions when not interested in the value.
	Change some variable names.

2026-01-10 Patrice Dumas  <pertusus@free.fr>

	* configure.ac, tta/configure.ac: move comments to tta/configure.ac
	where the code is.

	* tta/C/main/manipulate_tree.c: add static to local functions.

	* tta/C/main/floats.c, tta/C/main/manipulate_tree.c,
	tta/C/main/tree_types.h, tta/perl/Texinfo/ManipulateTree.pm: update
	comments and add comments.

	* tta/TODO: update

2026-01-10  Gavin Smith <gavinsmith0123@gmail.com>

	pretest 7.2.90

2026-01-10  Gavin Smith <gavinsmith0123@gmail.com>

	* README-hacking: reorder and edit headings slightly.  remove
	expired advice about release/7.1 branch.

2026-01-10  Gavin Smith <gavinsmith0123@gmail.com>

	* configure.ac (AM_INIT_AUTOMAKE): Add 'dist-xz' option.

2026-01-10  Gavin Smith <gavinsmith0123@gmail.com>

	* util/htmlxref.d/Texinfo_nonGNU.cnf,
	* util/htmlxref.d/Texinfo_GNU.cnf: update timestamps.

2026-01-10  Gavin Smith <gavinsmith0123@gmail.com>

	* grand-replace.sh: do not touch util/htmlxref.d/*.cnf
	files.

2026-01-10  Gavin Smith <gavinsmith0123@gmail.com>

	* util/htmlxref.cnf: track file in git only as a source
	for the stub file on ftp.gnu.org.

2026-01-09  Gavin Smith <gavinsmith0123@gmail.com>

	* README-hacking, tta/perl/t/README: update file location

2026-01-09  Gavin Smith <gavinsmith0123@gmail.com>

	* js/info.js (init_iframe) <on_load>:
	Do not add "in-iframe" class to <body> element as this is
	no longer used for anything.

2026-02-09 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/Converter.pm
	(converter_node_relations_of_node)
	(converter_section_relations_of_section)
	(converter_heading_relations_of_heading): add for user-defined
	HTML customization code, to get the relations information associated
	to tree elements, hiding the implementation details.

	* doc/texi2any_api.texi (Tree Elements and Document Structure)
	(Sectioning Commands Elements and Document Structure)
	(Node Elements and Document Structure)
	(Heading Elements and Document Structure): add to document the
	relations.

	* tta/perl/init/book.pm (book_in_contents_button, book_print_up_toc),
	tta/perl/t/init/index_direction_from_index_name.pm: use the functions
	to get the relations information in init files.

	* doc/texi2any_api.texi (Converter General Information): add
	nodes_list.

	* tta/TODO: update.

2026-02-09 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Example/TestReader.pm,
	tta/perl/Texinfo/ReaderNonXS.pm, tta/perl/Texinfo/TreeElementNonXS.pm:
	reformat functions beginning.  Use defined or exists in conditions
	when not interested in the value.

	* tta/C/main/reader.c, tta/C/structuring_transfo/transformations.c,
	tta/C/main/structure_list.c: minor changes in spacing and comments.

2026-02-09 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Structuring.pm, tta/perlTexinfo/Transformations.pm:
	reformat functions beginning.  Use defined or exists in conditions
	when not interested in the value.

2026-01-09  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/Makefile.am (wwwdoc-build): reference gnulib CSS file
	on www.gnu.org.

2026-01-06  Gavin Smith <gavinsmith0123@gmail.com>

	* NEWS: further edits and reordering

2026-01-06  Gavin Smith <gavinsmith0123@gmail.com>

	* NEWS: edit many entries.

2026-01-06  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/info-stnd.texi (Hooks): remove comment with impractical
	advice about what a "script" is and isn't.

2026-01-06  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Invoking @command{texi2any}) <--internal-links>:
	Fix grammar error.

2026-01-06  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Command List):
	Add @documentinfo, @publication, @maketitle, @namedanchor.

2026-01-06  Gavin Smith <gavinsmith0123@gmail.com>

	* Makefile.am (po_document-check): update path of excluded file

2026-01-06  Gavin Smith <gavinsmith0123@gmail.com>

	po-check fix

	* tta/C/main/errors.h (message_list_document_warn_no_xlate):
	Define as alias for message_list_document_warn.
	* tta/C/main/output_unit.c (destroy_output_unit): use it.
	* tta/C/main/tree.c (destroy_element): use it.
	
	This prevents files showing up in the output of "make po-check"
	when they do not have translatable strings.

	* Makefile.am (update-po): Refer to po/Makevars in a comment.
	* po/Makevars: edit comment.

2026-02-03 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Config.pm: reformat functions beginning.

2026-02-03 Patrice Dumas  <pertusus@free.fr>

	Add missing includes for _O_BINARY and S_IFMT and similar

	* tta/C/convert/convert_html.c, tta/C/main/utils.h: add fcntl.h
	include for _O_BINARY.  Report from Gavin.

	* tta/C/main/utils.h: ass sys/stat.h include for S_ISDIR, S_IFDIR and
	S_IFMT.  Report from Gavin.

2026-02-03 Patrice Dumas  <pertusus@free.fr>

	* po_document/POTFILES.in: remove
	tta/perl/init/documentation_examples.pm.

2026-02-01 Patrice Dumas  <pertusus@free.fr>

	* tta/swig/texinfo.i (interface_version): add.

2026-02-01 Patrice Dumas  <pertusus@free.fr>

	* doc/texi2any_api.texi (Simple Output Customization for Simple
	Commands with Braces), tta/perl/Texinfo/Config.pm
	(texinfo_register_style_command_formatting)
	(texinfo_style_command_set_quoting): add
	texinfo_style_command_set_quoting separately from
	texinfo_register_style_command_formatting to set quoting.  Update
	callers.

2026-01-01 Patrice Dumas  <pertusus@free.fr>

	* doc/texi2any_api.texi (Simple Customization for Commands Without
	Arguments, Simple Output Customization for Simple Commands with
	Braces): add code to the contexts handled with preformatted.

	* doc/texi2any_api.texi (Commands Without Arguments Formatting):
	explain how to access to information on formatting for commands
	without argument, through no_arg_commands_formatting.

	* doc/texi2any_api.texi (Simple Commands with Braces Formatting):
	explain how to access to information on formatting for simple commands
	with braces formatting, through style_commands_formatting.

2026-01-01 Patrice Dumas  <pertusus@free.fr>

	* doc/texi2any_api.texi (Simple Customization for Commands Without
	Arguments), tta/perl/Texinfo/Config.pm
	(texinfo_register_no_arg_command_formatting)
	(texinfo_register_no_arg_command_texinfo): add another function to
	specify Texinfo code for no args command formatting, that was
	previously the last argument of
	texinfo_register_no_arg_command_formatting.  Update callers.

2026-01-01 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/ext/epub3.pm (epub_setup, epub_finish): save values of
	OUTFILE and SUBDIR before setting them with force_conf, and reset them
	after the conversion.

2026-01-01 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/init/documentation_examples.pm (my_function_set_some_css):
	set $footnotestyle_before_setting only once.

2025-12-31 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/Plaintext.pm (conversion_initialization):
	reset node_names_text.

2025-12-31 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/html_prepare_converter.c (html_prepare_css)
	(html_conversion_initialization), tta/C/main/converter_types.h
	(CONVERTER), tta/perl/Texinfo/Convert/HTML.pm (_process_css_file)
	(_prepare_css, conversion_initialization): distinguish CSS lines from
	files, setup in converter initialization, and CSS lines modified in
	conversion.

	* tta/perl/Texinfo/Convert/HTML.pm (%XS_conversion_overrides),
	tta/perl/XSTexinfo/convert/ConvertXS.xs
	(html_conversion_initialization): re-add conversion_initialization in
	XS overrides, even though it is not used in main program, such that it
	can be used in tests, when a converter is used but not output nor
	converter.

2025-12-31 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/build_html_perl_info.c
	(html_pass_conversion_initialization): reuse converter_info Perl
	data, such as not to have stale references to tree.

2025-12-30 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/t/init/button_replacement_for_special_unit_direction.pm,
	tta/perl/t/init/special_element_customization.pm,
	tta/perl/t/init/translated_strings_customization.pm: proper return for
	functions.  Change beginning of functions formatting.

2025-12-30 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/t/test_utils.pl (_convert, convert_to_*): get converter
	initialization errors separately from conversion errors.

2026-01-01  Gavin Smith <gavinsmith0123@gmail.com>

	Character reference for @print{} in HTML

	* tta/data/commands_values.txt (xml_text_entity_no_arg_commands):
	Use character reference "&#8867;" for @print{} instead of inheriting
	"-|" string from "text_brace_no_arg_commands" section.
	
	This means that the ⊣ symbol (U+22A3 LEFT TACK) will be displayed
	instead of the ASCII approximation in HTML output.

2026-01-01  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/data/default_css_element_class_styles.csv
	(dt.def-line): Set font-size: 1 rem.  This gives a consistent
	font size for @deftypefn and similar.
	(strong.def-name): Remove font-size setting.

2026-01-01  Gavin Smith <gavinsmith0123@gmail.com>

	* update-version.sh: fix updating info.js version to replace "dev"
	suffix on version number.

2026-01-01  Gavin Smith <gavinsmith0123@gmail.com>

	* README-hacking: note on updating version number in usage messages.

2026-01-01  Gavin Smith <gavinsmith0123@gmail.com>

	* grand-replace.sh: further updates

2026-01-01  Gavin Smith <gavinsmith0123@gmail.com>

	* grand-replace.sh: do not touch configure.ac or Makefile.am in
	top-level directory.

2026-01-01  Gavin Smith <gavinsmith0123@gmail.com>

	* grand-replace.sh: further updates to cover more files

2026-01-01  Gavin Smith <gavinsmith0123@gmail.com>

	* grand-replace.sh (find_missed): update script to work for
	other years than 2025.

2026-01-01  Gavin Smith <gavinsmith0123@gmail.com>

	* grand-replace.sh: update some paths

2026-01-01  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (@pounds, @textdegree):
	Do not report that these commands could be output as "#" or
	"o" respectively.  This is unlikely for real users' use cases
	and would not be considered correct.

2026-01-01  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/data/commands_values.txt:
	correct name of Texinfo::Convert::NodeNameNormalization module
	in a comment.

2025-12-31  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Inserting an Ampersand): Remove unintended
	space before @footnote.

2025-12-31  Gavin Smith <gavinsmith0123@gmail.com>

	info: Avoid starting interactive session with --output flag

	* info/info.c (get_initial_file, add_initial_files)
	<hook node, invocation node>:
	Call info_session_or_dump_one_node instead of info_session_one_node.

	(info_session_or_dump_one_node): Get user output filename from
	file-global variable rather than as a variable.

2025-12-30  Gavin Smith <gavinsmith0123@gmail.com>

	* info/session.c (dump_nodes_to_file):
	Call initialize_dumping for each node in the list we were passed
	to dump.  This means we reset the list of dumped nodes each time
	round.  This makes "info --all MANUAL --output=-" work as
	expected: before, only one version of an installed manual would
	be output.

2025-12-30  Gavin Smith <gavinsmith0123@gmail.com>

	* info/info.c (dump_nodes_to_file_and_quit): New wrapper function.
	(main) <--all, --output>: Use it.

2025-12-30  Gavin Smith <gavinsmith0123@gmail.com>

	* info/info.c (main): remove unnecessary call to 'close_dribble_file'.

2025-12-30  Gavin Smith <gavinsmith0123@gmail.com>

	Move dumping functions between files

	* info/session-cmd.c, info/session.c
	(dump_nodes_to_file, write_node_to_stream)
	(struct info_namelist_entry, info_namelist_free)
	(dump_node_to_stream, initialize_dumping, dumped_already)
	Move to session.c.

2025-12-30  Gavin Smith <gavinsmith0123@gmail.com>

	info: Fix outputting manpage to file

	* info/info.c (info_session_or_dump_one_node):
	New function, wrapping info_session_one_node.  Dump node to
	output file if --output given or info output was piped.
	(main): Call info_session_or_dump_one_node both for manpage nodes
	and for "virtual index" nodes.

	This fixes piping the output of 'info' when a manpage is loaded,
	as in "info man | head".  Report from Arne Babenhauserheide.

2025-12-29 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Makefile.tres, tta/perl/t/html_tests.t
	(deftypefnnewline_on_in_middle): add test setting deftypefnnewline on
	in the middle of a document or HTML.

2025-12-29 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/init/documentation_examples.pm: initialize and
	re-initialize variables to allow for multiple calls of the functions
	for the same converter.

2025-12-29 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/converter.c (set_commands_options_value)
	(command_init), tta/C/main/option_types.h (COMMAND_OPTION_VALUE): add
	set field to COMMAND_OPTION_VALUE, set it when the value is set and
	use the value to determine if the command value is set.  This allows
	to pass 'undef' by avoiding to consider a command value set if not
	NULL for strings and positive for integers.

	* tta/perl/Texinfo/Convert/Converter.pm (get_command_init): set the
	value from init_conf if it exists, such that undef values registered
	in commands_init_conf are obtained.

	* tta/C/convert/converter.c (set_converter_init_information),
	tta/perl/Texinfo/Convert/Converter.pm (_generic_converter_init): set
	converter format defaults in commands_init_conf.

	* tta/C/convert/html_prepare_converter.c (informative_global_commands)
	(html_conversion_initialization), tta/perl/Texinfo/Convert/HTML.pm
	(conversion_initialization), tta/perl/Texinfo/Convert/LaTeX.pm
	(conversion_initialization), tta/perl/Texinfo/Convert/Plaintext.pm
	(conversion_initialization): call set_global_document_commands on the
	lists of relevant global commands for the different formats.  For
	LaTeX, most of the commands are used, so do it for all the commands in
	Texinfo::Common::document_settable_at_commands.

	* tta/perl/Texinfo/Convert/Plaintext.pm (conversion_initialization):
	reset outside_of_any_node_text and current_node.

	* tta/perl/Texinfo/Convert/Converter.pm (get_converter_errors),
	tta/perl/XSTexinfo/convert/ConvertXS.xs (get_converter_errors):
	remove the errors at the end of the call to get_converter_errors.

2025-12-28 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/utils.c (element_value_equivalent),
	tta/perl/Texinfo/Common.pm (element_value_equivalent): return the
	input command name and an undefined value if an equivalent command is
	not found.

	* tta/perl/Texinfo/Convert/LaTeX.pm (%informative_commands): fix a
	typo in module name.

2025-12-28 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/format_html.c (html_internal_command_tree): use better
	default for tree->status.

	* tta/C/convert/format_html.c (html_command_text),
	tta/perl/Texinfo/Convert/HTML.pm (_internal_command_tree): inline and
	remove external_command_tree.  Do not use a TREE_ADDED_ELEMENTS in C.

2025-12-28 Patrice Dumas  <pertusus@free.fr>

	* doc/texi2any_api.texi (Special Units Information Customization):
	remove heading_tree, separate simple item and Texinfo code item and
	describe special_unit_info_text.

2025-12-28 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/html_conversion_state.c (html_new_document_context):
	allow an undefined context_name.

	* doc/texi2any_api.texi (Texinfo Tree Conversion Functions)
	(Setting the Expansion Context for Conversion)
	(Internationalization of Strings Function): rename "Setting the
	Context for Conversion" as "Setting the Expansion Context for
	Conversion".  Modify for changes in
	convert_tree_new_formatting_context call and changes in setting the
	context.  Document _converted special text element in
	"Internationalization of Strings Function".

	* tta/perl/init/documentation_examples.pm,
	tta/perl/t/init_files_tests.t ($documentation_examples_text): add
	example of convert_tree_new_formatting_context call, simplify the
	convert_tree_in_code_context example use.

	* doc/texi2any_api.texi (Inline Text Containers Formatting)
	(Type Tree Element Conversion Functions): update with simpler example.

2025-12-28 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/HTML.pm (_set_code_context)
	(_pop_code_context, convert_tree_in_code_context): rename
	set_code_context as _set_code_context and pop_code_context as
	_pop_code_context.  Add convert_tree_in_code_context that calls
	_set_code_context, then convert tree and _pop_code_context.  Use that
	function instead of _set_code_context and convert_tree in code that
	could be user-defined.

2025-12-28 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/html_conversion_state.c (html_new_document_context),
	tta/perl/Texinfo/Convert/HTML.pm (_new_document_context): reorganize
	code and modify Perl code to be more similar to C code.

2025-12-27 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/HTML.pm ($CTXF_string, $CTXF_code): make
	our.

2025-12-27 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/converter_types.h (CTXF_code),
	tta/perl/Texinfo/Convert/HTML.pm ($CTXF_code): rename CTXF_in_code as
	CTXF_code.

2025-12-27 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/HTML.pm (set_code_context)
	(pop_code_context), tta/perl/init/documentation_examples.pm: rename
	_set_code_context as set_code_context and _pop_code_context as
	pop_code_context.  Update callers.

2025-12-27 Patrice Dumas  <pertusus@free.fr>

	Remove the _code special container

	* tta/C/convert/format_html.c (html_external_command_tree)
	(html_command_text), tta/perl/Texinfo/Convert/HTML.pm
	(_external_command_tree, command_text): do not use a _code container,
	instead set CTXF_in_code in the context_type used for conversion.

	* tta/C/convert/format_html.c (html_convert_xref_command)
	(html_convert_menu_entry_type, html_convert_def_line_type),
	tta/perl/Texinfo/Convert/HTML.pm (_convert_xref_commands)
	(_convert_menu_entry_type, _convert_def_line_type): instead of
	rooting a tree at _code to be in code context, call set_code_context
	and pop_code_context.

	* tta/C/convert/format_html.c (html_convert_printindex_command),
	tta/perl/Texinfo/Convert/HTML.pm (_convert_printindex_command): do
	not set types to be _code, instead set formatting_context to
	CTXF_in_code and call html_set_code_context and html_pop_code_context
	if in_code.

	* tta/perl/init/documentation_examples.pm
	(my_tree_element_convert_paragraph_type)
	(my_final_convert_paragraph_type): cal _set_code_context and
	_pop_code_context instead of rooting the trees at _code.

	* tta/C/convert/html_prepare_converter.c (default_code_types),
	tta/C/main/element_types.txt, tta/perl/Texinfo/Convert/HTML.pm
	(%default_code_types): remove completly the _code container.

2025-12-27 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/format_html.c (html_internal_command_tree),
	tta/C/main/tree_types.h (TREE_ADDED_ELEMENTS),
	tta/perl/Texinfo/Convert/HTML.pm (_internal_command_tree)
	(_internal_command_name_tree): instead of adding a _code type element,
	keep the information that the tree should be in code either in target
	and as return code in Perl, or in TREE_ADDED_ELEMENTS new in_code
	field in C.  Update callers in Perl.

	* tta/C/convert/format_html.c (html_internal_command_text)
	(html_internal_command_name), tta/perl/Texinfo/Convert/HTML.pm
	(_internal_command_text, _internal_command_name): use the tree added
	elements or the internal_command_tree in_code information to set the
	convert_command_tree argument.

2025-12-27 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/HTML.pm (special_unit_info_text): rename
	$context_type as $context.

	* tta/C/convert/convert_html.c
	(html_convert_tree_new_formatting_context, html_convert_tree_append),
	tta/C/convert/format_html.c, tta/C/convert/html_conversion_state.c
	(html_new_document_context), tta/C/convert/html_conversion_state.h
	(CTXF_string, CTXF_in_code), tta/perl/Texinfo/Convert/HTML.pm
	($CTXF_string, $CTXF_in_code, _new_document_context, _convert),
	tta/perl/XSTexinfo/convert/ConvertXS.xs
	(html_new_document_context): pass context information as flags,
	CTXF_string and CTXF_in_code set to an integer to new_document_context
	and convert_tree_new_formatting_context.  Update callers.

	* tta/perl/Texinfo/Convert/HTML.pm (_convert_command_tree),
	tta/C/convert/format_html.c (html_convert_command_tree): add
	in_code argument.

2025-12-27 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/HTML.pm (%XS_conversion_overrides),
	tta/perl/XSTexinfo/convert/ConvertXS.xs: remove
	html_internal_command_tree and html_internal_command_name_tree XS
	overrides, as they are only called from already overriden functions.

	* tta/C/convert/format_html.c (html_internal_command_tree): set tree
	status to tree_added_status_reused_tree.

2025-12-27 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/build_html_perl_state.c (build_html_translated_names):
	remove code related to the previous way to store special unit info
	trees.

2025-12-27 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/format_html.c (html_special_unit_info_text): rename
	special_unit_info_text as html_special_unit_info_text.  Update caller.

	* tta/perl/Texinfo/Convert/HTML.pm (%XS_conversion_overrides)
	tta/perl/XSTexinfo/convert/ConvertXS.xs
	(html_special_unit_info_text): add an XS interface for
	special_unit_info_text.

2025-12-27 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/convert_html.c, tta/C/convert/format_html.c: inline
	and remove html_convert_string_tree_new_formatting_context.

2025-12-27 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/convert_html.c (html_conversion_finalization),
	tta/C/convert/format_html.c (html_output_internal_links): remove calls
	to free_html_targets_trees, now that trees to build are not removed
	there.

	* tta/C/convert/html_prepare_converter.c (reset_html_targets_list)
	(reset_html_targets): move code from free_html_targets_trees_list
	to reset_html_targets_list.  Remove free_html_targets_trees_list and
	free_html_targets_trees.

2025-12-27 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/format_html.c (special_unit_info_tree): rename tree as
	unit_info_tree.

	* tta/C/convert/convert_html.c
	(html_reset_translated_special_unit_info_tree),
	tta/C/convert/converter.c (clear_tree_added_elements),
	tta/C/convert/format_html.c (special_unit_info_tree)
	(html_internal_command_tree, html_convert_command_tree)
	(html_command_text, html_convert_item_command): do not add nor remove
	trees to build in clear_tree_added_elements,
	html_reset_translated_special_unit_info_tree, special_unit_info_tree,
	html_internal_command_tree.  Instead add and remove tree to build just
	before and after conversion, in special_unit_info_text,
	html_convert_command_tree, html_command_text and
	html_convert_item_command.  That way it is much easier to determine
	when trees are added and removed.

2025-12-27 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/init/html32.pm (html32_convert_item_command): update
	convert_tree_new_formatting_context call.

2025-12-27 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/convert_html.c
	(html_reset_translated_special_unit_info_tree),
	tta/C/convert/format_html.c (special_unit_info_tree),
	tta/C/convert/html_converter_finish.c (html_free_converter),
	tta/C/convert/html_prepare_converter.c
	(html_converter_init_special_units_info), tta/C/main/converter_types.h
	(translated_special_unit_info_texinfo)
	(translated_special_unit_info_tree),
	tta/C/convert/html_converter_types.h (special_unit_info_tree_names),
	tta/maintain/generate_code_convert_data.pl,
	tta/perl/Texinfo/Convert/HTML.pm (_internal_command_tree)
	(_special_unit_info_tree, special_unit_info, _translate_names)
	(converter_initialize, converter_destroy),
	tta/perl/XSTexinfo/convert/get_html_perl_info.c
	(html_converter_init_special_unit_sv): split default information for
	tree special unit (heading) in a separate
	default_special_unit_tree_info array and add
	special_unit_info_tree_names.  Split tree unit special info texinfo
	strings out of the main special_unit_info data to
	translated_special_unit_info_texinfo.  Rename special_unit_info_tree
	as translated_special_unit_info_tree.  Never set a *_tree in Perl,
	always use directly the name.  Update C code for the separation
	of defaults.  In Perl, split code setting
	translated_special_unit_info_tree out of special_unit_info to
	_special_unit_info_tree and call directly this function for
	translated/tree special unit.
	Set and use consistently *SPECIAL_UNIT_INFO_*NR sizes in C.

	* tta/C/convert/format_html.c (special_unit_info_text)
	(default_format_footnotes_segment), tta/perl/Texinfo/Convert/HTML.pm
	(special_unit_info_text, _default_format_footnotes_segment): add
	special_unit_info_text that gets the tree and do the conversion.
	Use it in code such that the tree is never accessed in code that could
	be user-defined.

	* tta/perl/Texinfo/Convert/HTML.pm (get_special_unit_info_varieties):
	only consider non-tree special unit info.

2025-12-26 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/format_html.c, tta/perl/Texinfo/Convert/HTML.pm
	(output_internal_links): remove command_tree and html_command_tree.
	Replace by calls to _internal_command_tree in output_internal_links.

	* doc/texi2any_api.texi (Target Tree Element Link): remove
	documentation of command_tree.

2025-12-26 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/format_html.c (file_header_information),
	tta/perl/Texinfo/Convert/HTML.pm (_file_header_information): determine
	the string of the element actually used for the element text before
	comparing with the title string.  Use element text strings instead of
	trees for the formatting of the title.

2025-12-26  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/txi-pt.tex, doc/txi-pt_BR.tex: update comments

2025-12-26 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/get_converter_perl_info.c, tta/C/main/get_perl_info.c
	(converter_release_output_units_built): move
	converter_release_output_units_built to get_perl_info.c.

	* tta/C/convert/call_conversion_perl.c
	(release_converter_output_units_remove_perl_output_units): add to call
	both converter_release_output_units_built and
	call_object_perl_converter_remove_output_units to release and remove
	Perl output units from C.

	* tta/C/convert/texinfo.c (txi_converter_remove_output_units),
	tta/perl/XSTexinfo/convert/ConvertXS.xs
	(converter_remove_output_units): call
	release_converter_output_units_remove_perl_output_units.

2025-12-26 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/format_html.c (mini_toc_internal),
	tta/perl/Texinfo/Convert/HTML.pm (_mini_toc): use command_text instead
	of getting the tree and converting.

2025-12-26 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Makefile.tres, tta/perl/t/html_tests.t
	(namedanchor_in_redirection_file): test with @namedanchor in
	redirection file.

2025-12-26 Patrice Dumas  <pertusus@free.fr>

	Update po files

2025-12-26 Patrice Dumas  <pertusus@free.fr>

	In index formatted in code context use a true code for @seealso

	* tta/C/convert/format_html.c (html_convert_printindex_command),
	tta/perl/Texinfo/Convert/HTML.pm (_convert_printindex_command): if in
	code formatted index, use an actual @code{} for the @seealso
	in-document converted string.

2025-12-25 Patrice Dumas  <pertusus@free.fr>

	Remove the _string special HTML only container

	* tta/C/convert/html_conversion_state.c
	(html_open_type_update_context, html_convert_type_update_context),
	tta/C/main/element_types.txt, tta/perl/Texinfo/Convert/HTML.pm
	(_open_type_update_context, _convert_type_update_context): remove the
	_string special HTML only container, the new
	convert_tree_new_formatting_context argument should be used instead.

2025-12-25 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/convert_html.c
	(html_convert_tree_new_formatting_context)
	(html_convert_string_tree_new_formatting_context)
	(html_prepare_converted_output_info, html_convert_tree_append)
	tta/C/convert/format_html.c, tta/C/convert/html_conversion_state.c
	(html_new_document_context), tta/perl/Texinfo/Convert/HTML.pm
	(_convert_command_tree, convert_tree_new_formatting_context)
	(_new_document_context, _convert),
	tta/perl/XSTexinfo/convert/ConvertXS.xs (html_new_document_context):
	add a context type argument to _new_document_context and
	convert_tree_new_formatting_context.  if set to string (or
	HCC_type_string in C), set string context.  Replace the use of the
	_string type element container by setting this argument in callers.
	Update all the callers.

2025-12-25 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/format_html.c (html_convert_command_tree),
	tta/perl/Texinfo/Convert/HTML.pm (_convert_command_tree): set string
	context instead of creating a tree with _string type at its root
	to convert the tree if the text type is string.

2025-12-25 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/build_html_perl_info.c (html_pass_htmlxref): fix typo
	in function name.

2025-12-25 Patrice Dumas  <pertusus@free.fr>

	Remove XS interface of functions called by output or convert

	* tta/perl/Texinfo/Convert/HTML.pm (%XS_conversion_overrides),
	tta/perl/XSTexinfo/convert/ConvertXS.xs: remove XS overrides for
	functions called by output and convert, they are not called.  Also
	their code is not up to date.  Remove html_conversion_initialization,
	html_setup_output, html_setup_convert, html_conversion_finalization,
	html_prepare_simpletitle, html_prepare_converted_output_info,
	html_prepare_title_titlepage, html_convert_convert,
	html_convert_output, html_prepare_node_redirection_page,
	html_node_redirections.

2025-12-25 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/converter.c (converter_remove_output_units),
	tta/C/convert/converter.h (CONVERTER_FORMAT_DATA),
	tta/C/convert/texinfo.c (txi_converter_remove_output_units),
	tta/perl/Texinfo/Convert/Converter.pm (%XS_overrides)
	(converter_remove_output_units),
	tta/perl/XSTexinfo/convert/ConvertXS.xs
	(converter_remove_output_units): rename
	reset_converter as converter_remove_output_units,
	txi_reset_converter as txi_converter_remove_output_units and
	CONVERTER_FORMAT_DATA converter_reset field as
	converter_release_output_units.  Update callers.

2025-12-25 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/converter.c (converter_format_data)
	(reset_tree_to_build, reset_converter),
	tta/C/convert/html_converter_finish.c: add reset_tree_to_build based
	on html_converter_finish.c reset_converter code and call it in
	converter.c reset_converter.  Remove html_converter_finish.c
	html_free_converter function.

2025-12-25 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/converter.c (reset_converter): do not set the document
	to NULL, it is not useful to do it at that point.

2025-12-25 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/call_conversion_perl.c
	(call_object_perl_converter_remove_output_units),
	tta/perl/Texinfo/Convert/Converter.pm
	(converter_release_output_units, perl_converter_remove_output_units),
	tta/perl/Texinfo/Convert/HTML.pm (converter_release_output_units):
	rename converter_reset as converter_release_output_units, rename
	reset_perl_converter as perl_converter_remove_output_units, and rename
	call_object_reset_perl_converter as
	call_object_perl_converter_remove_output_units.  Update callers.

	* tta/C/convert/converter.c (destroy_converter_output_units)
	(reset_converter): rename reset_generic_converter as
	destroy_converter_output_units and move setting document to 0 directly
	in reset_converter.

2025-12-25 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/LaTeX.pm (_prepare_floats): make
	latex_floats a local variable.

	* tta/perl/Texinfo/Convert/LaTeX.pm (conversion_initialization)
	(_prepare_conversion): move resetting converter fields related to the
	document to conversion_initialization.  Remove converter_reset.

	* tta/perl/Texinfo/Convert/LaTeX.pm (converter_destroy): delete
	settitle_tree too.

2025-12-25 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/XSTexinfo/convert/ConvertXS.xs (html_output): call
	build_output_files_information as late as possible to catch all the
	opened files.

	* tta/C/main/convert_utils.c, tta/C/main/utils.c (free_unclosed_files)
	(free_output_files_information, clear_output_files_information): move
	to utils.c.

	* tta/C/texi2any.c (main), tta/C/convert/converter.c
	(reset_generic_converter, html_reset_converter),
	tta/perl/XSTexinfo/convert/ConvertXS.xs (html_output): do not call
	clear_output_files_information in *reset_*converter, call in main
	program and when building the data to Perl.

2025-12-25 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/Utils.pm (output_files_reset): add.

	* tta/perl/t/test_utils.pl (close_files), tta/perl/texi2any.pl: call
	output_files_reset when the files information has been transfered to
	the main program.

	* tta/C/main/get_perl_info.c (get_output_files_information): clear
	Perl output files information.

2025-12-24 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/html_converter_finish.c (html_reset_converter)
	(html_free_converter), tta/C/convert/html_prepare_converter.c
	(reset_html_page_css, html_conversion_initialization)
	(prepare_page_css, html_setup_output_simple_page)
	(html_set_pages_files): add reset_html_page_css to
	html_prepare_converter.c based on html_reset_converter code.
	Reuse the memory allocated in converter page_css.  Call
	reset_html_page_css in html_free_converter and html_free_converter.
	Free page_css list in html_free_converter.
	Add prepare_page_css based on code used to setup page_css in
	html_setup_output_simple_page and html_set_pages_files, updated to
	reuse the page_css memory.  Call in html_setup_output_simple_page
	and html_set_pages_files.

2025-12-24 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/html_conversion_state.c (html_free_pending_footnote):
	add to free one pending footnote.

	* tta/C/convert/format_html.c
	(html_default_format_footnotes_sequence),
	tta/C/convert/html_conversion_state.c (html_clear_pending_footnotes),
	tta/C/convert/html_converter_finish.c (html_free_converter),
	tta/C/convert/html_prepare_converter.c
	(html_conversion_initialization),
	tta/perl/XSTexinfo/convert/ConvertXS.xs (html_get_pending_footnotes):
	access directly the converter pending footnotes in
	html_default_format_footnotes_sequence and in html_get_pending_footnotes
	instead of calling html_get_pending_footnotes.  Free each pending
	footnote after it is formatted in
	html_default_format_footnotes_sequence.  Add html_clear_pending_footnotes
	to free all the pending footnotes, but keep the allocated memory.
	Call html_clear_pending_footnotes in html_conversion_initialization,
	html_conversion_finalization and html_get_pending_footnotes.  Free the
	converter pending_footnotes stack in html_free_converter.
	Remove html_get_pending_footnotes and destroy_pending_footnotes.

	* tta/C/convert/convert_html.c (html_conversion_finalization): output
	a warning if there are pending footnotes.

2025-12-24 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/convert_html.c (clear_type_explanations)
	(html_reset_shared_conversion_state),
	tta/C/convert/html_converter_finish.c (html_reset_converter): move
	code resetting shared_conversion_state to convert_html.c
	html_reset_shared_conversion_state.

	* tta/C/convert/convert_html.c (html_reset_shared_conversion_state):
	clear shared_conversion_state->elements_authors.top if not empty.
	Zero in_skipped_node_top, footnote_number and html_menu_entry_index.

	* tta/C/convert/convert_html.c (html_conversion_finalization),
	tta/C/convert/html_prepare_converter.c
	(html_reset_shared_conversion_state): call
	html_reset_shared_conversion_state in html_conversion_finalization and
	html_reset_shared_conversion_state (and not in html_reset_converter).

2025-12-24 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/XSTexinfo/convert/get_html_perl_info.c (get_authors_list):
	rename warn argument as access_elements_authors and sv_in as
	quotation_titlepage_nr_sv.

	* tta/perl/XSTexinfo/convert/get_html_perl_info.c
	(html_set_shared_conversion_state, html_get_shared_conversion_state):
	be more robust to incorrect input.  Add comments.

2025-12-24 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/HTML.pm (_collect_css_element_class)
	(register_file_information, _prepare_title_titlepage)
	(_html_convert_convert, _html_convert_output)
	(_prepare_node_redirection_page, _node_redirections): delete
	current_filename instead of setting undef.

	* tta/C/convert/convert_html.c (html_convert_output),
	tta/perl/Texinfo/Convert/HTML.pm (_html_convert_output): make sure
	that current_filename is unset when exiting the function.

	* tta/C/convert/convert_html.c (html_convert_convert)
	(html_convert_output), tta/C/convert/html_prepare_converter.c
	(html_setup_output): reset current_filename in html_setup_output to do
	like in Perl, even though it is not needed as it is already deleted
	after conversion and each time it is set out of the conversion.
	Always reset the whole structure to simplify code and thinking.

2025-12-24 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/converter_types.h (CONVERTER),
	tta/perl/Texinfo/Convert/HTML.pm: rename converter field
	document_global_context as document_global_context_counter (to avoid
	mistaking with the document_global_context strings).  Update code
	accessing document_global_context_counter.

	* tta/perl/Texinfo/Convert/HTML.pm (conversion_initialization),
	tta/C/convert/html_prepare_converter.c
	(html_conversion_initialization): initialize
	document_global_context_counter.

2025-12-24  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Inserting Math): Move from a section
	to a chapter as it is doesn't fit well with the rest of the
	chapter ("Special Insertions").

2025-12-24 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Makefile.tres, tta/perl/t/formats_encodings.t
	(char_latin1_latin1_in_refs_output_encoding_latin1): add a test
	similar to char_latin1_latin1_in_refs, but with OUTPUT_ENCODING_NAME
	set to ISO-8859-1, both to test the effect of setting
	OUTPUT_ENCODING_NAME, and also to test LaTeX with latin1, now that the
	default encoding is UTF-8 for LaTeX.

2025-12-24 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Common.pm (set_output_encoding): test if
	OUTPUT_ENCODING_NAME is undefined to use input encoding.

2025-12-24  Gavin Smith <gavinsmith0123@gmail.com>

	UTF-8 by default for LaTeX output

	* tta/perl/Texinfo/Convert/LaTeX.pm (%defaults):
	Set OUTPUT_ENCODING_NAME to 'utf-8'.

	* tta/perl/Texinfo/Common.pm (set_output_encoding),
	* tta/C/main/document.c (set_output_encoding): Only propagate
	encoding name from input encoding to output encoding if output
	encoding is not already set.
	* tta/perl/Texinfo/Convert/Text.pm: update comments

	* tta/data/converters_defaults.txt (html_converter),
	* tta/perl/Texinfo/Convert/DocBook.pm (%defaults),
	* tta/perl/Texinfo/Convert/TexinfoXML.pm (%defaults):
	Remove OUTPUT_ENCODING_NAME utf-8 default.

	* NEWS: update

2025-12-24  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/data/default_css_element_class_styles.csv (strong.def-name):
	Define "font-size" as "1rem" rather than "larger".  The "larger"
	setting was to compensate for a smaller monospaced font size, but
	if an @r element is embedded within the name of the defined symbol,
	then the roman text would be larger than the surrounding text
	(as in "@defun foo[@r{bar}]", which construct was sometimes used in
	the groff manual).  Using "1rem" results in a consistent font size.

2025-12-23 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/format_html.c (html_convert_index_entry_command_type)
	(html_convert_def_line_type), tta/perl/Texinfo/Convert/HTML.pm
	(_convert_index_entry_command_type, _convert_def_line_type): use
	in_multiple_conversions instead of multi_expanded_region in
	conditions.  The result is the same, but it makes more sense to avoid
	outputting a target for an index entry more than once irrespective
	of the context.

2025-12-23 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Makefile.tres, tta/perl/t/html_tests.t
	(anchor_on_node_line): add test of anchor on node line expanded in
	output (on a @node line of a node not associated to sectioning
	commands).

2025-12-23 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/html_conversion_state.c (html_multi_expanded_region),
	tta/perl/Texinfo/Convert/HTML.pm (multi_expanded_region),
	tta/perl/XSTexinfo/convert/ConvertXS.xs (html_multi_expanded_region):
	rename in_multi_expanded as multi_expanded_region.  Update callers.

	* tta/C/convert/html_conversion_state.c
	(html_in_multiple_conversions),
	tta/perl/XSTexinfo/convert/ConvertXS.xs
	(html_in_multiple_conversions), tta/C/convert/format_html.c
	(html_convert_raw_command): add html_in_multiple_conversions to be
	more like Perl code.

	* doc/texi2any_api.texi (Other Dynamic Information): update function
	name and edits.

2025-12-23 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/convert_html.c (html_conversion_finalization),
	tta/C/convert/format_html.c (html_convert_raw_command),
	tta/C/convert/html_conversion_state.c (html_set_multiple_conversions)
	(html_unset_multiple_conversions), tta/C/main/converter_types.h
	(CONVERTER), tta/perl/Texinfo/Convert/HTML.pm
	(in_multiple_conversions, _set_multiple_conversions)
	(_unset_multiple_conversions), tta/perl/XSTexinfo/convert/ConvertXS.xs
	(html_in_multiple_conversions): remove multiple_conversions, use the
	size of multiple_pass instead.

2025-12-23 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/html_converter_finish.c (html_reset_converter),
	tta/C/convert/html_prepare_converter.c
	(html_conversion_initialization): reset check_htmlxref_already_warned
	in html_conversion_initialization not in html_reset_converter.

	* tta/perl/Texinfo/Convert/HTML.pm (conversion_initialization): always
	reset check_htmlxref_already_warned.

	* tta/C/convert/html_converter_finish.c (html_reset_converter)
	(html_free_converter): avoid a useless intermediary variable for
	explained_commands.

2025-12-23  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\lattwochardefs): Use \ensuremath for definitions
	of × and ÷.

2025-12-23  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\latonechardefs): Change more definitions to
	match \unicodechardefs.

2025-12-23  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\latonechardefs): Define ^^b1 using \ensuremath,
	matching definition in \unicodechardefs.  Report from Patrice Dumas.

2025-12-22 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/html_converter_finish.c (free_special_unit_info_list)
	(html_reset_converter): do not call reset_special_unit_info_list on
	customized_special_unit_info, this information should not change after
	getting the customization.  remove reset_special_unit_info_list,
	merging code to free_special_unit_info_list.

2025-12-22 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/html_converter_finish.c (html_reset_converter)
	(html_free_converter), tta/C/convert/html_prepare_converter.c
	(html_conversion_initialization): reset title_tree and
	added_title_tree in html_conversion_initialization instead of
	html_reset_converter and free in html_free_converter.

	* tta/C/convert/html_prepare_converter.c
	(html_conversion_initialization): reset simpletitle_tree and
	simpletitle_cmd.

2025-12-22 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/convert_html.c, tta/C/convert/html_prepare_converter.c
	(html_initialize_pending_closes, html_setup_output_simple_page): move
	html_initialize_pending_closes and html_setup_output_simple_page to
	html_prepare_converter.c.

2025-12-22 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/html_converter_api.c (html_output, html_convert),
	tta/perl/XSTexinfo/convert/ConvertXS.xs (html_output, html_convert):
	use consistently document_name and not converter->document_name, pass
	directly 0 to html_prepare_conversion_units_targets for convert.

	* tta/C/convert/html_converter_finish.c (html_reset_converter)
	(html_free_converter), tta/C/convert/html_prepare_converter.c
	(html_conversion_initialization): reset title_titlepage, title_string,
	documentdescription_string, copying_comment, destination_directory
	and document_name in html_conversion_initialization, not in
	html_reset_converter and free in html_free_converter.

	* tta/C/convert/convert_html.c (html_setup_output_simple_page),
	tta/C/convert/html_converter_finish.c (html_reset_converter)
	(html_free_converter), tta/C/convert/html_prepare_converter.c
	(html_set_pages_files): reset output_unit_file_indices and
	special_unit_file_indices in html_set_pages_files and
	html_setup_output_simple_page, not in html_reset_converter.  Free in
	html_free_converter.

	* tta/C/convert/html_prepare_converter.c
	(html_conversion_initialization): call reset_html_targets in
	html_conversion_initialization.

2025-12-22 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/html_converter_finish.c (html_reset_converter),
	tta/C/convert/html_prepare_converter.c (html_reset_files_source_info)
	(html_prepare_units_directions_files): move
	html_reset_files_source_info to html_prepare_converter.c.  Do not call
	html_reset_files_source_info in html_reset_converter, instead call it
	in html_prepare_units_directions_files before being set.

	* tta/C/convert/html_converter_finish.c (html_reset_converter)
	(html_free_converter), tta/C/convert/html_prepare_converter.c
	(free_js_categories_list, html_conversion_initialization): move the
	code free'ing js categories list to html_prepare_converter.c and call
	it in html_conversion_initialization and in html_free_converter, not
	in html_reset_converter.

2025-12-22 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/XSTexinfo/convert/get_html_perl_info.c: remove unused
	html_get_jslicenses_sv function.

2025-12-22 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/converter.c (free_tree_added_elements): set
	list and space to 0 after free'ing, such that it is possible to call
	the function twice.

	* tta/C/convert/convert_html.c (free_html_targets_trees_list)
	(free_html_targets_trees), tta/C/convert/html_converter_finish.c,
	tta/C/convert/html_prepare_converter.c (reset_html_targets_list)
	(reset_html_targets): move reset_html_targets_list and
	reset_html_targets to html_prepare_converter.c.  Split freeing trees
	outside of reset_html_targets and reset_html_targets_list to
	free_html_targets_trees and free_html_targets_trees_list.

	* tta/C/convert/convert_html.c (html_conversion_finalization),
	tta/C/convert/format_html.c (html_output_internal_links): call
	free_html_targets_trees.

	* tta/C/convert/html_converter_finish.c (html_free_converter)
	(html_reset_converter): call reset_html_targets in html_free_converter
	only.

2025-12-22 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/t/z_misc/same_converter_init.t: set TEST to 2.
	Destroy converter to trigger memory leaks report.

2025-12-22 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/html_converter_finish.c (reset_html_targets_list):
	remove a useless memset.

	* tta/C/convert/html_converter_finish.c (reset_html_targets)
	(html_reset_converter, html_free_converter),
	tta/C/convert/html_prepare_converter.c (sort_cmd_targets): register
	cmd that have been targets allocated in html_target_cmds.  Reuse
	html_targets and html_special_targets targets lists memory, free the
	lists in html_free_converter only.

	* tta/C/convert/html_converter_finish.c (reset_html_targets): remove
	registered_ids_c_hashmap clearing, it is cleared upon being set
	already.

2025-12-22 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/format_html.c: remove
	find_element_target_number_linear and associated comments.

2025-12-22 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/convert_html.c (html_conversion_finalization),
	tta/C/convert/html_converter_finish.c (html_reset_converter): call
	html_reset_translated_special_unit_info_tree in
	html_conversion_finalization instead of html_reset_converter, because
	it releases trees to build.

	* tta/C/convert/html_converter_finish.c (html_reset_converter)
	(html_free_converter), tta/C/convert/html_prepare_converter.c
	(html_conversion_initialization), tta/C/main/converter_types.h
	(SORTED_INDEX_NAMES): add a space field to SORTED_INDEX_NAMES, reuse
	the memory, do not free in html_reset_converter but free in
	html_free_converter.

2025-12-21 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/html_converter_finish.c (html_reset_converter)
	(html_free_converter), tta/C/convert/html_prepare_converter.c
	(html_conversion_initialization), tta/C/main/translations.c
	(free_translation_cache): add free_translation_cache based on
	html_reset_converter code.  Call free_translation_cache in
	html_free_converter and in html_conversion_initialization, but not in
	html_reset_converter.

	* tta/C/convert/html_converter_finish.c (html_reset_converter)
	(html_free_converter), tta/C/convert/html_prepare_converter.c
	(html_conversion_initialization)
	(html_prepare_output_units_global_targets): do not reset
	global_units_direction_names, global_texts_direction_names and
	special_units_direction_names in html_reset_converter.  Free
	special_units_direction_names and global_units_direction_names list in
	html_free_converter.  Free global_units_direction_names list in
	html_conversion_initialization too.  Reuse
	special_units_direction_names memory by using realloc.

	* tta/C/convert/converter.c (converter_set_document): zero out
	converter->output_units_descriptors if a new document is associated to
	a converter.

2025-12-21 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/convert_html.c (html_setup_output_simple_page),
	tta/C/convert/html_converter_finish.c (html_reset_converter)
	(html_free_converter): call allocate_name_number_list in
	html_setup_output_simple_page, since it also resets page_name_number.
	Move free_name_number_list from html_reset_converter to
	html_free_converter now that it is reset upon being allocated.

	* tta/C/convert/convert_html.c (html_prepare_title_titlepage),
	tta/C/convert/html_converter_api.c (html_convert),
	tta/perl/XSTexinfo/convert/ConvertXS.xs (html_convert): call
	html_setup_output_simple_page in convert, not in
	html_prepare_title_titlepage.

2025-12-21 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/converter.c (reset_generic_converter),
	tta/C/convert/html_converter_finish.c (html_reset_converter),
	tta/C/convert/html_prepare_converter.c
	(html_prepare_units_directions_files, html_set_pages_files),
	tta/perl/Texinfo/Convert/HTML.pm (_html_set_pages_files)
	(_prepare_units_directions_files): call clear_output_unit_files in
	html_prepare_units_directions_files and not in html_set_pages_files,
	do not call clear_output_unit_files in *reset_*converter.  Similarly,
	in Perl, call initialize_output_units_files in
	_prepare_units_directions_files, not in _html_set_pages_files.

	* tta/C/convert/converter.c: remove initialize_output_units_files,
	clear_output_unit_files is called instead.

2025-12-21 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/html_converter_finish.c,
	tta/C/convert/html_prepare_converter.c
	(free_html_no_arg_command_conversion)
	(copy_html_no_arg_command_conversion, html_conversion_initialization):
	move free_html_no_arg_command_conversion to html_prepare_converter.c,
	remove the useless second argument, call in
	html_conversion_initialization and remove the calls to free in
	copy_html_no_arg_command_conversion.

	* tta/C/convert/convert_html.c
	(reset_unset_no_arg_commands_formatting_context),
	tta/C/convert/format_html.c, tta/C/convert/html_prepare_converter.c
	(special_characters_formatting): minor changes, avoid useless
	initialization, and useless if, add const.

	* tta/perl/t/z_misc/same_converter_init.t: add another test with
	OUTPUT_CHARACTERS set.

2025-12-21 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/html_prepare_converter.c
	(html_converter_initialize_beginning, html_setup_output),
	tta/perl/Texinfo/Convert/HTML.pm (converter_initialize)
	(_prepare_css, conversion_initialization, _setup_output): call
	html_prepare_css only once per converter initialization in
	html_converter_initialize_beginning/converter_initialize, not once per
	conversion.

2025-12-21 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/html_prepare_converter.c
	(html_conversion_initialization), tta/perl/Texinfo/Convert/HTML.pm
	(conversion_initialization): always unset current_node and
	current_root_command in conversion initialization.

2025-12-21 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/html_prepare_converter.c
	(html_conversion_initialization): rename html_initialize_output_state
	as html_conversion_initialization.  Update callers.

2025-12-21 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/convert_html.c (order_direction_icons_list): rename
	prepare_direction_icons_list as order_direction_icons_list.

	* tta/C/convert/html_converter_finish.c (html_reset_converter)
	(html_free_converter): call html_free_direction_icons_array in
	html_free_converter and not in html_reset_converter as it is already
	called when setting up the icon arrays in order_direction_icons_list.

	* tta/C/convert/convert_html.c (html_convert_output)
	tta/C/convert/html_converter_finish.c (html_reset_converter)
	(html_free_converter): free self->date_in_header just before setting
	it and in html_free_converter.

	* tta/C/convert/convert_html.c (html_initialize_pending_closes)
	(html_setup_output_simple_page), tta/C/convert/html_converter_finish.c
	(html_free_converter), tta/C/convert/html_prepare_converter.c
	(html_set_pages_files), tta/C/main/converter_types.h
	(STRING_STACK_LIST): add a space field in STRING_STACK_LIST.  Reuse
	the pending_closes list instead of free'ing it, growing it if
	there is not enough space.  Add html_initialize_pending_closes that
	grows the pending_closes list if needed and initializes the newly
	added string stacks.  Remove html_free_pending_closes, inlining
	the code free'ing the pending_closes list in html_free_converter.

2025-12-20  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/perl/Texinfo/Convert/LaTeX.pm (_convert, _format_brace_command):
	Split conversion of @{ and @} into separate function and use it
	for @lbracechar{} and @rbracechar{} to ensure conversion of these
	commands is done correctly in index entries.

2025-12-20 Patrice Dumas  <pertusus@free.fr>

	* doc/texi2any_api.texi (Customization of CSS Rules Imports and
	Selectors): add explanations and improve example.

2025-12-20 Patrice Dumas  <pertusus@free.fr>

	Never store CSS selector style with undefined style

	* tta/C/convert/html_conversion_state.c (compare_selector_style):
	sort NULL selector last, such that it is easy to "remove" the selector
	style by decreasing the number of elements in list after it has been
	put last.

	* tta/C/convert/html_conversion_state.c (html_css_set_selector_style):
	if the selector was found but the style is NULL, remove the selector
	style.  Do not add a selector with a NULL style.

	* tta/C/convert/html_prepare_converter.c
	(html_initialize_output_state): adapt to selector style never being
	NULL anymore.

	* tta/C/convert/html_prepare_converter.c
	(set_css_selector_style_list_size): make static.

	* tta/perl/Texinfo/Convert/HTML.pm (_collect_css_element_class)
	(html_attribute_class, css_set_selector_style, css_get_info): never
	add a selector style with an undef style.  Remove the selector if
	css_set_selector_style is called with an undef style.

	* tta/C/convert/html_prepare_converter.c (html_format_setup),
	tta/perl/Texinfo/Convert/HTML.pm: do not add div.lisp selector in the
	first place instead of adding and then removing it.

	* tta/C/convert/html_conversion_state.c (html_css_get_info): always
	clear css_element_class_list and reset the values to avoid returning
	stale information if some selectors have been removed or added.

2025-12-20 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/html_conversion_state.c (html_css_set_selector_style):
	minor change to set to 0 only if needed.

2025-12-20 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/html_converter_finish.c (html_free_converter),
	tta/C/convert/html_prepare_converter.c
	(clear_css_selector_style_list, html_initialize_output_state): replace
	free_css_selector_style_list by clear_css_selector_style_list,
	possibly followed by a free.

	* tta/C/convert/html_prepare_converter.c
	(set_css_selector_style_list_size, html_format_setup)
	(html_initialize_output_state): replace
	initialize_css_selector_style_list by
	set_css_selector_style_list_size, which uses realloc, such as to reuse
	the already allocated memory.

	* tta/C/convert/html_prepare_converter.c (html_format_setup): rename
	css_selector_style as display_preformatted_css_selector_style.

	* tta/perl/XSTexinfo/convert/get_html_perl_info.c
	(html_converter_get_customization_sv): remove unused code.

2025-12-20  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/perl/Texinfo/Convert/LaTeX.pm (_latex_header) <@unnumbered>:
	Do not use \Texinfoplaceholder in the redefinition of
	\Texinfothechapterheading as the former is defined to take an argument,
	leading to an error message "! Argument of \Texinfoplaceholder
	has an extra }.".

2025-12-20 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/html_converter_finish.c (html_reset_converter): set
	some converter variables to NULL after freeing them, such that if
	they are freed again without being set, for example if the setup
	handler failed, there is no error.

	* tta/C/convert/html_converter_finish.c (html_reset_converter)
	(html_free_converter): free tree_to_build.list in html_free_converter
	only, set the number to 0 in html_reset_converter.

2025-12-20 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/t/test_utils.pl (test): verify that both the reference
	error string and the test result string are set before comparing them.

2025-12-20 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/t/test_utils.pl (_convert, convert_to_*): use a function
	for the code common for all the converters.

2025-12-19 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/html_prepare_converter.c (prepare_footnotes_targets):
	reset shared_conversion_state.footnote_number.

	* tta/perl/Makefile.tres, tta/perl/t/z_misc/same_converter_init.t:
	check calling a converter twice.

2025-12-19 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Tests.pm (is_diff), tta/perl/t/test_utils.pl: move
	is_diff to Tests.pm.

2025-12-19 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/convert_html.c (html_free_pending_closes)
	(html_setup_output_simple_page),
	tta/C/convert/html_converter_finish.c (html_free_converter),
	tta/C/convert/html_prepare_converter.c (html_set_pages_files): add
	html_free_pending_closes based on html_free_converter.  Call it before
	allocating pending_closes.

	* tta/C/convert/converter.c (converter_set_document): destroy text
	options, if they are already set, before setting them.

	* tta/C/convert/html_conversion_state.c,
	tta/C/convert/html_prepare_converter.c
	(initialize_css_selector_style_list): move
	initialize_css_selector_style_list to html_prepare_converter.c.

	* tta/C/convert/html_converter_finish.c (html_free_converter),
	tta/C/convert/html_prepare_converter.c (free_css_selector_style_list)
	(initialize_css_selector_style_list): add free_css_selector_style_list
	based on html_free_converter.  Call it before allocating a
	css_selector_style_list.

	* tta/C/convert/html_converter_finish.c (reset_html_targets)
	(html_reset_converter): set list to 0 after free'ing.

	* tta/C/convert/html_prepare_converter.c
	(copy_html_no_arg_command_conversion, html_initialize_output_state):
	free strings before (re)setting them, and set to 0 if not set.

	* tta/C/convert/html_prepare_converter.c
	(html_initialize_output_state): call html_clear_direction_string_type
	on directions_strings type if already set instead of reallocating.

	* tta/C/convert/html_prepare_converter.c
	(html_prepare_conversion_units_targets): clear an existing hashmap
	if there is already one instead of creating a new one.

	* tta/perl/XSTexinfo/convert/get_html_perl_info.c: remove unused
	html_get_directions_strings_sv.

2025-12-19 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Tests.pm (find_dirs_t2a)
	(configure_document_locales),
	tta/perl/t/z_misc/same_parser_multiple_files.t: add, based on
	t/z_misc/same_parser_multiple_files.t code.

2025-12-19 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Tests.pm: change call formatting, use ignore when
	the value is not needed.

2025-12-19 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/convert_html.c (html_conversion_finalization): set
	html_files_information to zero after free'ing.

2025-12-18 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/convert_html.c (html_translate_names),
	tta/C/convert/html_converter_finish.c
	(free_html_no_arg_command_conversion, html_free_converter),
	tta/C/convert/html_prepare_converter.c
	(copy_html_no_arg_command_conversion, html_initialize_output_state),
	tta/C/main/converter_types.h (HTML_NO_ARG_COMMAND_CONVERSION)
	(HTML_NO_ARG_COMMAND_FORMATTING, HTML_NO_ARG_COMMAND_CUSTOMIZATION)
	(CONVERTER), tta/perl/Texinfo/Config.pm
	(_GNUT_initialize_no_arg_commands_formatting_strings)
	(texinfo_register_no_arg_command_formatting),
	tta/perl/Texinfo/Convert/HTML.pm (_translate_names)
	(converter_initialize, converter_destroy, conversion_initialization):
	Do not put translated_to_convert nor translated_tree no arg command
	formatting in the normal context information, instead put it outside
	of the per-context information.

	* tta/C/convert/build_html_perl_info.c
	(build_no_arg_commands_formatting),
	tta/C/convert/build_html_perl_state.c (build_html_translated_names),
	tta/C/convert/convert_html.c
	(reset_unset_no_arg_commands_formatting_context),
	tta/C/convert/format_html.c (html_convert_no_arg_command)
	(html_convert_css_string_for_list_mark),
	tta/perl/Texinfo/Convert/HTML.pm
	(_reset_unset_no_arg_commands_formatting_context),
	tta/perl/XSTexinfo/convert/get_html_perl_info.c
	(html_converter_get_customization_sv): update users of no arg commands
	formatting information, and Perl to C interfaces.

	* tta/perl/XSTexinfo/convert/get_html_perl_info.c: remove unused
	html_get_no_arg_commands_formatting_sv.

2025-12-17 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/HTML.pm: rename $command variable as
	$cmdname when it is used for an @-command name string.  Use $command
	for Texinfo tree elements.

2025-12-15 Patrice Dumas  <pertusus@free.fr>

	* doc/texi2any_api.texi (Command Tree Element Conversion Functions),
	tta/perl/Texinfo/Convert/Converter.pm (Accents conversion): add
	a separate section for the accent tree elements conversion in
	converter using convert_accents.  Refer to the convert_accent
	documentation in the "Command Tree Element Conversion Functions"
	node.

2025-12-15 Patrice Dumas  <pertusus@free.fr>

	* doc/Makefile.am (html_default_commands_args.texi),
	doc/generate_html_doc_texi.pl, tta/perl/Makefile.am
	(perl_commands_source_files): only generate one item for all the
	accent commands in generate_html_doc_texi.pl.  Have
	generate_html_doc_texi.pl depend on Commands.pm for the list of accent
	commands, add Makefile.am code to generate Commands.pm from the doc
	dorectory if needed.

2025-12-16  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/perl/Texinfo/Convert/LaTeX.pm (_latex_header):
	Use \chaptermark and \sectionmark for @unnumbered and
	@unnumberedsec so that the heading is updated.

	Report from Dimitris Papavasilio.

2025-12-15  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/perl/Texinfo/Convert/LaTeX.pm (_latex_header):
	Output use of \newtitlemark to define \Texinfoheadingchaptername
	in a mark.  Otherwise it does not always have the correct value.

	Report from Dimitris Papavasilio.

2025-12-14 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/LaTeX.pm (_latex_header, _convert):
	do not modify \chaptername when reaching the appendix, instead define a
	LaTeX macro \Texinfoheadingchaptername for the headings, set initially
	to \chaptername and reset to \appendixname after reaching the
	appendices.

	* tta/perl/Texinfo/Convert/LaTeX.pm (_convert): use \appendixname if
	the reference is to an appendix sectioning command.  Report from
	Dimitris Papavasilio.

	* tta/perl/Makefile.tres, tta/perl/t/latex_tests.t
	(reference_to_from_appendix): add test of references from chapter to
	appendix and from appendix to chapter.

2025-12-13 Patrice Dumas  <pertusus@free.fr>

	* doc/texi2any_api.texi (Target Tree Element Link): add command_name
	and command_description documentation.

2025-12-13  Gavin Smith <gavinsmith0123@gmail.com>

	* js/info.css: Set "margin: 0px" on all <body> elements, not
	just those with a special class set ("in-iframe").  This prevents
	the text moving to the left shortly after a node is loaded, when
	the margin was changed when the class was added in info.js.  Remove
	all use of .in-iframe class.

2025-12-13  Gavin Smith <gavinsmith0123@gmail.com>

	* js/info.css (div[node]): set "overflow: hidden", as was the
	setting before change on 2021-02-14.  This should not be necessary
	but is an extra way to stop a double scroll bar from appearing.

2025-12-13 Patrice Dumas  <pertusus@free.fr>

	Update libintl-perl to 1.35

2025-12-13  Gavin Smith <gavinsmith0123@gmail.com>

	* js/info.css (iframe.node): Set "display: block".  This is intended
	to prevent a double scroll bar, one for the iframe, one for the
	containing div, by making both elements the same height.

2025-12-13  Gavin Smith <gavinsmith0123@gmail.com>

	* INSTALL.generic: update from gnulib

2025-12-13  Gavin Smith <gavinsmith0123@gmail.com>

	* Makefile.am (po_document-check): exclude another XS file

2025-12-13  Gavin Smith <gavinsmith0123@gmail.com>

	* po/POTFILES.in: add missing files

2025-12-13 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/LaTeX.pm
	(%LaTeX_in_heading_commands_formatting, %section_map)
	(_latex_header): replace "\chaptername{} \thechapter{} " by a LaTeX
	macro, \Texinfothechapterheading{} and redefine the macro when a
	chapter or an appendix is encountered to
	"\chaptername{} \thechapter{}" and to an empty string when unnumbered
	is encountered.  Add the Texinfochapter LaTeX macro for chapter and
	appendix.  Report from Dimitris Papavasiliou.

	* tta/perl/Texinfo/Convert/LaTeX.pm (_convert): call
	\renewcommand{\chaptername}{\appendixname} when reaching the first
	appendix.  Report from Dimitris Papavasiliou.

	* tta/perl/Texinfo/Convert/LaTeX.pm (_prepare_conversion): delete
	appendix_done.

2025-12-13 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/LaTeX.pm (%section_map)
	(%texinfo_unnumbered_macros_toc_latex, _latex_header): generate a
	LaTeX macro definition for each of the unnumbered commands that should
	appear in table of contents.
	Report from Dimitris Papavasiliou.

2025-12-13 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/LaTeX.pm (_latex_header): fix float_type
	setting.  Report from Dimitris Papavasiliou.
	Reindent string.

2025-12-13  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/C/Makefile.am (MAINTAINERCLEANFILES): Add all "multiple outputs"
	stamp files.  This fixes parallel make after "make maintainer-clean".
	Report from Patrice.

2025-12-13  Gavin Smith <gavinsmith0123@gmail.com>

	* README-hacking: add AUTOPOINT=true to autoreconf invocation to
	reduce the risk of making a mess.

2025-12-13  Gavin Smith <gavinsmith0123@gmail.com>

	* NEWS: automake, autoconf, gettext, libtool versions.
	* README-hacking: more on upgrading gettext.

2025-12-12  Gavin Smith <gavinsmith0123@gmail.com>

	* tta: upgrade to gettext 0.26

2025-12-12  Gavin Smith <gavinsmith0123@gmail.com>

	* po, po_document: upgrade to gettext 0.26

2025-12-12  Gavin Smith <gavinsmith0123@gmail.com>

	update gnulib

	* (top level), tta: run gnulib-tool --add-import

2025-12-11  Gavin Smith <gavinsmith0123@gmail.com>

	* update-version.sh: update other configure.ac files automatically.

2025-12-11  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/perl/CheckXS/configure.ac: increase version to 7.2.90.

2025-12-10  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/configure.ac: also bump version here
	* util/pdftexi2dvi: bump version

2025-12-10  Gavin Smith <gavinsmith0123@gmail.com>

	* configure.ac: bump version to 7.2.90.

2025-12-10  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/maintain/change_perl_modules_version.sh:
	Fix path to perl/CheckXS/configure.ac.

2025-12-10  Gavin Smith <gavinsmith0123@gmail.com>

	* util/texi2dvi (make_openout_test, decide_aux_files_method):
	Keep output from tests of \openout and print the last kept output if
	the test failed and we can't run TeX.  This helps the user to
	find out why the test failed, e.g. if they are running with PDFTEX=xetex
	and xetex isn't installed.

2025-12-10  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.texi: Change several gnu.org URLs
	to use https instead of http.

2025-12-10  Gavin Smith <gavinsmith0123@gmail.com>

	* READNE-alpha: use https in link

2025-12-10  Gavin Smith <gavinsmith0123@gmail.com>

	* info/test-infodir: remove subdirectory.

2025-12-10  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/perl/t/layout.t: use https: in value of PACKAGE_URL.

2025-12-10  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/perl/t/40moresectioning.t: use https: in some values
	for TOP_NODE_UP.

2025-12-09  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/C/texi2any.c (main),
	* tta/perl/texi2any.pl:
	Use https:// link in output of texi2any --version.

2025-12-09  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/C/convert/html_prepare_converter.c (html_setup_output),
	* tta/perl/Texinfo/Convert/HTML.pm (_setup_output):
	Use https: in link for GPL license.

2025-12-07 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/LaTeX.pm (_convert): use code to get a
	space if in inner horizontal or vertical mode for sectioning commands,
	not for other commands.  Report from Gavin.

2025-12-07 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/LaTeX.pm (_convert): use code based on
	\ifinner and on Texinfo TeX code for @* in LaTeX to handle all the
	cases in internal horizontal or vertical mode, in particular in page
	headings.  Based on Gavin code.

	* tta/perl/t/converters_tests.t (line_breaks): add @* in more command
	areguments and contexts.

2025-12-06  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Custom Headings): @thispart is implemented for
	LaTeX output.

2025-12-06 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/LaTeX.pm (%section_map, _latex_header):
	define a \texinfopart LaTeX comand ofr @part that uses \part* and
	\addcontentsline.  From Gavin.

	* tta/perl/Texinfo/Convert/LaTeX.pm (_convert): use \texorpdfstring
	for @* if in a heading command.

	* tta/perl/t/latex_tests.t (thispart): also test @* in @part.

2025-12-06  Gavin Smith <gavinsmith0123@gmail.com>

	Fix @* display in header line

	* doc/texinfo.tex (\*): Check if in inner horizontal or vertical
	mode with \ifinner, and if so, output @* as a single space rather
	than trying to break a line.  This fixes display of @* when it
	occurs in a section name in the page heading line.
	(\entryinternal): Remove special override of definition of @*.

2025-12-06 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/format_html.c
	(default_panel_button_dynamic_direction_internal),
	tta/perl/Texinfo/Convert/HTML.pm
	(_default_panel_button_dynamic_direction): add nav-label and nav-link
	span class for dynamic buttons direction string and hyperlink.  Report
	from Raymond Toy.

2025-12-06 Patrice Dumas  <pertusus@free.fr>

	* NEWS, tta/perl/Texinfo/Convert/LaTeX.pm
	(%LaTeX_in_heading_commands_formatting, converter_reset)
	(_prepare_conversion, _latex_header): implement @thispart in LaTeX
	output.

	* tta/perl/Makefile.tres, tta/perl/t/latex_tests.t (thispart): add
	this part test tesing for @thispart.

2025-12-06  Gavin Smith <gavinsmith0123@gmail.com>

	* NEWS,
	* doc/texinfo.texi (Command List, Custom Headings): add @thispart.

2025-12-06  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/data/command_data.txt: Add @thispart.

2025-12-06  Gavin Smith <gavinsmith0123@gmail.com>

	@thispart

	* doc/texinfo.tex (@part):
	Set @thispart, to be used in headings and footings.  Suggestion
	from Werner.

2025-12-06  Gavin Smith <gavinsmith0123@gmail.com>

	@set txilinkindextext

	* doc/texinfo.tex (\indexentry) [pdftex]:
	Only create a link from the index entry text to the referenced
	page if the document contained "@set txilinkindextext".

2025-12-06  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Custom Headings): reorder slightly.

2025-12-06  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Custom Headings) <@thissectionnum>:
	Add example of output to reduce confusion about whether the
	"section number" contains the chapter number.

2025-12-05  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Custom Headings) <@thissection>:
	Change example section number to contain a full stop.
	From Werner Lemberg.

2025-12-03  Gavin Smith <gavinsmith0123@gmail.com>

	Set 'nav-panel' class on <p> element.

	* tta/C/convert/format_html.c (html_default_format_navigation_panel),
	* tta/perl/Texinfo/Convert/HTML.pm (_default_format_navigation_panel):
	Remove <div> surrounding navigation bar and set 'nav-panel' class
	on <p> element.  This is intended to make it easier to customize
	the style of the navigation bar with CSS.

2025-12-03  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/data/default_css_element_class_styles.csv (span.nav-button):
	Remove 'white-space: nowrap' as it is up to the user if they want
	this for their HTML output.

2025-11-29 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/customization_options.c
	(html_new_button_specification_info)
	(html_new_button_specification_list): rename
	new_button_specification_info as html_new_button_specification_info
	and new_button_specification_list as
	html_new_button_specification_list.  Update callers.

2025-11-29 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/customization_options.c
	(new_button_specification_info, new_button_specification_list),
	tta/C/main/create_buttons.c: move new_button_specification_info and
	new_button_specification_list to customization_options.c.

	* tta/C/Makefile.am (C_libtexinfo_sources): remove create_buttons.c
	and create_buttons.h.

2025-11-29 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/customization_options.c
	(html_free_button_specification_list, html_clear_direction_icons)
	(html_free_direction_icons), tta/C/main/utils.c: move functions
	freeing direction icons and buttons to customization options file.

2025-11-29 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/html_converter_init_options.c
	(enum BUTTON_special_unit_directions, buttons_special_units_names)
	(new_button_specification, new_special_unit_direction_button)
	(new_base_navigation_buttons, new_base_links_buttons)
	(new_base_navigation_section_buttons)
	(new_base_navigation_section_footer_buttons)
	(new_directions_list_buttons_specifications),
	tta/C/main/create_buttons.c: move functions creating specifc button
	lists to html_converter_init_options.c, as well as associated
	static function and data.

2025-11-29 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/html_converter_init_options.c: remove unused
	set_option_buttons_specification,
	set_html_default_buttons_specifications and
	set_texi2html_default_buttons_specifications.

	* tta/C/main/create_buttons.c (new_button_specification): declare
	static.

2025-11-29 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/format_html.c (html_standard_label_id_file): get
	BASEFILENAME_LENGTH from txi_base_options since it is a default
	converter option and is not set as an HTML converter default option.

2025-11-29  Gavin Smith <gavinsmith0123@gmail.com>

	Allow running uninstalled texi2any with a symbolic link

	* tta/perl/texi2any.pl: If loading Texinfo::ModulePath failed and
	$0 is a symbolic link, dereference the symbolic link and try again.

	* tta/perl/Texinfo/ModulePath.pm.in: dereference $0 if the file
	is a symbolic link.  Add "use strict" to module.

2025-11-29 Patrice Dumas  <pertusus@free.fr>

	Do not allow wrapping inside an HTML button

	* tta/data/default_css_element_class_styles.csv (span.nav-button):
	set navigation button white-space: nowrap, such that the button is not
	split on two lines on small screens.  Report by Raymond Toy and idea
	by Per Bothner.

2025-11-29 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/t/z_misc/no_structure_test.t (_do_format_test_file),
	tta/perl/t/z_misc/same_parser_multiple_files.t (_do_format_test_file):
	do not check the test result if $arg_generate is set and the test
	result is regenerated.

2025-11-29 Patrice Dumas  <pertusus@free.fr>

	Add a span for HTML navigation buttons not in table

	* tta/C/convert/format_html.c (html_default_format_navigation_panel),
	tta/perl/Texinfo/Convert/HTML.pm (_default_format_navigation_panel):
	add a span with nav-button class for each button.  Report by Raymond
	Toy.

	* tta/C/convert/format_html.c (html_default_format_button): do not
	return an empty string but NULL if button_text is NULL.

	* tta/C/convert/html_prepare_converter.c
	(html_set_main_units_direction_names): reindent.

2025-11-27 Patrice Dumas  <pertusus@free.fr>

	* doc/texi2any_api.texi: update.

	Changes in comments and Pod.

2025-11-26  Gavin Smith <gavinsmith0123@gmail.com>

	* NEWS (texi2any): mention you can turn off redirection files with
	--transliterate-file-names by giving --no-node-files.

2025-11-26 Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.texi (Invoking @command{texi2any}): rewrite and addition
	to --transliterate-file-names option description, adding the
	information that it does not affect redirection files, and that it is
	recommended to do redirection files in that case.

2025-11-25 Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.texi (Invoking @command{texi2any}): explain that
	transliteration is also done for sectioning commands file names, and
	sectioning commands identifiers if --transliterate-file-names is set.
	Also say that the transliterated names obtained are platform
	and processor dependent.

2025-11-25 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/utils.c (encode_with_iconv, encode_string): add an
	argument, if set encoding errors are not reported from
	encode_with_iconv.  Update callers.

	* tta/C/main/node_name_normalization.c (unicode_to_transliterate):
	silence transliteration errors.  Transliterations should only be used
	for internal identifiers.  Report from Gavin.

2025-11-25 Patrice Dumas  <pertusus@free.fr>

	Do not transliterate section command identifier by default

	* tta/C/main/node_name_normalization.c
	(convert_contents_to_node_identifier, convert_to_node_identifier)
	(convert_to_identifier),
	tta/perl/Texinfo/Convert/NodeNameNormalization.pm
	(convert_to_node_identifier, convert_to_identifier): rename
	convert_to_identifier as convert_to_node_identifier.  Readd
	convert_to_identifier that does the same as convert_to_node_identifier
	except for the normaization of top in name.  Update callers except for
	abbr or acronym first argument that uses convert_to_identifier.

	* tta/C/convert/converter.c (normalized_sectioning_command_filename),
	tta/perl/Texinfo/Convert/Converter.pm
	(normalized_sectioning_command_filename): transliterate sectioning
	command identifier only if TRANSLITERATE_FILE_NAMES is set.

	* tta/perl/t/30sectioning.t (in_menu_only_special_spaces_node_menu)
	(in_menu_only_special_spaces_node_menu_transliterate)
	(reference_to_only_special_spaces_node)
	(reference_to_only_special_spaces_node_transliterate),
	tta/perl/t/40moresectioning.t (only_special_spaces_node)
	(only_special_spaces_node_transliterate),
	tta/perl/t/converters_tests.t ($some_at_commands_in_ref_nodes_text)
	(some_at_commands_in_ref_nodes)
	(some_at_commands_in_ref_nodes_transliterate),
	tta/perl/t/formats_encodings.t (japanese_shift_jis),
	tta/perl/Makefile.tres: add tests with TRANSLITERATE_FILE_NAMES set.
	Explicitely set TRANSLITERATE_FILE_NAMES more.

	* tta/tests/many_input_files/different_encodings.sh: add
	--transliterate-file-name to the test command-line.

2025-11-25 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/Utils.pm (definition_category_tree): update
	TRANSLATORS description again to match spacing of the other
	TRANSLATORS description.

	update po files.

2025-11-25 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/convert_utils.c (definition_category_tree),
	tta/perl/Texinfo/Convert/Utils.pm (definition_category_tree): replace
	name with category in TRANSLATORS description.  Report by Gavin.

2025-11-25 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/texinfo.c (txi_reset_converter),
	(txi_destroy_converter), tta/perl/Texinfo/Convert/Converter.pm
	(destroy_converter), tta/perl/Texinfo/Convert/Text.pm
	(destroy_converter), tta/perl/XSTexinfo/convert/ConvertXS.xs
	(destroy_converter): rename destroy in Converter.pm, Text.pm and
	ConvertXS.xs as destroy_converter.  Rename txi_converter_reset as
	txi_reset_converter.  Rename txi_converter_destroy as
	txi_destroy_converter.  Update callers.

	* tta/C/convert/call_conversion_perl.c
	(call_object_reset_perl_converter), tta/C/convert/texinfo.c
	(txi_reset_converter), tta/perl/Texinfo/Convert/Converter.pm
	(%XS_overrides, reset_converter, reset_perl_converter)
	(destroy_converter), tta/perl/Texinfo/Convert/Text.pm (%XS_overrides),
	tta/perl/XSTexinfo/convert/ConvertXS.xs (reset_converter)
	(destroy_converter, destroy_text_converter): use reset_converter and
	destroy_converter functions for the XS interface and call Perl
	converter reset and release code from the XS interface instead of
	calling the C code from Perl through specific XS interface functions.
	Move reset_perl_converter out of reset_converter and call
	reset_perl_converter from C.  Rename call_object_reset_converter as
	call_object_reset_perl_converter.  Consistently, always call
	reset_converter in txi_reset_converter.  Call
	call_object_reset_perl_converter from reset_converter in ConvertXS.xs
	and call call_object_converter_perl_release from destroy_converter in
	ConvertXS.xs.  Remove _XS_reset_converter and _XS_destroy.  Add a new
	XS interface for Texinfo::Convert::Text , destroy_text_converter since
	there is no converter_perl_release function nor call to
	call_object_converter_perl_release for the Text converter.

	* tta/perl/Texinfo/Convert/Converter.pm (converter_perl_release): call
	format-specific converter_destroy before generic converter code.

2025-11-25  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.tex (\doindexinitialentry) [pdfTeX]:
	Do not break if passed an empty argument.
	Report from Rik <rik@octave.org>.

2025-11-23  Gavin Smith <gavinsmith0123@gmail.com>

	* README-hacking: update path to valgrind suppressions file when
	running tests from tta/perl.

2025-11-23  Gavin Smith <gavinsmith0123@gmail.com>

	* info/man.c (get_manpage_from_formatter): cast return value
	of get_output_from_program to void to indicate it is being ignored.

2025-11-22  Gavin Smith <gavinsmith0123@gmail.com>

	Fix Info memory errors after signals

	* info/window.c (window_make_modeline),
	* info/footnotes.c (info_get_or_remove_footnotes):
	Add check if 'node' field of WINDOW argument is null.

	* info/window.c (window_new_screen_size, window_make_window):
	Allocate modeline with xzalloc rather than xmalloc so that the
	memory will be initiailised.

	There were occasional memory errors when a signal was sent to Info
	in the redisplay code if these data structures were not initialised.
	I obtained this unreliably under valgrind monitoring with
	"TEXINFO_INFO_TESTS_TIMEOUT=2 t/resize-in-completions.sh".

2025-11-22  Gavin Smith <gavinsmith0123@gmail.com>

	fix "make distcheck" with TEXINFO_XS=required.

	* Pod-Simple-Texinfo/Makefile.am (AM_TESTS_ENVIRONMENT):
	Set t2a_srcdir and t2a_builddir as is done in tta/tests/Makefile.am.
	Otherwise the tests fail under TEXINFO_XS=required.

2025-11-18 Patrice Dumas  <pertusus@free.fr>

	* tta/C/Makefile.am (AM_CFLAGS, ctexi2any_CFLAGS)
	(teximakehtml_CFLAGS): set AM_CFLAGS to the value used for libraries.

	* tta/C/Makefile.am (teximakehtml_LDADD): add Gnulib dependencies to
	LDADD.

	* tta/perl/XSTexinfo/Makefile.am (AM_CFLAGS, AM_LDFLAGS): set and
	remove now unneeded per library variables.

2025-11-18 Patrice Dumas  <pertusus@free.fr>

	* tta/m4/txi_embedded_perl.m4: set CPPFLAGS and use same LDFLAGS as
	used in compilation.

	* tta/C/Makefile.am: simplify code now that flags are more
	homogeneous.

2025-11-18 Patrice Dumas  <pertusus@free.fr>

	* tta/m4/txi_perl_conf.m4 (perl_conf_LIB_LDFLAGS)
	(perl_conf_LDFLAGS), tta/C/Makefile.am (AM_LDFLAGS), tta/configure.ac
	(LDFLAGS): rename perl_conf_LDFLAGS as perl_conf_LIB_LDFLAGS and readd
	perl_conf_LDFLAGS with Perl config ldflags only.  Use
	perl_conf_LDFLAGS in tta/configure.ac checks if enable_xs and use
	perl_conf_LDFLAGS for AM_LDFLAGS, which is used by executable.

2025-11-18  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/configure.ac: add comment before call to txi_PERL_CONF
	listing the variables it sets to make it easier to track the origin
	of these variables.

2025-11-17 Patrice Dumas  <pertusus@free.fr>

	* tta/m4/txi_perl_conf.m4 (perl_conf_CFLAGS): rename
	perl_conf_EMBED_CFLAGS as perl_conf_CFLAGS.

	* tta/configure.ac (CFLAGS), tta/C/Makefile.am (AM_CFLAGS): use
	perl_conf_CFLAGS for configure tests, even when Perl headers are not
	compiled and set AM_CFLAGS to perl_conf_CFLAGS such that the flags are
	used for the libraries not compiled against Perl headers.  This is
	because those flags are already used for executables and we need
	consistency between configure flags and compile flags.

2025-11-17 Patrice Dumas  <pertusus@free.fr>

	* tta/m4/txi_embedded_perl.m4 (CFLAGS): use perl_conf_CPPFLAGS and
	perl_conf_EMBED_CFLAGS instead of PERL_EXTUTILS_EMBED_ccopts.

2025-11-16 Patrice Dumas  <pertusus@free.fr>

	* tta/m4/txi_perl_conf.m4 (perl_conf_LIB_CFLAGS),
	(perl_conf_EMBED_LIB_CFLAGS), tta/C/Makefile.am
	(*_la_CFLAGS), tta/perl/CheckXS/Makefile.am (TestXS_la_CFLAGS),
	tta/perl/XSTexinfo/Makefile.am (XSLIBS_CFLAGS),
	tta/swig/perl/Makefile.am (Texinfo_la_CFLAGS): rename perl_conf_CFLAGS
	as perl_conf_LIB_CFLAGS and perl_conf_EMBED_CFLAGS as
	perl_conf_EMBED_LIB_CFLAGS as those two variables should be used for
	libraries only.

	* tta/m4/txi_perl_conf.m4 (perl_conf_EMBED_CFLAGS), tta/C/Makefile.am
	(libperlembed_libtexinfo_main_la_CPPFLAGS)
	(libperlembed_libtexinfo_main_la_CFLAGS, ctexi2any_CFLAGS): add
	perl_conf_EMBED_CFLAGS with the CFLAGS part of
	PERL_EXTUTILS_EMBED_ccopts, corresponding to $PERL_CONF_ccflags, and
	use that both for ctexi2any CFLAGS and
	libperlembed_libtexinfo_main_la_CFLAGS.  The CPPFLAGS/perl_inc part is
	perl_conf_CPPFLAGS, add it to
	libperlembed_libtexinfo_main_la_CPPFLAGS, but not to ctexi2any
	CPPFLAGS.  Gavin idea.

2025-11-16 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/tree_types.h (INDEX), tta/C/parsetexi/indices.c
	(add_index_internal), tta/swig/texinfo.i: remove prefix field from
	INDEX, it is not used nor useful.

2025-11-15 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Structuring.pm, tta/perl/Texinfo/ParserNonXS.pm:
	change in POD related to relations.

2025-11-15 Patrice Dumas  <pertusus@free.fr>

	* tta/m4/txi_embedded_perl.m4: save and restore CFLAGS and LDFLAGS
	instead of leaving them set at the end of the macro call.

2025-11-15 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/get_converter_perl_info.c
	(convert_element_options_sv_to_text),
	tta/perl/XSTexinfo/convert/ConvertXS.xs (text_convert_tree): add
	convert_element_options_sv_to_text based on code removed from
	text_convert_tree.

2025-11-15  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/m4/txi_libperl_link.m4:
	Save and restore CFLAGS, CPPFLAGS and LDFLAGS to original rather than
	hardcoding expressions to restore them to.

2025-11-12  Gavin Smith <gavinsmith0123@gmail.com>

	* info/filesys.c (filesys_error_string): Allocate result with
	asprintf rather than keeping an internal buffer.

2025-11-12  Gavin Smith <gavinsmith0123@gmail.com>

	* info/infodoc.c (function_name): declare as const.

2025-11-11  Gavin Smith <gavinsmith0123@gmail.com>

	const for Info
	
	* info/infodoc.c (function_documentation, replace_in_documentation):
	Declare return value as const char *.

2025-11-11 Patrice Dumas  <pertusus@free.fr>

	* info/infodoc.c (create_internal_info_help_node): fix conditional to
	use where_is_exec_cmd when setting exec_keys.

	* info/dir.c (get_dir_node): remove unused variable in functionad
	nunused dir_contents static variable.

2025-11-11  Gavin Smith <gavinsmith0123@gmail.com>

	const for Info

	* info/infodoc.c (pretty_keyseq, where_is, where_is_internal):
	Return const char *.
	(pretty_keyseq_ext): Wrapper to pretty_keyseq to allow safely
	appending a '-' character to the result.

	* info/session.c (display_info_keyseq): Use pretty_keyseq_ext.

2025-11-11  Gavin Smith <gavinsmith0123@gmail.com>

	* info/infodoc.c, info/window.c (create_internal_info_help_node):
	Move to window.c.  Declare in window.h rather than session.h.

2025-11-11  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/info-stnd.texi (Invoking Info): document new index lookup
	behaviour.

2025-11-11  Gavin Smith <gavinsmith0123@gmail.com>

	* NEWS: mention change to index lookup for "info TOPIC INDEX-ENTRY".

2025-11-11 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/Converter.pm (comment_or_end_line): rename
	comment_or_end_line_nonxs as comment_or_end_line.  Update callers.

	* tta/perl/Texinfo/Example/TreeElementConverter.pm
	(tree_element_comment_or_end_line): merge
	with tree_element_comment_or_end_line_nonxs, remove
	tree_element_comment_or_end_line_nonxs.

2025-11-10 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/tree_types.h (NAMED_STRING_ELEMENT)
	(NAMED_STRING_ELEMENT_LIST), tta/C/main/translations.h: move
	NAMED_STRING_ELEMENT and NAMED_STRING_ELEMENT_LIST to tree_types.h.

2025-11-10 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/get_perl_info.c,
	tta/C/tree_elements/get_perl_tree_elements.c
	(get_lang_translations_sv, get_replaced_substrings): move to
	get_perl_tree_elements.c.

	* tta/perl/Texinfo/Example/TreeElementConverter.pm (%XS_overrides)
	(build_element_tree),
	tta/perl/Texinfo/Example/TreeElementReadDocBook.pm (_convert),
	tta/perl/Texinfo/Translations.pm (_substitute_element_array),
	tta/perl/XSTexinfo/parser_document/DocumentXS.xs (build_tree),
	tta/perl/XSTexinfo/reader_element/TreeElementConverterXS.xs
	(build_element_tree): add build_element_tree based on
	DocumentXS.xs build_tree, corresponding to building a tree based on a
	tree element with a handle and remove the corresponding code from
	build_tree.  Call build_element_tree in TreeElementReadDocBook.pm.
	Building a tree from a root element is still in build_tree.
	Modify Translations.pm _substitute_element_array to check for
	root element only before calling build_tree.

2025-11-10  Gavin Smith <gavinsmith0123@gmail.com>

	* util/htmlxref.d/Texinfo_GNU.cnf: update 'stabs', 'groff'.
	From Thérèse Godefroy <godef.th@free.fr>.

2025-11-08  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.texi
	(Inserting Math, Info and Plaintext Customization Variables),
	* NEWS: mark INFO_MATH_IMAGES as experimental

	* doc/texinfo.texi (Info Format Image): document 'dpi' and 'depth'.
	Explain possible image scaling formula.

2025-11-08  Gavin Smith <gavinsmith0123@gmail.com>

	Output image baseline depth for INFO_MATH_IMAGES

	* tta/perl/Texinfo/Convert/LaTeX.pm (convert_math_to_images):
	Pass --depth option to dvipng and extract depth from command output.
	* tta/perl/Texinfo/Convert/Plaintext.pm (_insert_image)
	(_convert) [INFO_MATH_IMAGES],
	* tta/perl/Texinfo/Convert/Info.pm (format_image):
	output 'depth' value for @math.

2025-11-08  Gavin Smith <gavinsmith0123@gmail.com>

	Output DPI setting for INFO_MATH_IMAGES

	* tta/perl/Texinfo/Convert/LaTeX.pm (convert_math_to_images):
	Save and return DPI setting used for call to 'dvipng'.
	* tta/perl/Texinfo/Convert/Plaintext.pm (_insert_image)
	(_convert) [INFO_MATH_IMAGES],
	* tta/perl/Texinfo/Convert/Info.pm (format_image):
	Output dpi setting in Info file as 'dpi' attribute on image directive.

2025-11-04 Patrice Dumas  <pertusus@free.fr>

	* tta/C/swig/swig_parser_api.c
	(txi_ext_parser_conf_set_MAX_MACRO_CALL_NESTING): do not return
	anything.

2025-11-04 Patrice Dumas  <pertusus@free.fr>

	Separate C code related to "tree elements" interface only

	* tta/C/Makefile.am (libtexinfo_convertxs_la_SOURCES),
	tta/perl/XSTexinfo/Makefile.am (TreeElementXS_la_CPPFLAGS)
	(TreeElementConverterXS_la_CPPFLAGS, ReaderXS_la_CPPFLAGS),
	tta/C/main/build_perl_info.c (build_new_base_element, document_tree),
	tta/C/main/get_perl_info.c, tta/perl/Texinfo/Document.pm
	(%XS_structure_overrides),
	tta/perl/Texinfo/Example/TreeElementConverter.pm (%XS_overrides)
	(register_document_relations_lists_elements),
	tta/perl/XSTexinfo/reader_element/TreeElementConverterXS.xs
	(register_document_relations_lists_elements),
	tta/C/tree_elements/build_perl_tree_elements.c
	(register_sv_element_handle_in_sv, register_element_handle_in_sv)
	(build_element_attribute, register_document_sections_list_elements)
	(register_document_nodes_list_elementsr)
	(register_document_headings_list_elements)
	(register_document_relations_lists_elements)
	(build_tree_elements_relations_lists)
	(build_tree_elements_sections_list, build_tree_elements_nodes_list)
	(build_tree_elements_headings_list),
	tta/C/tree_elements/get_perl_tree_elements.c (get_sv_reader_reader)
	(new_element_from_sv): move code needed by the tree element interface
	only to the tree_elements directory.  Move build_element_attribute,
	register_document_sections_list_elements,
	register_document_nodes_list_elements,
	register_document_headings_list_elements,
	register_document_relations_lists_elements,
	build_tree_elements_relations_lists,
	build_tree_elements_sections_list, build_tree_elements_nodes_list,
	build_tree_elements_headings_list, register_element_handle_in_sv and
	register_sv_element_handle_in_sv to
	tree_elements/build_perl_tree_elements.c.  Move get_sv_reader_reader
	and new_element_from_sv to tree_elements/get_perl_tree_elements.c.
	Add build_new_base_element to build_perl_info.c to replace the little
	bit of code still needed in document_tree and in other codes.  Move
	register_document_sections_list_elements to TreeElementConverterXS.xs.

	* tta/C/main/utils.c (get_check_element_interpreter_refcount): allow
	check_element_interpreter_refcount to be < 0, such as to avoid
	refcount error messages to be output if
	unset_check_element_interpreter_refcount is called.

	* tta/C/main/document.c (setup_texinfo_main),
	tta/perl/Texinfo/Document.pm (remove_document_references),
	tta/perl/Texinfo/ManipulateTree.pm (_element_remove_references)
	(tree_remove_references): if the environment variable
	TEXINFO_SILENT_REFCOUNT is set to 1 do not warn if Perl refcounts are
	not correct.  This is not documented because it should only be useful
	for the tests, in practice, for now, to be able to test
	Texinfo::Example::ReadDocBook.

	* tta/perl/Texinfo/Example/TreeElementConverter.pm
	(_tree_element_xml_numeric_entities_accent): fix duplicate $self in
	xml_accent call.

	* tta/perl/XSTexinfo/reader_element/TreeElementConverterXS.xs
	(global_commands_information_command_list): do not retain a reference
	on output Perl list.

	* tta/perl/Texinfo/Example/ReadDocBook.pm (%ignored_block_commands)
	(conversion_output_begin, _format_comment)
	(_convert_argument_and_end_line, _convert),
	tta/perl/Texinfo/Example/TreeElementReadDocBook.pm
	(%ignored_block_commands, conversion_output_begin, _format_comment)
	(_convert_argument_and_end_line, _convert): update for new commands
	related to @documentinfo, removal of enumerate_specification
	attribute, change in comment Texinfo tree.

2025-11-02 Patrice Dumas  <pertusus@free.fr>

	* tta/Texinfo/Example/TestReader.pm,
	tta/Texinfo/Example/TreeElementConverter.pm,
	tta/Texinfo/Example/TreeElementConverterXS.pm, doc/tta_api/Makefile.am
	(texi2any_internals_dependencies), tta/perl/Makefile.am
	(dist_convertmodules_DATA), tta/README,
	tta/perl/XSTexinfo/reader_element/TreeElementConverterXS.xs (MODULE)
	(PACKAGE), tta/perl/texi2any.pl (%formats_table): move TestReader.pm,
	TreeElementConverter.pm and TreeElementConverterXS.pm to
	Texinfo/Example/.

2025-11-04  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/perl/Texinfo/Convert/LaTeX.pm (convert_math_to_images):
	Use \setlength to remove space above display environment.  This
	space is provided in the Info file by a blank line, so no
	extra space is needed in the image.

2025-11-04  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/perl/Texinfo/Convert/LaTeX.pm (convert_math_to_images):
	Provide 'fleqn' option to \documentclass in order to align
	contents of @displaymath to the left.  Otherwise they can
	be way too far to the right and even off the edge of the window.

2025-11-04  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/perl/Texinfo/Convert/LaTeX.pm (convert_math_to_images):
	Reduce DPI of images from 600 to 180.

2025-11-04  Gavin Smith <gavinsmith0123@gmail.com>

	* NEWS: mention INFO_MATH_IMAGES
	* doc/texinfo.texi
	(Inserting Math, Info and Plaintext Customization Variables):
	document INFO_MATH_IMAGES.

2025-11-01 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/t/z_misc/*.t, tta/perl/texi2any.pl: comment out Data::Dumper
	related code when Data::Dumper is not actually used.

2025-11-01 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/HTML.pm (_prepare_css): minor change to
	clarify code.

2025-11-01 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/ParserNonXS.pm (_end_line): do not use TEST
	customization variable value in Parser, as it is never set.

2025-11-01 Patrice Dumas  <pertusus@free.fr>

	* NEWS: document that texi2any keeps input file name leading directory
	components in messages again.

2025-11-01 Patrice Dumas  <pertusus@free.fr>

	Use full input file paths in source info for error messages

	* tta/C/parsetexi/input.c (INPUT, next_text, input_push_file),
	tta/perl/Texinfo/ParserNonXS.pm (_input_push_file, parse_texi_file)
	(_next_text): use the full input file path as source info file name.
	Remove input_file_path firld from INPUT.  In Perl, do not have
	_input_push_file return the directories and file name, instead call
	fileparse in parse_texi_file.  Update callers.
	Report from Tom Tromey, some analysis by Gavin.

2025-11-01 Patrice Dumas  <pertusus@free.fr>

	Use simple text for conversion errors representation in tests

	* tta/perl/t/test_utils.pl (test): use errors_print_details to print
	conversion errors as simple text instead of Data::Dumper.

2025-11-01 Patrice Dumas  <pertusus@free.fr>

	Use simple text for parsing and structuring errors in tests

	* tta/C/main/errors.c (print_source_info_details),
	tta/C/main/manipulate_tree.c (print_element_details),
	tta/perl/Texinfo/ManipulateTree.pm (print_element_base),
	tta/perl/Texinfo/Report.pm (print_source_info_details): move code
	printing a source info to print_source_info_details and to errors.c or
	Report.pm.  Inline the remaining code from print_element_source_info
	to print_element_details or print_element_base. Remove
	print_element_source_info.

	* tta/perl/Texinfo/Report.pm (_print_error_details)
	(errors_print_details): add.

	* tta/perl/t/test_utils.pl (test): use errors_print_details to print
	errors as simple text instead of Data::Dumper.

2025-10-30 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Makefile.tres: update.

2025-10-30 Patrice Dumas  <pertusus@free.fr>

	* contrib/perldoc-all/GNUmakefile: remove the dist-hook target, which
	should not be used anymore since the contrib directory is not
	distributed.

2025-10-30 Patrice Dumas  <pertusus@free.fr>

	* contrib/perldoc-all/GNUmakefile (clean, maintainer-clean): add.

2025-10-30 Patrice Dumas  <pertusus@free.fr>

	* contrib/perldoc-all/README: explain that Perl needs to be built to
	have autogenerated Pod file available.

	* contrib/perldoc-all/perldoc-all.texi: add @titlepage, remove
	@setfilename, remove @ifnottex, update urls and comment out obsolete
	information.

2025-10-30 Patrice Dumas  <pertusus@free.fr>

	* contrib/perldoc-all/GNUmakefile: use gendocs and gendocs_templates
	from gnulib directory supposed to be along the texinfo directory, as
	done in doc/.

2025-10-27 Patrice Dumas  <pertusus@free.fr>

	* tta/swig/texinfo.i (FORMATTED_ERROR_MESSAGE): do not include
	swig_error_messages_types.h whole, only FORMATTED_ERROR_MESSAGE
	and the fields already used in codes.

	* tta/swig/texinfo.i (valid_documentlanguage): add.

	* tta/swig/perl/t/20index_sort.t: rename $parser to $swig_parser for
	the parser generated from the SWIG interface.

2025-10-26 Patrice Dumas  <pertusus@free.fr>

	* tta/C/swig/swig_interface.c
	(txi_ext_get_error_messages_list_messages): make extern.

	* tta/C/swig/swig_parser_api.c
	(txi_ext_parser_conf_get_INCLUDE_DIRECTORIES): add.

	* tta/swig/texinfo.i (TXI_EXT_ELEMENT_FORMATTED_ERRORS)
	(expand_verbatiminclude, destroy_element_formatted_errors): add.

2025-10-26 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/convert_utils.c (expand_verbatiminclude)
	(converter_expand_verbatiminclude), tta/perl/Texinfo/Convert/Utils.pm
	(expand_verbatiminclude),
	tta/perl/XSTexinfo/reader_element/TreeElementConverterXS.xs
	(utils_tree_element_expand_verbatiminclude): change order of
	arguments, to have more importants arguments first.  Update callers.

2025-10-28  Gavin Smith <gavinsmith0123@gmail.com>

	Fix echo area crash

	* info/display.c (printed_representation): Fix representation
	of tab when the line would be greater than 255 characters.  This
	fixes a crash in the echo area when holding down tab, for example
	in "M-x menu-sequence".
	
	Report from Aidan <aidanczhai@gmail.com>.

2025-10-26  Gavin Smith <gavinsmith0123@gmail.com>

	Remove ADD_TRANSLITERATED_REDIRECTION_FILES

	* tta/data/options_data.txt (ADD_TRANSLITERATED_REDIRECTION_FILES):
	Remove.
	* tta/C/convert/convert_html.c (html_node_redirections),
	* tta/perl/Texinfo/Convert/HTML.pm (_node_redirections):
	Remove code handling ADD_TRANSLITERATED_REDIRECTION_FILES.

	* tta/perl/t/html_tests.t (set_add_transliterated_redirection_files):
	remove test.
	* NEWS, doc/texinfo.texi (HTML Output Structure Customization): update.
	
	Users can get nearly the same effect as this variable by setting
	TRANSLITERATE_FILE_NAMES.

2025-10-25  Gavin Smith <gavinsmith0123@gmail.com>

	Fix float labels containing _

	* doc/texinfo.tex (\dofloat): Fix call to \setref not to
	expand float label.  This prevents premature expansion in case
	the label contains an underscore.  Report and investigation by
	Andreas Metzler and Hilmar Preuße.

2025-10-18 Patrice Dumas  <pertusus@free.fr>

	* util/htmlxref.d/Texinfo_GNU.cnf (aspell): remove index.html since
	the manual is split at section.  Report from Eli Zaretskii.

2025-09-28 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/XSTexinfo/convert/ConvertXS.xs
	(count_elements_in_filename_type_names),
	tta/C/convert/html_conversion_state.c: move
	count_elements_in_filename_type_names definition to ConvertXS.xs since
	it is only used there.

2025-09-28 Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.texi (Syntax Highlighting): use @table @code again and
	remove a wrong space.

	* TODO: remove done item on source highlighting.

2025-09-28 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/converter.h, tta/C/convert/html_prepare_converter.c
	(default_special_unit_varieties): declare
	default_special_unit_varieties in html_prepare_converter.c now that it
	is only used in that file.

2025-09-28 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/html_converter_api.c (html_converter_initialize),
	tta/C/convert/html_prepare_converter.c
	(html_converter_init_special_unit_varieties)
	(html_converter_init_special_units_info),
	tta/perl/XSTexinfo/convert/ConvertXS.xs
	(html_converter_get_customization_sv),
	tta/perl/XSTexinfo/convert/get_html_perl_info.c
	(html_converter_init_special_unit_sv): split
	html_converter_init_special_unit in two, with
	html_converter_init_special_unit_varieties that sets up the special
	units variety names, and html_converter_init_special_units_info that
	setup special units varieties information.  That way, the
	customization information can be setup after special units variety
	names have been set up, in html_converter_get_customization_sv.
	This also avoids the need to access default_special_unit_varieties in
	get_html_perl_info.c.

2025-09-20  Gavin Smith <gavinsmith0123@gmail.com>

	* TODO: remove done items: @documentinfo, use of <table> for
	index formatting.

2025-09-12 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/ext/highlight_syntax.pm (highlight_process): concatenate
	with language for 'highlight' and 'pygments' instead of using the %l
	placeholder, for efficiency.

2025-09-18  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Syntax Highlighting): edit
	* NEWS: edit announcement for HIGHLIGHT_SYNTAX

2025-09-17  Gavin Smith <gavinsmith0123@gmail.com>

	Use %l placeholder in value of HIGHLIGHT_SYNTAX

	* tta/perl/ext/highlight_syntax.pm (_substitute_language): New
	function.
	(highlight_process): Call _substitute_language in order to substitute
	%l with the "language" for syntax highlighting, rather than
	postpending the language.

2025-09-12 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/ext/highlight_syntax.pm (highlight_setup, _get_language):
	do not map language names.  If a mapping is needed, the user could
	use wrappers and do the mapping in the wrapper.

	* tta/tests/other/highlight_example.texi,
	tta/tests/other/list-of-tests: use languages names that do not need
	to be mapped.

2025-09-12 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/ext/highlight_syntax.pm (highlight_process): chomp error
	lines coming from the highlighting program stderr before feeding them
	to converter_document_error.

2025-09-12 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/ext/highlight_syntax.pm (_get_language): remove $cmdname
	argument, get it from the Texinfo tree element.  Update callers.

	* tta/perl/ext/highlight_syntax.pm (%highlighted_cmds): rename
	%commands and %highlighted_cmds.

	* tta/perl/ext/highlight_syntax.pm: add comments.

2025-09-12 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/ext/highlight_syntax.pm (highlight_process): rename
	@highlighted_commands as @highlighted_commands_names.

	* tta/perl/ext/highlight_syntax.pm (_add_command_language)
	(highlight_process): separate better the 'source-highlight' case from
	the other cases.  Indeed, the other cases do not need to collect
	per-language information.

2025-09-12 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/ext/highlight_syntax.pm (highlight_process): check earlier
	that HIGHLIGHT_SYNTAX is set.  Put tree elements only in languages
	'commands' array.

2025-09-12 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/ext/highlight_syntax.pm (highlight_process): increase
	input_languages_counters key value for each collected command.

2025-09-13  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/perl/ext/highlight_syntax.pm (highlight_setup):
	Correct comment.

2025-09-13  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/perl/ext/highlight_syntax.pm (highlight_setup):
	Add comment saying what this function does.

2025-09-12 Patrice Dumas  <pertusus@free.fr>

	HIGHLIGHT_SYNTAX value used as command-line

	* NEWS, doc/texinfo.texi (Syntax Highlighting)
	(HTML Customization Variables List), tta/perl/ext/highlight_syntax.pm
	($highlighted_languages_list, highlight_setup, _get_language)
	(highlight_process): make $highlighted_languages_list a reference on a
	hash, and if undef, do not check the language.  If the
	HIGHLIGHT_SYNTAX value is not a specific program, concatenate the
	value to the highlighted language name to generate the command-line
	used for highlighting.  Update documentation.

2025-09-10 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/ext/highlight_syntax.pm (_convert_element): copy and modify
	contents as an array first.

	* tta/perl/ext/highlight_syntax.pm (highlight_process): put file
	argument last on command line.

	* tta/perl/ext/highlight_syntax.pm: use exists or defined in
	conditions when the value is not used.  Change formatting of functions
	call code.  Change in spacing.

2025-09-07 Patrice Dumas  <pertusus@free.fr>

	* tta/C/parsetexi/separator.c (handle_close_brace),
	tta/perl/Texinfo/ParserNonXS.pm (_handle_close_brace): do not reset
	anchor and namedanchor source_info at closing, the source info should
	be set where the @-command is.

2025-09-09  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/configure.ac,
	* tta/m4/txi_libperl_link.m4 (txi_LIBPERL_LINK):
	Split check for linking against libperl into separate file.

2025-09-09  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/configure.ac,
	* tta/m4/txi_embedded_perl.m4 (txi_EMBEDDED_PERL):
	Split check for embedded perl into a separate .m4 file.

2025-09-09  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/configure.ac,
	* tta/m4/txi_iconv_converts_euc_cn.m4 (txi_ICONV_CONVERTS_EUC_CN):
	Move code checking if iconv works for EUC-CN character encoding
	to separate .m4 file.

2025-09-09  Gavin Smith <gavinsmith0123@gmail.com>

	Comments for parts of tta/configure.ac

	* tta/configure.ac (LIBPERL_LINK): add comment above lengthy
	section of file explaining that this is only used for SWIG.
	(PERL_EMBEDDED): add another comment saying when this conditional
	is used.

2025-09-08  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Command List): fix node reference.  from Bruno.

2025-09-07 Patrice Dumas  <pertusus@free.fr>

	* tta/C/swig/swig_element_types.h (TXI_CM_FLAGS_LIST): add
	no_paragraph.

	* tta/C/swig/swig_interface.c (txi_ext_messages_list_messages_number):
	return 0 if there are no messages.

	* tta/swig/perl/Makefile.am (SWIG_header_dependencies): add
	swig/swig_element_types.h.

	* tta/swig/texinfo.i (block_line_argument_command): add.

2025-09-07  Gavin Smith <gavinsmith0123@gmail.com>

	* NEWS: update now that @maketitle is fully implemented

2025-09-07  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Tips): Remove section about using @value in
	@copying as this is covered elsewhere in the manual.
	(@settitle, Preamble): Change link to "@titlepage" node to
	"Titlepage & Copyright Page".
	(GNU Sample Texts): Use @maketitle in example.

2025-09-07  Gavin Smith <gavinsmith0123@gmail.com>

	@maketitle in documentation

	* doc/texinfo.texi (Short Sample Texinfo File, @sp, @page)
	(@value Example, Overfull hboxes, HTML Output Structure Customization)
	(HTML Customization Variables List):
	Update examples to use @maketitle instead of @titlepage.
	* doc/info-stnd.texi: use @maketitle instead of @titlepage.

2025-09-07 Patrice Dumas  <pertusus@free.fr>

	* tta/swig/perl/Makefile.am (scripts_test_files, EXTRA_DIST),
	tta/swig/perl/tests/test_expansion_lines_block/test_expansion_lines_block.texi:
	new test for macro expansion with empty lines and block command.

2025-09-06 Patrice Dumas  <pertusus@free.fr>

	* tta/C/swig/swig_interface.c (txi_ext_messages_list_messages_number)
	(txi_ext_destroy_error_messages_list): handle NULL formatted error
	messages, as it may easily happen, if there are no error messages, and
	it is better not to rely on the caller to check that it is not
	NULL/undef or similar.

2025-09-01 Patrice Dumas  <pertusus@free.fr>

	* tta/C/Makefile.am (ctexi2any_CPPFLAGS): add
	PERL_EXTUTILS_EMBED_ccopts to match LDFLAGS.  Could be needed on
	AlmaLinux.  Not needed for libraries, probably because libtool already
	adds the cflags.

	* tta/C/Makefile.am (libperlembed_libtexinfo_main_la_CPPFLAGS)
	(libperlembed_libtexinfo_main_la_CFLAGS)
	(libperlembed_libtexinfo_main_la_LIBADD): use consistent flags
	with/without Perl embedding.

2025-08-31  Gavin Smith <gavinsmith0123@gmail.com>

	* info/Makefile.am: fix use of Automake variables to install,
	distribute and clean the correct files under info-hooks-default.

2025-08-31 Patrice Dumas  <pertusus@free.fr>

	Add a parser 'virtual' object in SWIG interface

	* tta/C/main/document_types.h (PARSER): add struct in this file to
	hide it from the SWIG interface.  It only holds a parser configuration
	descriptor.

	* tta/C/main/parser_conf.c (unregister_parser_conf_descriptor): add.

	* tta/C/Makefile.am (C_libtexinfo_main_sources),
	tta/C/swig/swig_parser_api.c (txi_ext_parser, txi_ext_destroy_parser)
	(txi_ext_parse_*, txi_ext_parser_conf_*), tta/swig/perl/Makefile.am
	(SWIG_header_dependencies): add an interface for parse_* and
	parser_conf_* with a constructor and a desstructor and parser in
	argument, that allows to find associated parser conf and apply conf.

	* tta/swig/perl/parse_refold.pl, tta/swig/perl/t/*.t,
	tta/swig/python/test_Texinfo.py, tta/swig/texinfo.i (parse_*)
	(parser_conf_*): use interface with a parser.

2025-08-31 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/parser_conf.c (global_parser_conf, register_conf)
	(apply_conf), tta/C/parsetexi/conf.c (simple_parser_conf)
	(reset_parser_conf): do not copy in apply_conf, but replace.  For
	this, make global_parser_conf a pointer.  Add simple_parser_conf
	structure to hold memory for the configurations that do not need to be
	registered, which global_parser_conf did previously.  Update
	reset_parser_conf.  Update code accessing global_parser_conf.

2025-08-31 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/t/z_misc/same_parser_multiple_files.t,
	tta/perl/t/z_misc/no_structure_test.t,
	tta/perl/XSTexinfo/Parsetexi.pm: use exists or defined in conditions
	when the value is not used.  Change formatting of functions call code.

2025-08-31 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/utils.c (print_values_list): add, for debugging.

2025-08-30 Patrice Dumas  <pertusus@free.fr>

	* tta/C/Makefile.am (C_libtexinfo_main_sources),
	tta/swig/*/Makefile.am (SWIG_include_directories)
	(SWIG_header_dependencies, Texinfo_la_CPPFLAGS), tta/C/swig/swig_*:
	move files in C libraries used for the swig interface to their own
	directory.

2025-08-26 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Common.pm, tta/perl/Texinfo/Convert/DocBook.pm: use
	exists or defined in conditions when the value is not used.  Change
	formatting of functions call code.

	* tta/perl/Texinfo/Convert/Utils.pm: use exists in conditions when the
	value is not used. 

	* tta/perl/Texinfo/Convert/HTML.pm: change formatting of functions
	call code.

2025-08-26 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/Info.pm,
	tta/perl/Texinfo/Convert/Plaintext.pm: use exists or defined in
	conditions when the value is not used.  Change formatting of functions
	call code.

	* tta/perl/Texinfo/Convert/Plaintext.pm: always use prototypes.

2025-08-26 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/Text.pm: use exists or defined in
	conditions when the value is not used.  Change formatting of functions
	call code.

2025-08-26 Patrice Dumas  <pertusus@free.fr>

	@maketitle in LaTeX output

	* tta/perl/Texinfo/Convert/Utils.pm (get_titlepage_publication_info):
	directly reuse $document_info.

	* tta/perl/Texinfo/Convert/LaTeX.pm (_format_title): add based on
	_convert code.

	* tta/perl/Texinfo/Convert/LaTeX.pm (_make_title, _convert): format
	@maketitle.

	* tta/perl/Makefile.tres, tta/perl/t/latex_tests.t
	(maketitle_documentinfo_publication): add test.

2025-08-25 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/convert_utils.c (new_document_info)
	(destroy_document_info, get_document_documentinfo)
	(get_titlepage_publication_info), tta/C/main/document_types.h
	(DOCUMENT_INFO), tta/perl/Texinfo/Convert/Utils.pm
	(get_document_documentinfo, get_titlepage_publication_info): add
	get_document_documentinfo to get the information in @documentinfo, and
	get_titlepage_publication_info to additionally get @copying and
	@publication information.

	* tta/C/convert/format_html.c (format_maketitle)
	(html_default_format_titlepage), tta/perl/Texinfo/Convert/HTML.pm
	(_format_maketile, _default_format_titlepage): format maketitle
	title page in HTML, getting title page information with
	get_document_documentinfo.

	* tta/perl/Makefile.am (test_files), tta/perl/t/docbook_tests.t
	(maketitle_documentinfo_publication), tta/perl/t/html_tests.t
	(maketitle_documentinfo_publication),
	tta/perl/t/input_files/maketitle_documentinfo_publication.texi,
	tta/perl/Makefile.tres: add maketitle_documentinfo_publication.texi,
	which calls @maketitle, @publication and @documentinfo with several
	commands.  Add tests for HTML and Docbook formatting of document info
	and title mage with those commands.

2025-08-24 Patrice Dumas  <pertusus@free.fr>

	Add @documentinfo, @publication, @maketitle in texi2any, preliminary 

	* tta/data/command_data.txt: add maketitle, documentinfo and
	publication.

	* tta/C/parsetexi/handle_commands.c (handle_line_command),
	tta/perl/Texinfo/ParserNonXS.pm (_handle_line_command): allow author
	to be in documentinfo.

	* tta/perl/Texinfo/Convert/DocBook.pm (%ignored_block_commands)
	(conversion_output_begin), tta/C/convert/format_html.c
	(html_default_format_titlepage, html_convert_maketitle_command)
	(html_convert_unit_type), tta/C/convert/html_prepare_converter.c
	(commands_internal_conversion_table), tta/perl/Texinfo/Convert/HTML.pm
	(%ignored_block_commands, _convert_maketitle_command)
	(_convert_unit_type, _default_format_titlepage),
	tta/perl/Texinfo/Convert/Plaintext.pm (%formatted_line_commands,
	%advance_paragraph_count_commands) (%ignored_commands),
	tta/perl/Texinfo/Convert/Text.pm (%ignored_block_commands),
	tta/perl/ext/epub3.pm (epub_finish): basic handling of documentinfo
	and publication, mainly by ignoring, but also by searching for author
	and subtitle in documentinfo.  Handle maketitle in HTML.  The
	titlepage formatting for maketitle is not yet implemented.

	* tta/perl/Texinfo/Convert/LaTeX.pm (%ignored_block_commands)
	(_make_title, _convert, _tableofcontents_after_title)
	(_begin_document): add _tableofcontents_after_title with code from
	_begin_document related to table of contents.  Do titlepage in
	_begin_document only if maketitle is not found.  Handle maketitle.
	Add mainmatter and table of contents where maketitle is output.  The
	titlepage formatting for maketitle, expected to be in the _make_title
	function is not yet implemented.

2025-08-24 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/get_perl_info.c (get_sv_option), tta/C/main/txi_config.c
	(set_option_value): if an integer option is not an integer, set it to
	0 if it is the string value is empty, or to 1 if not empty.  This
	mimics Perl.  Not exactly the same as comparison won't fail in C, while
	it will fail in Perl and trigger a warning.

2025-08-24 Patrice Dumas  <pertusus@free.fr>

	* tta/C/texi2any.c (check_integer_option, main): add
	check_integer_option that aborts with an error message similar the the
	one in Perl if an integer option is not an integer.  Call for the
	options that are integer and not obsolete.

2025-08-24 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/format_html.c (contents_inline_element): free
	table_of_contents when it is the empty string.

2025-08-24 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/tree.c (destroy_key_pair_value, destroy_associated_info):
	split destroy_key_pair_value out of destroy_associated_info to destroy
	a single key pair value.

	* tta/C/main/extra.c (get_associated_info_key): if a key pair is
	reused, call destroy_key_pair_value on the value.

2025-08-24 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/DocBook.pm (convert_tree): report a
	formatting context not setup, with empty lang_stack as a bug.

2025-08-24 Patrice Dumas  <pertusus@free.fr>

	 * tta/perl/Texinfo/Convert/LaTeX.pm (_latex_header): call
	 _push_new_context and call _convert for settitle_tree conversion,
	 instead of calling convert_tree without context.

	 * tta/perl/Texinfo/Convert/LaTeX.pm (convert_tree): report no
	 formatting_context in convert_tree as a bug.

2025-08-24 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/LaTeX.pm (output): call _push_new_context
	explicitly and call _convert.

	* tta/perl/Texinfo/Convert/LaTeX.pm (convert): reset
	formatting_context, always call _push_new_context.

	* tta/perl/Texinfo/Convert/LaTeX.pm (_latex_begin_output): rename
	$header as $result_text.

2025-08-24 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/LaTeX.pm: use exists or defined in
	conditions when the value is not used.  Change formatting of functions
	call code.  DO not use object oriented syntax when calling local scope
	functions.

	* tta/perl/Texinfo/Convert/LaTeX.pm (converter_reset): add.

	* tta/perl/Texinfo/Convert/LaTeX.pm (_prepare_conversion): reset more
	state keys, in particular those that may not exist at all.

	* tta/perl/Texinfo/Convert/LaTeX.pm (output): set
	$self->{'formatting_context'} explicitly.

	* tta/perl/Texinfo/Convert/LaTeX.pm (_format_heading_command)
	(_set_custom_headings): rename first_custom_heading as
	is_first_custom_heading.

	* tta/perl/Texinfo/Convert/LaTeX.pm (_convert_def_line): rename
	deftypefnnewline as with_deftypefnnewline.

2025-08-24 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/texi2any.pl: update comment about memory release.

2025-08-23 Patrice Dumas  <pertusus@free.fr>

	* doc/texinfo.texi (Global Customization Variables): add more
	information on setting TEST value, to described that setting TEST can
	trigger some additional checks and test related features enabling.

2025-08-23 Patrice Dumas  <pertusus@free.fr>

	* tta/C/texi2any.c (main): rename i as file_index.  As in Perl,
	release memory if TEST > 0 or the processed file is not the last one.

	* tta/C/texi2any.c (main): set external_module to
	elt_count_external_module for sort_element_count, to notify that the
	a Perl module is used, and in particular that document was built to Perl.

	* tta/C/main/call_document_perl_functions.c
	(call_document_remove_document_references): check that document hv is
	non-NULL.  It may be NULL if the Texinfo file was not found.

	* tta/C/main/tree.c (destroy_element): improve refcount check message.

2025-08-23 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/texi2any.pl ($file_index, $input_files_nr): rename
	$file_number as $file_index.  Set $input_files_nr.  Call
	reset_converter, destroy on converter and on document if the file
	being processed is not the last one.

2025-08-23 Patrice Dumas  <pertusus@free.fr>

	* tta/C/structuring_transfo/structuring.c (print_down_menus): do not
	wrongly redefine the reuse_existing_menu variable when setting it.

2025-08-23 Patrice Dumas  <pertusus@free.fr>

	* tta/C/parsetexi/handle_commands.c (add_comment_at_end),
	tta/perl/Texinfo/ParserNonXS.pm (_add_comment_at_end): rename
	input_comment_text as input_comment_cmd_text and comment_text as
	comment_cmd_text.  Rename q as argument_text.

	* tta/C/parsetexi/handle_commands.c (add_comment_at_end): free
	comment_cmd_text.

	* tta/C/main/output_unit.c (print_output_units_details): free
	root_command_texi.

	* tta/C/parsetexi/handle_commands.c (handle_line_command): destroy
	line_args element if the raw line element is ignored.

	* tta/C/parsetexi/macro.c (expand_macro_arguments)
	(expand_linemacro_arguments, handle_macro),
	tta/C/parsetexi/separator.c (handle_open_brace): add static variables
	to hold the new line pointer returned by next_text and free them
	before getting the next line.

	* tta/C/structuring_transfo/structuring.c (print_down_menus): add a
	variable set if the existing menu is reused, and use that variable
	value to decide if menus need to be destroyed.

2025-08-23 Patrice Dumas  <pertusus@free.fr>

	* tta/C/parsetexi/handle_commands.c (raw_line_command_arg_spaces):
	leave an fully empty text element on a raw line command as is.  Can
	only happen if there is nothing at all after the command, not even an
	new line.

2025-08-23 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/HTML.pm: add comment explaining that the
	overrides without whole output or convert overriding do not work
	anymore.

2025-08-23 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/XSTexinfo/convert/get_html_perl_info.c
	(html_get_no_arg_commands_formatting_sv)
	(html_get_directions_strings_sv): split
	html_conversion_initialization_sv in two,
	html_get_no_arg_commands_formatting_sv and
	html_get_directions_strings_sv.  This code is unused.

	Remove all the references to html_conversion_initialization_sv from
	code and comments.

2025-08-23 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/HTML.pm (_run_stage_handlers): rename
	run_stage_handlers as _run_stage_handlers since it is a local function
	only and do not call with object oriented syntax.

	* tta/perl/Texinfo/Convert/HTML.pm (_prepare_converted_output_info):
	use $self->{'document'} in the whole function.

2025-08-23 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/call_html_perl_function.c (call_stage_handler): do not
	use document SV found in converter if undef.

2025-08-23 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/HTML.pm (_default_format_element_header):
	only test if tree_unit_directions exists to determine that there are
	directions and more than one element.

2025-08-23 Patrice Dumas  <pertusus@free.fr>

	Remove enumerate_specification extra information from tree

	* tta/C/main/tree_types.h (AI_KEYS_LIST), tta/C/parsetexi/end_line.c
	(end_line_starting_block), tta/perl/Texinfo/ParserNonXS.pm
	(_end_line_starting_block): do not put enumerate_specification extra
	information in tree.

2025-08-23 Patrice Dumas  <pertusus@free.fr>

	Do not use enumerate_specification extra information in converters

	* tta/perl/Texinfo/ParserNonXS.pm (_end_line_starting_block): inverse
	condition, simplify regex.

	* tta/C/main/utils.c (enumerate_number_representation)
	(enumerate_item_representation), tta/C/main/convert_to_text.c
	(convert_to_text_internal), tta/C/structuring_transfo/structuring.c
	(sectioning_structure), tta/perl/Texinfo/Common.pm
	(enumerate_number_representation, enumerate_item_representation),
	tta/perl/Texinfo/Convert/Plaintext.pm (_convert),
	tta/perl/Texinfo/Convert/Text.pm (_convert): rename
	enumerate_item_representation as enumerate_number_representation, and
	handle malformed specification in enumerate_number_representation.
	Readd enumerate_item_representation as a function that determines an
	item tree element enumerate representation by calling
	enumerate_number_representation and without using
	enumerate_specification extra information.  Update callers.

	* tta/C/convert/format_html.c (html_convert_enumerate_command),
	tta/perl/Texinfo/Convert/DocBook.pm (_convert),
	tta/perl/Texinfo/Convert/HTML.pm (_convert_enumerate_command),
	tta/perl/Texinfo/Convert/LaTeX.pm (_set_environment_options),
	tta/perl/Texinfo/Convert/TexinfoMarkup.pm (_convert): use the
	enumerate arguments to get the @enumerate argument instead of 
	using the enumerate_specification extra information.

2025-08-22 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/HTML.pm: do not use object oriented call
	for file scope functions.

2025-08-22 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/HTML.pm: use exists in conditions when the
	value is not used.

	* tta/perl/init/book.pm: use exists or defined in conditions when the
	value is not used.  Change formatting of functions call code.  Sync
	common parts of book_convert_heading_command with HTML.pm.

2025-08-22 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/HTML.pm: use exists or defined in conditions
	when the value is not used.  Change formatting of functions call code.

	* tta/perl/Texinfo/Convert/HTML.pm (_parse_htmlxref_files): minor
	changes in code.

	* tta/perl/Texinfo/Convert/HTML.pm (converter_initialize): handle
	undef customization data.

2025-08-22 Patrice Dumas  <pertusus@free.fr>

	* tta/tests/run_parser_all.sh (check_strxfrm_ok): remove a space in
	string in condition that can be significant.

2025-08-22 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/HTML.pm: use exists or defined in conditions
	when the value is not used.  Change formatting of functions call code.

	* tta/perl/Texinfo/Convert/Converter.pm: use exists in conditions.

2025-08-21 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/HTML.pm, tta/perl/init/html32.pm,
	tta/perl/texi2any.pl: use exists or defined in conditions when the value
	is not used.  Change formatting of functions call code.  Use the value
	of TEXI2HTML customization variable in conditions, not whether it is
	defined.

	* tta/perl/texi2any.pl: add comments.

2025-08-21 Patrice Dumas  <pertusus@free.fr>

	* tta/tests/formatting/list-of-tests: remove setting TEXI2HTML undef,
	it is never needed.

2025-08-20 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/texi2any.pl, tta/perl/load_txi_modules.pl: remove the
	references to the standalone module infrastructure.

2025-08-20 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/XSLoader.pm ($xs_parser_loaded, XS_parser_loaded)
	(set_XS_parser_loaded), tta/perl/Texinfo/Parser.pm (BEGIN): add a
	setter and a getter for the XS Parser being actually loaded.  Set in
	Parser.pm if XS is enabled and init did not return the non-XS package
	name.

	* tta/perl/Texinfo/ManipulateTree.pm (_element_remove_references)
	(tree_remove_references): distinguish tree_remove_references that
	removes the reference for a whole the, and _element_remove_references
	that remove recusrively the references for elements except for the
	tree root.  Setup reference Refcounts in tree_remove_references, using
	XS_parser_loaded.

2025-08-20 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/ManipulateTree.pm
	($destroyed_objects_refcount_text): rename
	$destroyed_objects_refcount_target as
	$destroyed_objects_refcount_text.  Update
	$destroyed_objects_refcount_text when $destroyed_objects_refcount
	changes.

2025-08-20 Patrice Dumas  <pertusus@free.fr>

	* tta/swig/perl/Makefile.am (perl_texinfo_wrap.c),
	tta/swig/python/Makefile.am (python_texinfo_wrap.c): expand $< in
	non-suffix rules for BSD make.

2025-08-20 Patrice Dumas  <pertusus@free.fr>

	* tta/configure.ac (AM_PATH_PYTHON): set value if not found, and
	set with_swig_python only if the python interpreter is found.

2025-08-20 Patrice Dumas  <pertusus@free.fr>

	* tta/C/Makefile.am (noinst_LTLIBRARIES): do not build
	libcallperl_libtexinfo.la if HAVE_ICONV is not set even of the library
	do not depend on iconv, as the library is only used as a convenience
	library for libtexinfo.la, which depends on iconv.

2025-08-20 Patrice Dumas  <pertusus@free.fr>

	* info/Makefile.am (dist_check_SCRIPTS): make
	t/config/texinfo/info-hooks/manual-not-found dist_ to have it
	distributed.

2025-08-19 Patrice Dumas  <pertusus@free.fr>

	* tta/README, tta/configure.ac (refcounts-checks): remove Devel::Cycle
	from the modules that should load for refcounts-checks, as it is not
	needed.  Add information in tta/README on how to modify the code to
	test for cycles.

	* tta/perl/Texinfo/Convert/Converter.pm ($devel_findref_loading_error)
	(reset_converter), tta/perl/Texinfo/ManipulateTree.pm
	($devel_findref_loading_error, tree_remove_references): remove
	Devel::FindRef from the modules that should load for refcounts-checks,
	instead add a runtime check and adapt message.

	* tta/perl/Texinfo/Convert/Converter.pm ($output_unit_SV_target_count)
	($output_unit_object_target_count, reset_converter),
	tta/perl/Texinfo/ManipulateTree.pm
	($destroyed_objects_refcount_target, $element_SV_target_count)
	(tree_remove_references): modify messages related to refcount checks.

2025-08-19 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Document.pm (new_document): remove
	output_units_lists, get_output_units_lists and
	register_output_units_lists.  It is already done by converters, no
	point in having two possibilities.

	Changes in comments.

2025-08-19 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Document.pm (_remove_section_relations_relations):
	remove cycle going through toplevel prev directions.

	* tta/perl/Texinfo/Document.pm (remove_document_references):
	reorganize code to separate code that remove cycles and code that
	remove all the references to elements.

2025-08-19 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/ParserNonXS.pm (release): delete instead of
	undefining document associated to the parser.

2025-08-19 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/HTML.pm (converter_destroy): do not call
	tree_remove_references on no arg commands translated_tree, as there is
	no check on those trees.

	* C/convert/call_conversion_perl.c
	(call_object_converter_perl_release), tta/C/convert/texinfo.c
	(txi_converter_destroy), tta/perl/Texinfo/Convert/Converter.pm
	(converter_destroy, converter_perl_release, _XS_destroy, destroy),
	tta/perl/Texinfo/Convert/HTML.pm (converter_destroy),
	tta/perl/XSTexinfo/convert/ConvertXS.xs (destroy): remove
	remove_references argument of converter destroy functions.  It is not
	used anymore, but there should not be a need to readd it, as the
	converter and all the references on elements it could have had should
	be released when checks on refcounts are done on the Document tree. 
	Update callers.

2025-08-19 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/call_conversion_perl.c (call_object_reset_converter),
	tta/C/convert/texinfo.c (txi_converter_reset),
	tta/perl/Texinfo/Convert/Converter.pm (reset_converter),
	tta/perl/Texinfo/Convert/HTML.pm (converter_reset): remove the
	remove_references argument of reset_converter and converter_reset.
	Update callers.

2025-08-19 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/get_converter_perl_info.c
	(converter_release_output_units_built), tta/C/main/get_perl_info.c
	(release_output_units_list_built, release_output_units_lists_built),
	tta/perl/Texinfo/Convert/Converter.pm (reset_converter),
	tta/perl/Texinfo/OutputUnits.pm (release_output_units_list),
	tta/perl/XSTexinfo/convert/ConvertXS.xs (reset_converter),
	tta/perl/t/test_utils.pl (test), tta/perl/Texinfo/Convert/HTML.pm
	(converter_reset): in release_output_units_list, always remove
	associated_unit from elements when releasing output units, it does not
	make sense to have elements point to released output units.  Always
	remove all references to output units, even if it is not needed to
	remove cycles.

2025-08-19  Gavin Smith <gavinsmith0123@gmail.com>

	Fix make distcheck

	* info/Makefile.am: Distribute info-hooks-default/manual-not-found.in
	instead of info-hooks-default.  Look for file in srcdir in rule.
	Report from Patrice.

2025-08-18 Patrice Dumas  <pertusus@free.fr>

	Register error messages during destruction, for refcounts warnings

	* tta/perl/Texinfo/Convert/Converter.pm (destroy),
	tta/perl/Texinfo/Document.pm (destroy_document): do not undef
	the reference when destroying some data and removing cycles to prepare
	for full removal, as the caller may still have some use for the
	remaining data and methods.  In practice to be able to call the
	method to retrieve error messages messages registered during
	converter or document destruction after calling the method doing the
	destruction.

	* tta/perl/Texinfo/Convert/Converter.pm (reset_converter): pass
	a debugging warning message when the refcounts are not correct,
	such that this is visible in the tests.

	* tta/perl/Texinfo/Convert/HTML.pm (converter_destroy),
	tta/perl/Texinfo/Document.pm (remove_document_references),
	tta/perl/Texinfo/ManipulateTree.pm (tree_remove_references):
	pass a document as check_refcount tree_remove_references argument, and
	use it to pass a debugging warning message when the refcounts are not
	correct, such that this is visible in the tests.

	* tta/C/main/build_perl_info.c (pass_errors_to_hv): add an optional
	key argument.  Update callers.  Allow the error messages argument to
	be NULL.

	* tta/perl/XSTexinfo/convert/ConvertXS.xs (destroy)
	(get_converter_errors): if there are still error messages in the
	C converter data when destroy is called, pass the messages to
	the Perl converter.  Register/reuse the Perl messages lists in
	get_converter_errors and pass the messages stored in Perl even if the
	C converter is not found.

	* tta/perl/XSTexinfo/parser_document/DocumentXS.xs (destroy_document)
	(document_errors): if there are still error messages in the C document
	data when destroy_document is called, pass the messages to the Perl
	Document.  Register/reuse the Perl messages lists in document_errors
	and pass the messages stored in Perl even if the C document is not
	found.

	* tta/perl/t/test_utils.pl (convert_to_*, test): do not set the
	converter errors in convert_to_* functions, call get_converter_errors
	in test after conversion.

	* tta/perl/t/test_utils.pl (test): get converter errors after
	destroying the converter.  This is possible thanks to the changes
	in ConverterXS.xs above.

	* tta/perl/t/test_utils.pl (test): add a variable to store whether the
	parsing was successful or not instead of using the tree, such that the
	tree can be undefined.  Convert the tree back to Texinfo earlier on,
	after the conversions by the other converters.  Destroy the document
	before doing the comparisons and get the errors in document after
	destroying the document, which is possible thanks to the changes in
	DocumentXS.xs above.  That way, all the errors are gathered and
	code that does conversion and comparisons are well separated.

	* tta/C/main/utils.c (interpreter_refcount_error_messages)
	(set_check_element_interpreter_refcount)
	(get_check_element_interpreter_refcount), tta/C/main/output_unit.c
	(destroy_output_unit), tta/C/main/tree.c (destroy_element): add an
	error messages list to be used with
	*_check_element_interpreter_refcount, pass it to code setting
	check_element_interpreter_refcount and codes checking
	get_check_element_interpreter_refcount.  Add warning messages in the
	error message lists in destroy_element and destroy_output_unit.  A
	separate error messages list is handy because, in general, the
	refcounts are checked when the structure that unregister the
	references that could hold the error messages is being destroyed.

	* tta/C/convert/converter.c (reset_generic_converter),
	tta/C/convert/texinfo.c (txi_destroy_document),
	tta/perl/XSTexinfo/parser_document/DocumentXS.xs (destroy_document):
	handle error messages on refcounts gathered during document
	destruction and converter reset.  Pass to the converter in converter
	reset, discard in txi_destroy_document, and pass to Perl Document
	error messages list array in XS destroy_document.

2025-08-18 Patrice Dumas  <pertusus@free.fr>

	Support for refcounts checks in build system

	* configure.ac (refcounts-checks), tta/configure.ac (refcounts-checks)
	(DEFAULT_TEST_LEVEL), tta/defs.in (DEFAULT_TEST_LEVEL),
	tta/perl/Makefile.am (Texinfo/ModulePath.pm),
	tta/perl/Texinfo/ModulePath.pm.in ($default_test_level): add
	--enable-refcounts-checks flag to configure with default detected and
	set DEFAULT_TEST_LEVEL.

	* tta/perl/t/test_utils.pl ($default_test_level): use
	$Texinfo::ModulePath::default_test_level for the default test level.

	* tta/tests/many_input_files/*.sh, tta/tests/run_parser_all.sh: set
	TEST customization variable value in calls based on DEFAULT_TEST_LEVEL.

2025-08-18 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/ext/tex4ht.pm (tex4ht_finish): reset %formats to release
	references on tree elements.

2025-08-18 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/HTML.pm (converter_reset): reset
	document_units instead of emptying it as the Converter still needs the
	content on the list document_units points to.

2025-08-18 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/Converter.pm (reset_converter): minor
	changes in code, avoid using splice to remove array content.

	* tta/perl/Texinfo/Convert/HTML.pm (converter_reset): empty directly
	global_units_directions.  Empty document_units instead of removing.

2025-08-18 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/texi2any.pl: reset and destroy converter only if TEST is
	set.

2025-08-18 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/XSTexinfo/convert/ConvertXS.xs (reset_converter): elide
	reset_converter remove_references_sv argument.

2025-08-18 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Document.pm (remove_document_references),
	tta/perl/Texinfo/ManipulateTree.pm (tree_remove_references): change
	tree_remove_references argument to be check_refcount.

2025-08-17 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/ParserNonXS.pm (_end_line_misc_line),
	tta/perl/Texinfo/Transformations.pm (_new_node): call
	tree_remove_parents on nodes that do not end up in the tree to release
	them, to have Perl reclaim their memory and avoid references to
	elements in the tree from discarded tree elements.

2025-08-17 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/ManipulateTree.pm ($no_XS_objects_refcount)
	(tree_remove_references): allow a object refcount of the reference
	minus one if there is XS, but no XS for structure, as the elements
	added for structure may be Perl only.

2025-08-17 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/t/test_utils.pl ($default_test_level, test): set TEST in
	cutomization options based on $default_test_level, or the test.  Set
	TEST in format converter options based on $default_test_level.
	Set $default_test_level to 2.

	* tta/perl/t/test_utils.pl (test): set $remove_references based on
	TEST customization variable value and pass to reset_converter,
	destroy and destroy_document.  If remove_references is set, release
	the output_units setup by the tests.

	* tta/perl/t/test_utils.pl (test): release the $tree reference before
	destroying the document to avoid a last reference on the tree root
	when checking with C code that there are no references left.

2025-08-17 Patrice Dumas  <pertusus@free.fr>

	* tta/swig/texinfo.i (%inline): add a txi_ext_inline_ prefix for all
	the functions defined inline in the SWIG interface file.  All the
	functions defined that way should follow this rule.  This is to avoid
	name clash with Texinfo library functions, including future names.

2025-08-17 Patrice Dumas  <pertusus@free.fr>

	* tta/swig/texinfo.i (element_print_details): remove implementation,
	it exists in the library now.

2025-08-17 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/texinfo.c (txi_destroy_document), tta/C/texi2any.c
	(main): add external_module argument, and call
	call_document_remove_document_references only if set.

	* tta/C/main/call_document_perl_functions.c
	(call_document_remove_document_references): remove check on
	has_perl_interpreter and document->hv, having
	call_document_remove_document_references called only if
	external_module is set should ensure that.

	* tta/swig/texinfo.i (destroy_document)
	(txi_ext_inline_destroy_document): add txi_ext_inline_destroy_document
	to wrap the call to txi_destroy_document.  Use a prefix
	txi_ext_inline_ to disambiguate with library function.

2025-08-17 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/texinfo.c (txi_converter_output, txi_converter_reset):
	change the arguments order.  Update callers.

	* tta/C/convert/texinfo.c (txi_converter_destroy): add external_module
	argument and call Perl function only if set.  Update caller.

	* tta/C/convert/call_conversion_perl.c (call_object_reset_converter)
	(call_object_converter_perl_release): remove the check on self->sv.

2025-08-17 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/build_html_perl_state.c (build_html_formatting_state):
	do not check if converter->sv, the function is only called in
	situations where it is set.

	* tta/C/convert/call_html_perl_function.c
	(call_latex_convert_to_latex_math): do not check self->sv, as the
	main program will fail if this function could be called and no Perl
	interpreter is available.

2025-08-17 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/build_perl_info.c (build_output_units_list),
	tta/perl/XSTexinfo/convert/ConvertXS.xs (get_output_units_lists),
	tta/perl/XSTexinfo/parser_document/StructuringTransfoXS.xs
	(split_by_node, split_by_section): add build_output_units_list, based
	on pass_output_units_list case where there is no array already.  Use
	it where this is the case.

	* tta/C/main/build_perl_info.c (store_output_units_texinfo_tree):
	inline pass_output_units_list in store_output_units_texinfo_tree,
	using also build_output_units_list and remove pass_output_units_list.

2025-08-17 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/build_perl_info.c (store_output_units_texinfo_tree): add
	the converter SV as argument to store_output_units_texinfo_tree to
	align with other functions.  Update callers.

2025-08-17 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/build_html_perl_info.c
	(html_pass_conversion_initialization): remove condition on converter
	being non-NULL, which should always be true.

2025-08-17 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/build_html_perl_info.c: remove
	build_html_global_units_directions and
	pass_html_global_units_directions.

2025-08-17 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/build_html_perl_info.c (set_document_units_handle),
	tta/perl/XSTexinfo/convert/ConvertXS.xs (html_output, html_convert):
	add set_document_units_handle based on
	html_pass_conversion_output_units code to set "document_units" in a
	converter to a handle that holds a descriptor only, no units list Perl
	data.  Inline html_pass_conversion_output_units in html_output and
	html_convert and remove the function.

2025-08-17 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/build_html_perl_info.c
	(html_pass_conversion_output_units), tta/C/main/build_perl_info.c
	(store_output_units_texinfo_tree): remove references on output units
	list arguments.  Update callers, which had already the arguments set
	to 0 only.

2025-08-17 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/HTML.pm (%XS_conversion_overrides),
	tta/perl/XSTexinfo/convert/ConvertXS.xs: remove XS overrides for
	_prepare_conversion_units, _prepare_units_directions_files and
	_prepare_output_units_global_targets that are not called since output
	and convert are overriden and use html_pass_conversion_output_units
	and/or store_output_units_texinfo_tree, which interface changed.
	Remove html_prepare_output_units_global_targets,
	html_prepare_conversion_units and html_prepare_units_directions_files
	from XS.

2025-08-17 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/HTML.pm (%XS_conversion_overrides),
	tta/perl/XSTexinfo/convert/ConvertXS.xs: remove XS overrides for
	_register_id, _id_is_registered and _get_target that are in functions
	that are themselves overriden and are not likely to stop being so.
	Remove html_register_id, html_id_is_registered and html_get_target in
	the XS interface.

	* tta/C/convert/build_html_perl_info.c: remove now unused
	build_html_target.

2025-08-17 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/build_html_perl_info.c
	(html_pass_conversion_output_units): handle NULL output units lists
	pointers references in input.

	* tta/C/main/build_perl_info.c (pass_output_units_list): add an
	indicator in return value, set if a new array was created.

	* tta/C/convert/build_html_perl_info.c
	(store_output_units_texinfo_tree): always use "document_units" value
	for output units list if it exists, and set it early to the value
	pointed to by the output units pointer if it is set.  Always set
	"document_units" if there is a converter->hv.  Use the return value of
	pass_output_units_list to determine if the output units list reference
	on array returned should be stored as "document_units".

	* tta/perl/XSTexinfo/convert/ConvertXS.xs (html_output, html_convert):
	do not set output units arrays as they were never used nor released.

	* tta/perl/XSTexinfo/convert/ConvertXS.xs (get_output_units_lists),
	tta/perl/Texinfo/Convert/Converter.pm (%XS_overrides)
	(XS_get_output_units_lists): add an XS interface to get output units
	lists.

	* tta/perl/Texinfo/Convert/Converter.pm (converter_reset)
	(reset_converter): add a converter_reset function that can be
	redefined by converters.  Call in reset_converter.

	* tta/perl/XSTexinfo/convert/ConvertXS.xs (reset_converter),
	tta/C/main/get_perl_info.c (release_output_units_list_built),
	tta/perl/Texinfo/OutputUnits.pm (release_output_units_list),
	tta/perl/Texinfo/Convert/HTML.pm (converter_reset),
	tta/perl/Texinfo/OutputUnits.pm (release_output_units_list): if the
	remove references argument of release_output_units_list_built or
	release_output_units_list is set, remove all the references to output
	units that can be found in output units.  Set
	remove_output_units_references argument in reset_converter if TEST > 1,
	and remove the output units lists stored in converter.  Add a
	converter_reset function in HTML converter, remove global units
	directions and document_units if TEST > 1 to remove all rteferences to
	output units.

	* tta/perl/Texinfo/Convert/Converter.pm (reset_converter): check that
	the refcounts are the expected ones in pure Perl in case TEST > 1.  In
	that case the references to output units have been removed as much as
	possible.

	* tta/C/convert/converter.c (reset_generic_converter),
	tta/C/main/output_unit.c (destroy_output_unit): if TEST > 1, call
	set_check_element_interpreter_refcount and
	unset_check_element_interpreter_refcount in reset_generic_converter.
	Call get_check_element_interpreter_refcount in destroy_output_unit,
	and if true, check that the reference to the output unit held in C was
	the last one.

2025-08-16 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Document.pm (remove_document_references): do not
	remove associated_unit anymore, the references from the output units
	are now all removed.

2025-08-16 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/OutputUnits.pm (release_output_units_list),
	tta/C/main/get_perl_info.c (release_output_units_list_built): remove
	references to tree elements to avoid cycles going through
	associated_unit before removing anything from tree elements.

2025-08-16 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/OutputUnits.pm (%XS_overrides),
	tta/perl/XSTexinfo/parser_document/StructuringTransfoXS.xs: remove
	rebuild_output_units, it is unused and it would be best to think again
	when a similar function is needed.

2025-08-16 Patrice Dumas  <pertusus@free.fr>

	add commented out code and text about references to output units

2025-08-16 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/converter.c (free_generic_converter),
	tta/C/main/output_unit.c (destroy_output_unit): add code showing the
	refcounts after release, for debugging, not executed.

2025-08-16 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/Converter.pm (converter_perl_release):
	delete 'output_units_lists', to allow for checks of cycles.

	* tta/C/main/get_perl_info.c (release_output_units_list_built): delete
	directions to be more like Perl code.

2025-08-16 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/build_perl_info.c (store_output_units_texinfo_tree):
	transfer the reference on the output units list to the converter hash
	"document_units".

2025-08-16 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/texinfo.c (txi_destroy_document),
	tta/perl/XSTexinfo/parser_document/DocumentXS.xs (destroy_document):
	use a variable to avoid accessing document after being freed.  Use
	TEST > 1 for txi_destroy_document too.

2025-08-16 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/XSTexinfo/parser_document/DocumentXS.xs
	(indices_sort_strings): setup a new reference with newSVsv when
	retrieving from the hash.  Do not retain an additional reference on
	returned SV.

2025-08-16 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/XSTexinfo/parser_document/DocumentXS.xs (document_errors):
	do not retain a reference on returned SV.

2025-08-16 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/build_perl_info.c (pass_errors_to_hv),
	tta/perl/XSTexinfo/parser_document/Parsetexi.xs (parse_texi_line):
	create AV and store if not found.  Remove the corresponding code from
	pass_document_parser_errors_to_parser_sv.  Inline
	pass_document_parser_errors_to_parser_sv and remove.

	* tta/perl/XSTexinfo/parser_document/DocumentXS.xs (document_errors):
	make sure that the error messages passed to pass_errors_to_hv is not
	NULL.  Simplify code.

	* tta/perl/XSTexinfo/parser_document/Parsetexi.xs (errors): simplify.

	* tta/perl/t/z_misc/test_parse_texi_line.t (test_line): fix return
	values of errors().

2025-08-16 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Document.pm (errors),
	tta/perl/Texinfo/Convert/Converter.pm
	(merge_converter_error_messages_lists_noxs): use splice to get array
	content and empty the array at the same time.

2025-08-16 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/build_perl_info.c (pass_errors, pass_errors_to_hv),
	tta/perl/XSTexinfo/convert/ConvertXS.xs (get_converter_errors)
	(text_convert_tree), tta/perl/XSTexinfo/parser_document/DocumentXS.xs
	(document_parser_errors): rename build_errors as pass_errors and get
	the AV as argument.  Update callers.  Use in pass_errors_to_hv.

	* tta/perl/Texinfo/ParserNonXS.pm (parse_texi_line, errors):
	use splice to empty arrays when passing errors.  Check if
	'error_messages' exists by calling exists.

2025-08-16 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/build_perl_info.c (store_extra_additional_info):
	rename store_additional_info as store_extra_additional_info, remove
	key argument, hardocde "extra".  Rename info_hv as extra_hv.
	Update caller.

	* tta/C/main/build_perl_info.c (pass_source_info_hash): rename
	build_source_info_hash as pass_source_info_hash.

	* tta/C/main/build_perl_info.c (element_to_perl_hash): do not reuse
	intermediary sv variable.

2025-08-16 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/build_perl_info.c (build_element_attribute)
	(store_additional_info): have build_associated_info return nr_info
	instad of using a pointer.

2025-08-16 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/build_perl_info.c (store_additional_info): use more
	straightforward code, creating the HV without sv_2mortal but using
	SvREFCNT_dec if it remains empty should be released.

2025-08-16 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/build_perl_info.c (setup_info_hv, store_extra_flags):
	do not retain a superfluous reference.

2025-08-16 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Document.pm, tta/perl/Texinfo/ManipulateTree.pm
	(_print_tree_elements_ref): move _print_tree_elements_ref to
	ManipulateTree.pm and add refcounts.

2025-08-16 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/ManipulateTree.pm (tree_remove_references): do not
	show any message for the tree root element.

	* tta/perl/Texinfo/Document.pm (remove_document_references): no
	special handling of tree root.

2025-08-16 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/Converter.pm (sort_element_counts),
	tta/perl/texi2any.pl: register output units created in
	sort_element_counts.  Call reset_converter on element counts
	converter.

2025-08-16 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/TextContent.pm: use exists or defined
	conditions when the value is not used.  Change formatting of functions
	call code.

2025-08-15  Gavin Smith <gavinsmith0123@gmail.com>

	* info/makedoc.c: Do not #include "window.h" in generated
	doc.c, as this appears only to be needed in order to indirectly
	include doc.h.  Include doc.h directly.
	* info/window.h: Do not #include "doc.h" as it is not needed for
	the definitions in this file.
	* info/session.h: #include "doc.h".

2025-08-15  Gavin Smith <gavinsmith0123@gmail.com>

	* info/infodoc.c (pretty_keyseq): Declare argument as pointer to
	const int.

2025-08-15  Gavin Smith <gavinsmith0123@gmail.com>

	* info/display.c (printed_representation): Declare return value
	as const.  Remove comment saying return value is not to be freed
	as this is now evident from the type of the return value.

2025-08-15  Gavin Smith <gavinsmith0123@gmail.com>

	* info/terminal.c (terminal_put_text, terminal_put_text_hook),
	(terminal_write_chars, terminal_write_chars_hook):
	Declare first parameter as const char *.

2025-08-15  Gavin Smith <gavinsmith0123@gmail.com>

	* info/dir.c (get_dir_node),
	* info/nodes.c (info_get_node): Remove instructions on freeing
	return value from comment.  Simply calling 'free_node' should
	be enough.

2025-08-15 Patrice Dumas  <pertusus@free.fr>

	Add check of released refcounts to Perl object in C if TEST > 2

	* tta/C/main/utils.c (set_check_element_interpreter_refcount)
	(unset_check_element_interpreter_refcount)
	(get_check_element_interpreter_refcount): add functions to
	set/unset/get an indicator that signals whether all the references
	except the one hold by C code have been released and messages should
	be shown.

	* tta/C/convert/texinfo.c (txi_destroy_document),
	tta/perl/XSTexinfo/parser_document/DocumentXS.xs (destroy_document):
	if the customization variable TEST is > 2, call
	set_check_element_interpreter_refcount and
	unset_check_element_interpreter_refcount before and after
	destroy_document to have messages shown.

	* tta/C/main/tree.c (destroy_element): call
	get_check_element_interpreter_refcount, and if true, show the Perl
	object which still have a refcount after having been released in C,
	and in Perl.

2025-08-15 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/Converter.pm (destroy): fix the call of
	converter_perl_release.

	* tta/perl/Texinfo/Convert/Converter.pm (converter_destroy): do not
	check the number of references for the translated_tree elements, as
	they are not in the same situation as regular tree elements.

2025-08-15  Gavin Smith <gavinsmith0123@gmail.com>

	* info/nodes.c (free_node): remove check that either N_IsInternal
	or N_Replica is set.

2025-08-15 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/Converter.pm (float_name_caption): revert
	copying the element before using it in translation, now that the
	part of the tree corresponding to the translation do not have parent
	anymore and is removed automatically.

2025-08-15 Patrice Dumas  <pertusus@free.fr>

	Remove parents in translation trees

	* tta/C/main/manipulate_tree.c (tree_remove_parents): implement in C.

	* tta/C/main/translations.c (gdt_tree),
	tta/perl/Texinfo/Translations.pm (gdt): remove parents in translated
	string tree, to avoid cycles such that this part of the tree is
	destroyed as soon as the tree root is out of scope (in Perl).

2025-08-15 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/OutputUnits.pm (release_output_units_list): fix
	call.

2025-08-15 Patrice Dumas  <pertusus@free.fr>
/exis
	* tta/perl/Texinfo/ParserNonXS.pm (_rearrange_tree_beginning): merge
	_add_preamble_before_content in _rearrange_tree_beginning and remove.

	* tta/perl/Texinfo/ParserNonXS.pm (_rearrange_tree_beginning),
	tta/C/parsetexi/parser.c (rearrange_tree_beginning): redo a different
	implementation that determine indices and then splice the contents.
	Do not take information from the global setfilename command, in case
	there would be more than one.  In C, add parents only if there were
	parents to begin with as in Perl.

2025-08-15 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/ParserNonXS.pm (_parse_texi): determine the tree
	root by going through the current element parent, as in C.

	* tta/C/parsetexi/parser.c (parse_texi),
	tta/perl/Texinfo/ParserNonXS.pm (_parse_texi): remove unused root
	argument.  Update callers.

	* tta/perl/Texinfo/ParserNonXS.pm
	(_setup_document_root_and_before_node_section): return
	$before_node_section only.  Update callers.

	* tta/perl/Texinfo/Document.pm (_print_tree_elements_ref): print more
	information.

2025-08-15 Patrice Dumas  <pertusus@free.fr>

	Check unexpected references to tree elements if TEST > 1

	* configure.ac: also check 'use Devel::Peek' (module in Perl core
	since long).  We only need Devel::Peek for debugging, so a runtime
	load would have been better.  However, the function used does not
	seems to work correctly if the module is loaded with require, but
	works if loaded with use.

	* tta/perl/Texinfo/ManipulateTree.pm (tree_remove_references),
	tta/perl/Texinfo/Convert/HTML.pm (converter_destroy),
	tta/perl/Texinfo/Document.pm (remove_document_references): add a test
	level argument for tree_remove_references and check references only if
	> 2.  Set this argument to the TEST customization variable value in
	callers.

	* tta/perl/Texinfo/Document.pm (remove_document_references): remove
	the tree variable before calling tree_remove_references, such that the
	reference count for the tree root element is the same as the other
	elements reference count.

	* tta/perl/Texinfo/OutputUnits.pm (release_output_units_list):
	undef and directions for simpler and hopefully more efficient code.
	Also more similar to C code.

2025-08-15 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/convert_utils.c (table_item_content_tree),
	tta/perl/Texinfo/Convert/Converter.pm (table_item_content_tree_noxs),
	tta/perl/Texinfo/Convert/TreeElementConverter.pm
	(tree_element_table_item_content_tree): do not set parents in the
	returned tree, such that there is no cycle and Perl can release the
	elements as soon as they are out of scope.

2025-08-14 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/Converter.pm: use exists or defined in
	conditions when the value is not used.  Change formatting of functions
	call code.

2025-08-15  Gavin Smith <gavinsmith0123@gmail.com>

	Review use of N_IsInternal flag.

	* info/nodes.c (internal_info_node_p): Remove function.  It is
	simple enough that it may as well be inlined into calling sites.
	(free_node): Comment updated.

	* info/session-cmd.c
	(forward_move_node_structure, backward_move_node_structure):
	Also make an exception for "dir" nodes.
	
	N_IsInternal still exists but is not used for memory allocation
	purposes.  It is used for minor user-visible behaviour such as
	tiling windows, and as an optimisation when searching through
	lists of nodes.

2025-08-15  Gavin Smith <gavinsmith0123@gmail.com>

	* info/session-cmd.c (info_split_window): Check N_Replica
	flag when deciding whether to duplicate internal data structures.

2025-08-15  Gavin Smith <gavinsmith0123@gmail.com>

	* info/dir.c (get_dir_node),
	* info/man.c (get_manpage_node):
	Abbreviate code by calling replicate_node.

2025-08-15  Gavin Smith <gavinsmith0123@gmail.com>

	* info/nodes.c (copy_node, replicate_node): Rename.  Set N_Replica
	flag on result.  Do not do anything with the N_IsInternal flag.
	* info/session-cmd.c (info_follow_menus): Call replicate_node on
	starting node.

2025-08-15  Gavin Smith <gavinsmith0123@gmail.com>

	N_Replica flag

	* info/nodes.h (N_Replica): Add flag for NODE.flags
	* info/dir.c (get_dir_node),
	* info/nodes.c (info_node_of_tag_ext),
	* info/man.c (get_manpage_node): Set N_Replica flag.

	* info/nodes.c (free_node): Check N_Replica instead of
	N_IsInternal when deciding whether to free internal structures.
	The purpose of this flag is intended to be more clear than that
	of N_IsInternal.  Some nodes like the "dir" node are generated
	by Info, but do not have the "internal" flag on as there is another
	reference to the storage for the node.

2025-08-15  Gavin Smith <gavinsmith0123@gmail.com>

	free_node instead of free

	* info/session-cmd.c (dump_node_to_stream):
	Consistently call 'free_node' instead of 'free' on NODE
	object.  It shouuld not make a difference as the node was
	returned by info_get_node_of_file_buffer and is a replica
	of an object held in the file buffer data structures, but
	it should be clearer that the code is correct for somebody
	reading it.

2025-08-15  Gavin Smith <gavinsmith0123@gmail.com>

	* info/nodes.c (free_history_node, free_node): rename.
	* info/nodes.c (copy_history_node, copy_node): rename.

2025-08-15  Gavin Smith <gavinsmith0123@gmail.com>

	* info/nodemenu.c (select_visited_node): Call free_history_node
	instead of free.  This fixes a memory leak.

2025-08-14  Gavin Smith <gavinsmith0123@gmail.com>

	* info/scan.c, info/nodes.c (free_history_node, copy_history_node):
	Move to nodes.c.

2025-08-14 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/DocBook.pm: use exists or defined in
	conditions when the value is not used.  Change formatting of functions
	call code.

2025-08-14 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/output_unit.c (output_units_print_details): add, for
	debugging.

2025-08-14 Patrice Dumas  <pertusus@free.fr>

	Release output units in converter reset, not in document destroy

	* tta/perl/Texinfo/Document.pm, tta/perl/Texinfo/OutputUnits.pm
	(release_output_units_list): move _remove_output_units_directions and
	_remove_output_units_references to OutputUnits.pm as
	release_output_units_list.

	* tta/perl/Texinfo/Convert/Converter.pm (get_output_units_lists)
	(register_output_units_lists): add registering output units to Perl
	converter.

	* tta/C/convert/get_converter_perl_info.c
	(converter_release_output_units_built), tta/C/main/get_perl_info.c
	(release_output_units_list_built, release_output_units_lists_built):
	add C functions to be used with XS to release Perl references for the
	output units lists that are kept in C doing the same as
	release_output_units_list.

	* tta/perl/XSTexinfo/convert/ConvertXS.xs (reset_converter),
	tta/perl/texi2any.pl, tta/perl/Texinfo/Convert/Converter.pm
	(%XS_overrides, _XS_reset_converter, reset_converter),
	tta/perl/Texinfo/Convert/HTML.pm (_prepare_conversion_units),
	tta/perl/Texinfo/Convert/Info.pm (output),
	tta/perl/Texinfo/Convert/Plaintext.pm (convert, output),
	tta/perl/Texinfo/Document.pm (remove_document_references): add
	_XS_reset_converter and modify reset_converter to always have both
	Perl and XS run.  Add remove_references argument to reset_converter.
	Release output units in converters reset, not in document destroy.
	Register output units in Perl in converter, not in document.

	* tta/C/convert/call_conversion_perl.c (call_object_reset_converter), 
	tta/C/convert/texinfo.c (txi_converter_reset), tta/C/texi2any.c
	(main): add call_object_reset_converter and update txi_converter_reset
	to release output units in converters reset, not in document destroy.

	* tta/C/convert/texinfo.c (txi_converter_destroy): always call
	call_object_converter_perl_release to match with Perl.

	* tta/perl/Texinfo/ManipulateTree.pm ($destroyed_objects_refcount):
	handle automatically the difference in object refcount with XS and
	without (one more reference with XS).

2025-08-14 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/XSTexinfo/convert/ConvertXS.xs
	(get_converter_indices_sorted_by_index)
	(get_converter_indices_sorted_by_letter): relinquish the reference to
	index_entries_by_letter_hv to the caller.  Use newSVsv instead of
	SvREFCNT_inc.  Change in spacing, remove an intermediary variable.

2025-08-14 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/Info.pm (output),
	tta/perl/Texinfo/Convert/Plaintext.pm (conversion_initialization)
	(_convert): do not set elements_images key value at all if there are
	no elements_images.

	* tta/perl/Texinfo/Convert/Plaintext.pm (converter_destroy): remove
	elements_images.

	* tta/perl/Texinfo/Convert/Plaintext.pm (%command_style_map): use a
	different hash for commands style character than %style_map.

	* tta/perl/Texinfo/Convert/Plaintext.pm: use exists or defined in
	conditions when the value is not used.  Change formatting of functions
	call code.

2025-08-13  Gavin Smith <gavinsmith0123@gmail.com>

	* info/scan.c (copy_history_node): New function.
	* info/session-cmd.c (info_follow_menus): Do not free first
	argument and declare as const.  Use copy_history_node to get
	a NODE to start with.
	* info/info.c (add_initial_nodes): Update.  This means we can
	avoid calling info_get_node three times for the same node.

2025-08-13  Gavin Smith <gavinsmith0123@gmail.com>

	Prefer initial node for command-line index lookup

	* info/indices.c (index_lookup_from_node): New function, based on
	'look_in_indices'.
	* info/info.c (add_initial_nodes): Call index_lookup_from_node.

2025-08-13 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/build_perl_info.c (build_document): get ownership of the
	reference released when the C document is destroyed before destroying
	the document.

2025-08-12 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Translations.pm: change formatting of functions
	call code.  Use exists or defined in conditions when the value is not
	used.

2025-08-12 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/Converter.pm (float_type_number)
	(float_name_caption), tta/perl/Texinfo/Convert/Info.pm (format_ref),
	tta/perl/Texinfo/Convert/Plaintext.pm (format_ref, _convert): change
	formatting of functions call code.  Use exists or defined in
	conditions when the value is not used.  Check for contents in
	format_ref.

2025-08-12 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/HTML.pm: change formatting of functions
	call code.
 
	* tta/perl/Texinfo/Convert/HTML.pm: use exists or defined in
	conditions when the value is not used.

2025-08-12 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/TreeElementConverter.pm
	(_tree_element_xml_numeric_entities_accent, tree_element_xml_accents):
	remove _tree_element_xml_accent now that it is the same as the
	Texinfo::Convert::Converter function.

2025-08-12 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/unicode.c (unicode_accent),
	tta/perl/Texinfo/Convert/Unicode.pm (unicode_accent),
	tta/perl/Texinfo/Convert/TreeElementConverter.pm
	(_tree_element_unicode_accent): add index in
	accent stack and accent stack as arguments.  Update callers.

	* tta/perl/Texinfo/Convert/Unicode.pm (unicode_accent),
	tta/C/main/unicode.c (unicode_accent),
	tta/perl/Texinfo/Convert/Converter.pm (xml_accent),
	tta/perl/Texinfo/Convert/HTML.pm (_accent_entities_html_accent),
	tta/perl/Texinfo/Convert/TreeElementConverter.pm
	(_tree_element_unicode_accent, _tree_element_xml_accent): use position
	in accent stack instead of parent information to determine if
	dotless could be composed with the parent accent command.

2025-08-12 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/convert_utils.c, tta/C/main/utils.c
	(find_innermost_accent_contents), tta/perl/Texinfo/Common.pm
	(find_innermost_accent_contents), tta/perl/Texinfo/Convert/Utils.pm:
	move find_innermost_accent_contents to Texinfo::Common and to utils.c,
	now that it is used in conversion to identifiers code.

2025-08-12 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/Utils.pm: change formatting of functions
	call code.

	* tta/perl/Texinfo/Convert/Utils.pm: use exists or defined in
	conditions when the value is not used.

2025-08-12 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/node_name_normalization.c
	(convert_to_normalized_internal),
	tta/perl/Texinfo/Convert/NodeNameNormalization.pm (_convert): call
	find_innermost_accent_contents and encoded_accents to format an
	accent.

2025-08-12 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/NodeNameNormalization.pm: change formatting
	of functions call code.

	* tta/perl/Texinfo/Convert/NodeNameNormalization.pm: use exists or
	defined in conditions when the value is not used.

2025-08-12 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/Converter.pm (convert_accents),
	tta/perl/Texinfo/Convert/TreeElementConverter.pm
	(_tree_element_format_unicode_accents_stack)
	(_tree_element_format_eight_bit_accents_stack)
	(tree_element_convert_accents), tta/perl/Texinfo/Convert/Unicode.pm
	(_format_unicode_accents_stack, _format_eight_bit_accents_stack):
	change the implementation to be more like C code implementation.

	* tta/C/convert/converter.c (convert_accents),
	tta/C/main/convert_to_text.c (ascii_accents_internal),
	tta/C/main/unicode.c (format_eight_bit_accents_stack)
	(format_unicode_accents_stack_internal),
	tta/perl/Texinfo/Convert/Converter.pm (convert_accents),
	tta/perl/Texinfo/Convert/TexinfoMarkup.pm (_convert),
	tta/perl/Texinfo/Convert/TreeElementConverter.pm
	(_tree_element_format_unicode_accents_stack)
	(_tree_element_format_eight_bit_accents_stack)
	(tree_element_convert_accents), tta/perl/Texinfo/Convert/Unicode.pm
	(_format_unicode_accents_stack, _format_eight_bit_accents_stack): pass
	accent stack and position in stack to accent formatting functions.
	Update calls and prototypes.

2025-08-12 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/html_prepare_converter.c (html_format_setup),
	tta/perl/Texinfo/Convert/HTML.pm (%html_default_commands_args): no
	argument formatting for accent commands.

	* tta/perl/Texinfo/Convert/HTML.pm (_convert): remove a condition that
	is always true.

2025-08-12 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/format_html.c (html_convert_preformatted_type),
	tta/perl/Texinfo/Convert/HTML.pm (_convert_preformatted_type):
	remove condition on parent being def*, it cannot happen anymore, now
	there is an inter_def_item container.

	* tta/C/main/convert_utils.c (expand_verbatiminclude),
	tta/perl/Texinfo/Convert/HTML.pm (_convert_quotation_command), 
	tta/perl/Texinfo/Convert/Utils.pm (expand_verbatiminclude): do not
	generate a parent for element not originally in tree.

	* tta/perl/Texinfo/Convert/HTML.pm (_convert): use exists or defined
	when the value is not useful.

2025-08-12  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/info-stnd.texi (Hooks): Clarify that argument to
	hook may not always be the name of a manual.

2025-08-12  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Installing Dir Entries):
	Say a bit more about why you would have multiple @direntry's.

2025-08-12  Gavin Smith <gavinsmith0123@gmail.com>

	* info/info-hooks-default/manual-not-found.in:
	Check for variables set in data file and use them for the URL
	locations.
	* info/info-hooks-default/gnu-manuals-locations.dat:
	Use variables to abbreviate the file.

2025-08-12  Gavin Smith <gavinsmith0123@gmail.com>

	* info/info-hooks-default/manual-not-found.in, info/Makefile.am:
	add message in generated file saying that it was generated.

2025-08-12  Gavin Smith <gavinsmith0123@gmail.com>

	* configure.ac: run AC_PROG_AWK explicitly to make sure that
	@AWK@ is set (although it seemed to be set anyway).

2025-08-12  Gavin Smith <gavinsmith0123@gmail.com>

	* info/info-hooks-default/manual-not-found,
	* info/info-hooks-default/manual-not-found.in: Rename.  Generate
	the former from the latter by substituting the value of @AWK@
	found by configure.

2025-08-12  Gavin Smith <gavinsmith0123@gmail.com>

	* info/run-external.c (get_output_from_program): if couldn't
	exec, then exit subprocess with EXIT_FAILURE rather than EXIT_SUCCESS.
	* info/configfiles.c (run_info_hook) <debug>: report exit status of
	hook.

2025-08-12  Gavin Smith <gavinsmith0123@gmail.com>

	* info/info-hooks-default/manual-not-found: avoid
	printing to stderr as Info can print its own messages.
	replace perl script with awk as awk will be more portable.

2025-08-11 Patrice Dumas  <pertusus@free.fr>

	* tta/swig/perl/Makefile.am (nodist_perllib_DATA)
	(archlib_LTLIBRARIES, TESTS), tta/swig/python/Makefile.am
	(nodist_python_PYTHON, pyexec_LTLIBRARIES): do modules only if
	HAVE_ICONV is set, as otherwise there is no libtexinfo.

2025-08-11 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/build_perl_info.c (build_minimal_document): move code.

	* tta/C/main/build_perl_info.c (fill_document_hv, build_document):
	move code related to no_store and setting descriptors in Perl data
	out of fill_document_hv to build_document.

2025-08-11 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/build_html_perl_info.c,
	tta/C/convert/build_html_perl_state.c,
	tta/C/convert/get_converter_perl_info.c, tta/C/main/get_perl_info.c:
	use newSVsv instead of SvREFCNT_inc.

	* tta/C/convert/call_conversion_perl.c,
	tta/C/convert/call_html_perl_function.c: reorganize code to make
	clearer that the calls to SvREFCNT_inc are associated to subroutine
	call.  Add casts.

2025-08-11 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/build_perl_info.c (store_document_texinfo_tree)
	(store_output_units_texinfo_tree)
	(store_document_tree_output_units, document_tree): do not return
	a reference to the tree.  Update document_tree to find the reference
	to the tree in document->tree->sv.

	* tta/C/main/build_perl_info.c (document_tree): simplify code.

2025-08-12  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/info-stnd.texi (Custom Key Bindings): Update
	to reflect the fact that pkgdatadir is now also checked.
	(Hooks): mention default hook

2025-08-11  Gavin Smith <gavinsmith0123@gmail.com>

	* info/t/config/texinfo/info-hooks/manual-not-found:
	Add dummy file to stop an installed hook from running.

2025-08-11  Gavin Smith <gavinsmith0123@gmail.com>

	* info/Makefile.am: List info-hooks-default/manual-not-found
	in "SCRIPTS" and not "DATA" so that it will be installed with
	executable permissions.

2025-08-11  Gavin Smith <gavinsmith0123@gmail.com>

	* info/configfiles.c (locate_init_file_internal): Also check
	under $pkgdatadir (i.e., usually /usr/share/texinfo).
	* info/Makefile.am (AM_CFLAGS): Propagate value of $pkgdatadir.

2025-08-11  Gavin Smith <gavinsmith0123@gmail.com>

	* info/configfiles.c (locate_init_file): Report on attempts
	to find init file with debug macro (at level "-x 1").
	(run_info_hook): Use "-x 1" level rather than "-x 3".

2025-08-11  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/info-stnd.texi (Invoking Info):
	Index all command line options multiple times if they have
	synonyms, with each synonym appearing first in the index entry
	text.  This is for ease of lookup of short options.

2025-08-11  Gavin Smith <gavinsmith0123@gmail.com>

	* info/session.c, info/info.c (info_debug): move to info.c.
	* info/session.h, info/info.h (debug): move to info.h.

	* info/info.c (get_initial_file),
	* info/configfiles.c (run_info_hook): output debug message in
	run_info_hook, using name of the hook as a variable.

2025-08-11  Gavin Smith <gavinsmith0123@gmail.com>

	* info/info-hooks-example/gnu-manuals-locations.dat,
	info/info-hooks-default/gnu-manuals-locations.dat,
        info/info-hooks-example/manual-not-found,
        info/info-hooks-default/manual-not-found: Rename subdirectory to
        info-hooks-default.  Install files by default (not found by info
        yet).

2025-08-11  Gavin Smith <gavinsmith0123@gmail.com>

	* info/info-hooks-example/manual-not-found,
	* info/info-hooks-example/gnu-manuals-locations.dat:
	Add copyright notice.

2025-08-11  Gavin Smith <gavinsmith0123@gmail.com>

	Add further ALTIMP dependencies

	* tta/perl/Texinfo/Convert/Converter.pm,
	* tta/perl/Texinfo/Convert/HTML.pm,
	* tta/perl/Texinfo/Convert/PlainTexinfo.pm,
	* tta/perl/Texinfo/Convert/Texinfo.pm,
	* tta/perl/Texinfo/Convert/Text.pm,
	* tta/perl/Texinfo/Convert/Utils.pm,
	* tta/perl/XSTexinfo/convert/ConvertXS.xs:
	Add ALTIMP lines.  (No changes needed to *.c files as these
	already referenced the corresponding Perl modules.)

2025-08-11  Gavin Smith <gavinsmith0123@gmail.com>

	Add ALTIMP comments to reference alternative implementation files

	* tta/C/main/document.c,
	* tta/C/parsetexi/errors_parser.c,
	* tta/C/texi2any.c,
	* tta/perl/texi2any.pl,
	* tta/perl/Texinfo/Document.pm,
	* tta/perl/Texinfo/DocumentXS.pm,
	* tta/perl/Texinfo/Indices.pm,
	* tta/perl/Texinfo/IndicesXS.pm,
	* tta/perl/Texinfo/ManipulateTree.pm,
	* tta/perl/Texinfo/OutputUnits.pm,
	* tta/perl/Texinfo/ParserNonXS.pm,
	* tta/perl/Texinfo/Parser.pm,
	* tta/perl/Texinfo/ReaderNonXS.pm,
	* tta/perl/Texinfo/Reader.pm,
	* tta/perl/Texinfo/Report.pm,
	* tta/perl/Texinfo/StructTransfXS.pm,
	* tta/perl/Texinfo/Structuring.pm,
	* tta/perl/Texinfo/Transformations.pm,
	* tta/perl/Texinfo/Translations.pm,
	* tta/perl/Texinfo/TreeElementNonXS.pm,
	* tta/perl/Texinfo/TreeElement.pm,
	* tta/perl/XSTexinfo/parser_document/DocumentXS.xs,
	* tta/perl/XSTexinfo/parser_document/IndicesXS.xs,
	* tta/perl/XSTexinfo/parser_document/StructuringTransfoXS.xs,
	* tta/perl/XSTexinfo/reader_element/ReaderXS.xs,
	* tta/perl/XSTexinfo/reader_element/TreeElementXS.xs:

	For .pl and .pm files under tta/perl, add comments referencing
	other relevant source codes with parts of alternative implementations
	in C.  This is so someone updating the source code can be aware
	they exist.

	* tta/README: explain ALTIMP comments

2025-08-11  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/README: Add note re Perl/C/XS code maintenance dependency

2025-08-11  Gavin Smith <gavinsmith0123@gmail.com>

	* README-hacking, tta/README: move information about running
	uninstalled program into tta/README.  Add some headings in the
	latter file.

2025-08-11 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/build_perl_info.c (BUILD_PERL_DOCUMENT_ITEM)
	(BUILD_PERL_DOCUMENT_LIST): change the code to duplicate the returned
	reference.  Simplify code.

	* tta/C/main/build_perl_info.c (document_global_information):
	rearrange code.

	* tta/C/main/build_perl_info.c (setup_output_units_handler)
	(html_build_button): avoid retaining superfluous references.

	* tta/C/main/build_perl_info.c (html_build_buttons_specification):
	duplicate the returned reference instead of increasing reference
	count.

2025-08-11 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/build_perl_info.c (build_perl_section_directions)
	(build_perl_section_relations_array, build_section_relations)
	(build_sectioning_root): Have build_perl_section_directions and
	build_perl_section_relations_array return HV and AV.  Do not keep a
	reference in build_section_relations and build_sectioning_root.

	* tta/C/main/build_perl_info.c (build_tree_elements_relations_lists)
	(store_document_texinfo_tree): do not keep duperfluous references.

	* tta/C/main/build_perl_info.c (store_document_texinfo_tree):
	duplicate returned reference.

	* tta/C/main/build_perl_info.c (store_output_units_texinfo_tree): use
	newSVsv instead of SvREFCNT_inc.

	* tta/C/main/build_perl_info.c (pass_global_info)
	(build_minimal_document, fill_document_hv)
	(document_global_information): rename build_global_info as
	pass_global_info, and have pass_global_info use an HV in argument.
	Have build_minimal_document and fill_document_hv create the HV before
	calling pass_global_info.  Modify document_global_information such
	that the reuse of global info hash is done in this function before
	calling pass_global_info.  Simplify code based on document->hv
	necessarily being set.

2025-08-11 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/build_html_perl_state.c,
	tta/C/convert/call_html_perl_function.c, tta/C/main/build_perl_info.c,
	tta/perl/XSTexinfo/parser_document/DocumentXS.xs,
	tta/perl/XSTexinfo/parser_document/StructuringTransfoXS.xs,
	tta/perl/XSTexinfo/reader_element/TreeElementConverterXS.xs,
	tta/perl/XSTexinfo/reader_element/TreeElementXS.xs: use newSVsv
	instead of SvREFHVCNT_inc everywhere.  It is better to have
	independent references, and additionaly SvREFHVCNT_inc leads to
	unreleased references as the added SV reference prevents removal of an
	HV reference.

2025-08-11 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/build_perl_info.c (build_indices_sort_strings)
	(build_sorted_indices_by_index, build_sorted_indices_by_letter)
	(build_convert_text_options, pass_document_sv_to_converter_sv): use
	newSVsv instead of SvREFCNT_inc to obtain independent reference on the
	same object instead of reusing the same reference.

2025-08-11 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/build_perl_info.c (build_filenames, build_file_counters)
	(build_out_filepaths, pass_output_unit_files): return HV from build
	functions.  Pass all the references.  Note that the functions are
	currently unused and therefore could not be tested.

2025-08-11 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/build_perl_info.c (html_build_buttons_specification):
	do not return anything.

	* tta/C/main/build_perl_info.c (build_sv_option, build_global_info)
	(build_sv_options_from_options_list)
	(latex_build_options_for_convert_to_latex_math): remove useless
	increase in reference counts.

2025-08-11 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/convert_html.c (html_convert_tree_append): add
	explicit checks to verify that functions references called for
	conversion are not NULL.

	* tta/C/texi2any.c (main): load HTML Perl conversion if
	XS_EXTERNAL_FORMATTING or XS_EXTERNAL_CONVERSION is set.

2025-08-10 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/build_perl_info.c (new_element_perl_data)
	(element_to_perl_hash), tta/C/main/tree.c (destroy_element): do not
	retain an additional reference in new_element_perl_data, and
	consistently do not remove an HV reference in destroy_element.
	Call newSVsv instead of SvREFHVCNT_inc in element_to_perl_hash.

	* tta/C/main/build_perl_info.c (build_elements_list)
	(fill_document_hv, store_document_texinfo_tree): use newSVsv instead
	of SvREFHVCNT_inc.

	* tta/C/main/build_perl_info.c (build_perl_const_element_array)
	(build_perl_directions, build_extra_misc_args)
	(build_extra_index_entry): do not retain an additional reference
	to the AV/HV.

	* tta/C/main/build_perl_info.c (build_perl_array)
	(build_perl_container): return an AV.  Update caller.

2025-08-10 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/ManipulateTree.pm (_copy_tree, copy_contents)
	(copy_contentsNonXS): handle an tree without contents in input of
	copy_contents and copy_contentsNonXS.

2025-08-10 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/manipulate_tree.c (copy_associated_info),
	tta/C/main/tree.c (destroy_associated_info), tta/C/main/tree_types.h
	(INDEX_ENTRY_LOCATION), tta/C/parsetexi/indices.c (enter_index_entry),
	tta/C/structuring_transfo/transformations.c
	(relate_index_entries_to_table_items_in): do a copy of the index name
	in INDEX_ENTRY_LOCATION index_entry in extra information.  That way,
	the element can outlive the indices information.

2025-08-10  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Headings): Remove extra comma after "and".

2025-08-10  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (@titlepage): Remove text about "@end titlepage"
	being required to turn on page numbering, as this is no longer
	the case.

2025-08-10  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Titlepage & Copyright Page, @setchapternewpage):
	'frontmatter' -> 'front matter'.

2025-08-10  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (@titlepage):
	Mention that @insertcopying is needed for @titlepage.  Mention
	that the copyright page is always produced in the same way.  Combine
	two examples.

2025-08-10 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/Converter.pm (%XS_overrides, destroy)
	(_XS_destroy, converter_perl_release): rename destroy as
	converter_perl_release.  Re-add destroy calling converter_perl_release
	and _XS_destroy, which is now the XS override.  That way, the Perl
	data can be released before destroying the C data.

	* tta/C/Makefile.am (libtexinfoxs_la_SOURCES)
	(libcallperl_libtexinfo_convert_la_SOURCES),
	tta/perl/Texinfo/Document.pm (%XS_overrides, _XS_destroy_document)
	(destroy_document), tta/perl/XSTexinfo/parser_document/DocumentXS.xs
	(destroy_document): add _XS_destroy_document, called by
	destroy_document and use it as XS override.  That way, the Perl data
	can be released before destroying the C data.  Do not call
	call_document_remove_document_references in destroy_document in
	DocumentXS.xs.  Move call_document_perl_functions.c to
	libcallperl_libtexinfo_convert_la_SOURCES.

	* tta/C/convert/call_conversion_perl.c
	(call_object_converter_perl_release), tta/C/convert/texinfo.c
	(txi_converter_destroy, txi_destroy_document), tta/C/texi2any.c
	(main): add call_object_converter_perl_release and call from
	txi_converter_destroy.  Call call_document_remove_document_references
	from txi_destroy_document.  Add remove_references argument to
	txi_destroy_document and txi_destroy_document.  Set remove_references
	in texi2any.c.

2025-08-10 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/Converter.pm (converter_destroy, destroy),
	tta/perl/Texinfo/Convert/HTML.pm (converter_destroy),
	tta/perl/Texinfo/Convert/LaTeX.pm (converter_destroy),
	tta/perl/Texinfo/Convert/Plaintext.pm (converter_destroy): add
	converter_destroy to the Perl converter API, called in Converter
	destroy, defined by each of the converters that need to.

2025-08-10 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Document.pm, tta/perl/Texinfo/ManipulateTree.pm
	(tree_remove_parents, tree_remove_references): move
	tree_remove_parents and tree_remove_references to
	Texinfo::ManipulateTree.  Update callers.

2025-08-10 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/Converter.pm (float_name_caption): copy
	tree in substrings to be able to destroy the tree afterwards.

	* tta/perl/Texinfo/Convert/HTML.pm (_convert_float_command): fix
	variable used in output when in string (which probably never happens).

	* tta/perl/Texinfo/Convert/Converter.pm (float_name_caption),
	tta/perl/Texinfo/Convert/HTML.pm (_convert_float_command),
	tta/perl/Texinfo/Convert/Plaintext.pm (_convert),
	tta/perl/Texinfo/Structuring.pm (number_floats): use exists or defined
	if the variable value is not used.

	* tta/perl/Texinfo/ParserNonXS.pm (_enter_index_entry): minor change
	in code.

2025-08-10 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/ParserNonXS.pm (_get_current_node_relations):
	simplify condition, the current node is always registered in
	nodes_list.

2025-08-10 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/ParserNonXS.pm
	(%parser_document_state_initialization, _move_last_space_to_element)
	(_parse_texi): do not initialize current_node, current_section,
	current_part and internal_space_holder to undef, and delete them to
	unset them.
	Update users.

2025-08-10 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/OutputUnits.pm (units_directions): check that
	_label_target_unit_element did not return undef before setting
	a direction.

2025-08-10 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Structuring.pm (_print_down_menus): go out of the
	loops used to find lenu entry names as soon as a menu entry name is
	found.  Only look in menu_entry.

	* tta/perl/Texinfo/Structuring.pm (_print_down_menus): use exists or
	defined if the variable value is not used, change arguments code.

2025-08-10 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Common.pm (parse_node_manual): fix return in case
	there is no contents.

2025-08-10 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Makefile.tres (test_files_generated_list): add
	missing_detailmenu_menu_entry_names.

2025-08-10 Patrice Dumas  <pertusus@free.fr>

	detailmenu generation in C

	* tta/C/structuring_transfo/structuring.c (print_down_menus):
	implement change in detailmenu generation: check for presence of a
	'menu_entry_name' element in a menu, and if found, do not use it to
	make a detailmenu.

	Update test result.

2025-08-10 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Convert/HTML.pm (_prepare_conversion_units),
	tta/perl/Texinfo/Convert/Info.pm (output),
	tta/perl/Texinfo/Convert/Plaintext.pm (convert, output),
	tta/perl/Texinfo/Document.pm (new_document)
	(register_output_units_lists, get_output_units_lists): add the
	possibility to register output units in document to be able to find
	them back (similar to C).

	* tta/perl/Texinfo/Convert/Plaintext.pm (conversion_finalization):
	remove count contexts.

	* tta/perl/Texinfo/ParserNonXS.pm (release),
	tta/perl/XSTexinfo/parser_document/Parsetexi.xs (release),
	tta/perl/t/test_utils.pl (test, tta/perl/texi2any.pl): add
	function in Perl to remove keys in parser that could create cycles or
	refer to elements.

	* tta/perl/Texinfo/ParserNonXS.pm (_parse_texi): properly unset
	internal_space_holder, and current_*.

	* tta/perl/Texinfo/Document.pm (tree_remove_parents): add to remove
	elements parents in a tree.  This allows to remove cycles in tree,
	such that Perl can reuse the memory.

	* tta/perl/Texinfo/Document.pm (tree_remove_references): add to remove
	references to tree elements, work in progress to be able to check that
	the refcounting in XS/C is done correcty.

	* tta/perl/Texinfo/Convert/Converter.pm (destroy),
	tta/perl/texi2any.pl: remove cycles in converters.  Add a
	remove_references argument, if set try to remove references to
	elements that cannot be accessed through the document too.  Set
	remove_references in texi2any if TEST is > 1.

	* tta/perl/Texinfo/Document.pm (_remove_section_relations_relations)
	(_remove_output_units_directions): remove keys in relations and output
	units that could create cycles in data, such that Perl can reuse the
	memory.

	* tta/perl/Texinfo/Document.pm (_remove_section_relations_references)
	(_remove_node_relations_references)
	(_remove_heading_relations_references)
	(_remove_output_units_references, remove_document_references)
	(destroy_document), tta/C/Makefile.am (libtexinfoxs_la_SOURCES),
	tta/C/main/call_document_perl_functions.c
	(call_document_remove_document_references),
	tta/perl/XSTexinfo/parser_document/DocumentXS.xs (destroy_document),
	tta/perl/texi2any.pl: implement destroy_document in Perl.  In the
	default case, remove cycles.  With the remove_references argument,
	remove all references to elements.  Add a call to Perl function from
	XS to remove Perl data before destroying the C document.

	* tta/perl/Texinfo/ParserNonXS.pm
	(_check_register_target_element_label): minor change in code.

2025-08-10 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Common.pm, tta/perl/Texinfo/ManipulateTree.pm,
	tta/perl/Texinfo/OutputUnits.pm: change formatting of sub arguments
	passing.  Minor changes in code. 

	* tta/perl/Texinfo/OutputUnits.pm: use exists or defined if the
	value is not used.

2025-08-10 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/ManipulateTree.pm (_protect_text),
	(protect_first_parenthesis): modify directly the element source marks.

	* tta/perl/Texinfo/ManipulateTree.pm: use exists or defined if the
	value is not used.  Minor changes in code.

2025-08-09 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/Common.pm: use exists or defined if the value is not
	used.  Minor changes in code.

2025-08-09 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/manipulate_tree.c (element_print_details): add, for
	debugging.

2025-08-09  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Copyright, @titlepage, Document Permissions):
	Move material out of 'Copyright' node and delete node.

2025-08-09  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.texi
	(@title @subtitle @author, @titlefont @center @sp):
	Make these sub-sections of the '@titlepage' node..

2025-08-09  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Titlepage & Copyright Page): Move discussion
	of @settitle here.
	(Title Page Version): Create new node for discussion of version
	and edition on the title page.
	(@titlepage): Content moved from this node.

2025-08-09  Gavin Smith <gavinsmith0123@gmail.com>

	* NEWS: mention new title page commands
	* doc/texinfo.texi
	(Titlepage & Copyright Page, Document Metadata, @titlepage):
	Start work on documentation.

2025-08-08  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/C/texi2any.c (main): Check for the existence of a built
	file relative to executable location, rather than a source code file,
	as this could be an out-of-source build.  Report from Patrice.

2025-08-08  Gavin Smith <gavinsmith0123@gmail.com>

	* info/info-hooks-example/manual-not-found: if nothing known
	about a manual, exit unsucessfully to allow Info to continue.
	this means we display a manpage immediately, if one exists,  rather
	than the hook output.

2025-08-08  Gavin Smith <gavinsmith0123@gmail.com>

	* TODO: add desideratum re info index lookup for manuals documenting
	many programs, such as coreutils.

2025-08-08  Gavin Smith <gavinsmith0123@gmail.com>

	* util/info-hooks, info/info-hooks-example: Move directory.
	* doc/info-stnd.texi (Hooks): update

2025-08-08  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (HTML Xref Configuration):
	Adjust wording slightly re htmlxref.d location.

2025-08-07  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/perl/t/z_misc/do_master_menu.t: update as re-using labels
	for the master menu is no longer supported

2025-08-07  Gavin Smith <gavinsmith0123@gmail.com>

	* tp/Texinfo/XS: run gnulib-tool --remove-import getcwd

2025-08-07  Gavin Smith <gavinsmith0123@gmail.com>

	ctexi2any remove use of getcwd

	* tta/C/texi2any.c (main): If TEXINFO_DEV_SOURCE is not set, check if
	program is uninstalled by checking directory above program directory
	in argv[0] contains a file that should be in that directory.  argv[0]
	should always contain a directory name because the executable is run
	via the libtool wrapper script.
	This is simpler, and avoids calling getcwd, which requires gnulib
	modules to be installed.

2025-08-07  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Node Names, Macro Details): Document that
	user-defined macros should not appear within node names.  Report
	from Werner Lemberg, bug-texinfo, 2025-02-05.

2025-08-06  Gavin Smith <gavinsmith0123@gmail.com>

	detailmenu generation

	* tta/perl/Texinfo/Structuring.pm (_print_down_menus):
	Check for presence of a 'menu_entry_name' element in a menu,
	and if found, do not use it to make a detailmenu.
	(NB no XS override exists for this function.)
	* tta/perl/t/10menu.t (missing_detailmenu_menu_entry_names): new test.

2025-08-06  Gavin Smith <gavinsmith0123@gmail.com>

	* tta/perl/Texinfo/Convert/HTML.pm: remove debugging code
	committed by mistake.

2025-08-06  Gavin Smith <gavinsmith0123@gmail.com>

	* info/dir.c (build_dir_node): Output labels for the list
	of dir files.  Restructure code slightly so it is easier to follow.

2025-08-05  Gavin Smith <gavinsmith0123@gmail.com>

	* info/dir.c (build_dir_node): Add section to menu listing
	all the dir files used to make this dir node, if there were
	more than one.

2025-08-05  Gavin Smith <gavinsmith0123@gmail.com>

	* info/dir.c (build_dir_node): Use "dir" as file name,
	not the path to the first dir file found.

2025-08-05  Gavin Smith <gavinsmith0123@gmail.com>

	* info/dir.c (build_dir_node): free memory in one situation

2025-08-05  Gavin Smith <gavinsmith0123@gmail.com>

	Don't replace text from dir node

	* info/dir.c (build_dir_node): Don't supply our own introduction
	to the dir node.  Just use what was in the user's dir node.
	Use higher-level functions to access the dir files.  This also
	means that "dir.info" will work as a dir file.
	(insert_text_into_node): Free memory appropriately.
	* info/filesys.c (info_file_find_next_in_path): Change comment
	slightly.
	* NEWS: mention

2025-08-04  Gavin Smith <gavinsmith0123@gmail.com>

	Change default for WORDS_IN_PAGE

	* tta/data/converters_defaults.txt (WORDS_IN_PAGE): Change
	default from 300 to 200.  This means the navigation panel is
	more likely to be output at the bottom of fairly short nodes,
	hopefully reducing user confusion.
	* doc/texinfo.texi (Customization of Navigation and Headers):
	Explain why WORDS_IN_PAGE is only approximate.
	(HTML Customization Variables List) <WORDS_IN_PAGE>: update for
	new default.
	* NEWS: mention.

2025-08-04  Gavin Smith <gavinsmith0123@gmail.com>

	* util/info-hooks/manual-not-found: update name of data file.

2025-08-04  Gavin Smith <gavinsmith0123@gmail.com>

	* configure.ac:
	Rename variable from ac_cv_var_ospeed to ac_cv_var_extratermlib
	as we are not checking only the 'ospeed' variable.

	Remove comment:
	/* Make sure all variables actually exist.  AIX 4.3 has ospeed but no BC.
        --Andreas Ley <andy@rz.uni-karlsruhe.de> 24 Aug 2000.  */
        
        This comment was added when more variables, including BC, were added
        to the test.  Since this change is not apparent from looking at
        the current state of the file, the comment is not useful.

2025-08-04  Gavin Smith <gavinsmith0123@gmail.com>

	* configure.ac: Move AC_CHECK_HEADERS of "ncurses/termcap.h"
	before test that uses it (with #ifdef HAVE_NCURSES_TERMCAP_H).

	This had been in that location since commit on 2003-04-18.  See
	https://lists.gnu.org/archive/html/bug-texinfo/2003-04/msg00092.html.
	This has not been a problem in practice as the following test
	only needs to succeed to find extra libraries to link with on rare
	occasions.

2025-08-04  Gavin Smith <gavinsmith0123@gmail.com>

	* configure.ac: In AC_LANG_PROGRAM used in AC_LINK_IFELSE used
	in terminal library check, provide first argument, which appears
	in the test program outside of the 'main' function.  Including
	header files inside 'main' appears not to work well for this test,
	as all libraries tested failed.

2025-08-04  Gavin Smith <gavinsmith0123@gmail.com>

	* configure.ac: check for libtinfow and libncursesw in addition to
	libtinfo and libncurses.
	
	Report from Дилян Палаузов <dilyan.palauzov@aegee.org>.

2025-08-04  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (Directory Category):
	Note that dircategories will never be consistent but user can
	edit them if they like.  Mention the possibility of package-
	specific categories.  Add some suggested category names to list.
	Remove "Emacs" and "Basics".

2025-08-04  Gavin Smith <gavinsmith0123@gmail.com>

	* util/dir-example: some changes to categories to move towards
	categories used at https://www.gnu.org/manual/manual.html.  Eliminate
	"Basics" category.  Add reference to https://www.gnu.org/manual/manual.html.

2025-08-03  Gavin Smith <gavinsmith0123@gmail.com>

	* NEWS: mention that we now create extra redirection pages
	if --transliterate-file-names is given.

2025-08-02  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/info-stnd.texi (Hooks): Mention sample hook in util/info-hooks.

2025-08-02  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (@pxref): mention Info-hide-not-references
	variable in Emacs Info.

2025-08-02  Gavin Smith <gavinsmith0123@gmail.com>

	* util/info-hooks/gnu-manuals-locations,
	* util/info-hooks/gnu-manuals-locations.dat: rename.
	* util/Makefile.am: distrubute files in util/info-hooks.

2025-08-02  Gavin Smith <gavinsmith0123@gmail.com>

	* util/info-hooks/gnu-manuals-locations: add missed manuals.

2025-08-02  Gavin Smith <gavinsmith0123@gmail.com>

	* util/info-hooks/gnu-manuals-locations:
	reorder and group related manuals together for ease
	of maintence (similarly to htmlxref.d files)

2025-08-02  Gavin Smith <gavinsmith0123@gmail.com>

	* util/info-hooks/manual-not-found: Skip comments and blank
	lines in data file.

2025-08-02  Gavin Smith <gavinsmith0123@gmail.com>

	* util/info-hooks/gnu-manuals-locations: add links for
	remaining manuals.

2025-08-01  Gavin Smith <gavinsmith0123@gmail.com>

	* util/htmlxref.d/Texinfo_GNU.cnf (iwf_mh, scantest): fix.

2025-08-01  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (@pxref):
	Attempt at clarifying why "see @ref" may often be better
	than "@pxref".

2025-08-01  Gavin Smith <gavinsmith0123@gmail.com>

	* util/htmlxref.d/Texinfo_GNU.cnf (mit-scheme-*):
	Unify the two blocks of mit-scheme-* manuals.  A second
	block was added on 2022-11-12 not taking into account
	an existing block.

2025-08-01  Gavin Smith <gavinsmith0123@gmail.com>

	* util/htmlxref.d/Texinfo_GNU.cnf (dico): seems only to
	be available by node now.
	(lispintro): Make synonymous with eintr.

2025-08-01  Gavin Smith <gavinsmith0123@gmail.com>

	* util/info-hooks/gnu-manuals-locations: add more URLs

2025-08-01  Gavin Smith <gavinsmith0123@gmail.com>

	* util/info-hooks/gnu-manuals-locations: continue
	adding links.

2025-07-31  Gavin Smith <gavinsmith0123@gmail.com>

	* util/info-hooks/gnu-manuals-locations: fix gcc links
	and add more links

2025-07-31  Gavin Smith <gavinsmith0123@gmail.com>

	* util/info-hooks/gnu-manuals-locations: add link for R
	manuals (no link for Info manuals).

2025-07-31  Gavin Smith <gavinsmith0123@gmail.com>

	* util/info-hooks/gnu-manuals-locations: add link for mit-scheme
	manuals (no link for Info manuals).

2025-08-01 Patrice Dumas  <pertusus@free.fr>

	* tta/C/parsetexi/end_line.c (end_line_starting_block): re-add setting
	parent of element used in expanded conditional source mark to 0, that
	was erroneously removed.

2025-08-01 Patrice Dumas  <pertusus@free.fr>

	Remove parent information for text elements 

	* tta/C/structuring_transfo/transformations.c
	(protect_hashchar_at_line_beginning_internal),
	tta/perl/Texinfo/Transformations.pm
	(_protect_hashchar_at_line_beginning): instead of processing text
	elements, process elements with contents, such that it is easier to
	find the position of the text with regard to end of lines.

	* tta/C/main/tree.c (add_element_to_element_contents)
	(insert_into_contents_as_array): add insert_into_contents_as_array. 
	Add add_element_to_element_contents that works both for text elements
	and other types of elements.

	* tta/C/main/tree_types.h (CONTAINER, ELEMENT),
	tta/C/parsetexi/debug_parser.c (print_element_debug_parser),
	tta/C/main/build_perl_info.c (element_to_perl_hash),
	tta/C/convert/swig_interface.c (txi_ext_element_parent),
	tta/C/main/debug.c (print_element_debug), tta/C/*/*.c,
	tta/perl/Texinfo/*.pm, tta/perl/Texinfo/ParserNonXS.pm
	(_split_element_delimiters, _split_element_def_args),
	tta/perl/XSTexinfo/reader_element/TreeElementXS.xs: do not set parent
	for text elements, considering that the structure information should
	be with the parent already.  Use add_to_contents_as_array and
	insert_into_contents_as_array to add text elements to contents, move
	the parent field from ELEMENT to CONTAINER, check if text element, or,
	in Perl, if there is already a parent to determine if the parent
	should be set.

	* tta/C/main/manipulate_tree.c (protect_text),
	tta/perl/Texinfo/ManipulateTree.pm (_protect_text): do not set the
	parent of the added @comma or @asis commands.

	* tta/perl/Texinfo/ManipulateTree.pm (element_print_details): add.

2025-07-31  Gavin Smith <gavinsmith0123@gmail.com>

	Separate footnote markers with commas

	* doc/texinfo.tex (\dofootnote): Do not reuse definition for
	the footnote marker, as this could include a separating comma.

2025-07-31  Gavin Smith <gavinsmith0123@gmail.com>

	Separate footnote markers with commas

	* doc/texinfo.tex (\dofootnote): Use \aftergroup to output a
	small penalty after the footnote.
	(\footnote): Check \lastpenalty and output a comma before our
	footnote marker if it appears that we are immediately after
	another footnote marker.
	* NEWS: mention
	
	Suggestion from Werner Lemberg.

2025-07-31  Gavin Smith <gavinsmith0123@gmail.com>

	* util/htmlxref.d/Texinfo_GNU.cnf (ada-mode, music-glossary):
	Corrections.

2025-07-31  Gavin Smith <gavinsmith0123@gmail.com>

	* util/info-hooks/gnu-manuals-locations: add locations for
	gcc manuals.  no links to Info files, so reference the top-level
	documentation index that gives links to more formats including
	the Texinfo sources.

2025-07-31  Gavin Smith <gavinsmith0123@gmail.com>

	* util/info-hooks/gnu-manuals-locations: continue to add links,

2025-07-31  Gavin Smith <gavinsmith0123@gmail.com>

	* util/info-hooks/gnu-manuals-locations: continue to add links,
	including for guile-gnome.

2025-07-31  Gavin Smith <gavinsmith0123@gmail.com>

	* util/info-hooks/gnu-manuals-locations: continue to add links,
	including for gnupg and binutils manuals.  note some manuals
	don't have downloads for Info files so we just link to the
	HTML version of the documentation instead.

2025-07-31  Gavin Smith <gavinsmith0123@gmail.com>

	* util/info-hooks/gnu-manuals-locations (emacs, eintr, elisp):
	add specific links.

2025-07-31  Gavin Smith <gavinsmith0123@gmail.com>

	* util/htmlxref.d/Texinfo_GNU.cnf (eintr): Add.

2025-07-31  Gavin Smith <gavinsmith0123@gmail.com>

	* util/info-hooks/gnu-manuals-locations: add links for
	emacs manuals.  most of them don't have Info download links
	on the main page so just link to the main index page.

2025-07-31  Gavin Smith <gavinsmith0123@gmail.com>

	* util/info-hooks/gnu-manuals-locations: add URLs for
	more manuals that follow the usual pattern under www.gnu.org/software.

2025-07-31  Gavin Smith <gavinsmith0123@gmail.com>

	* util/htmlxref.d/Texinfo_GNU.cnf (autogen): Fix node URL,
	changing "autoconf" to "autogen".  (Wrong ever since this entry
	was added.)

2025-07-31  Gavin Smith <gavinsmith0123@gmail.com>

	Add example hook program and supporting data file
	
	* util/info-hooks/manual-not-found,
	* util/info-hooks/gnu-manuals-locations: new

2025-07-31  Gavin Smith <gavinsmith0123@gmail.com>

	Info hooks documentation

	* doc/info-stnd.texi (Hooks): Describe how to get data files
	for a hook.  Add index entries.  In a comment, add exhortation
	not to use the collocation "hook script".

2025-07-30  Gavin Smith <gavinsmith0123@gmail.com>

	* TODO.HTML: discuss possible way forward for use of locally
	installed HTML.  edit for flow after reordering document.

2025-07-30  Gavin Smith <gavinsmith0123@gmail.com>

	* TODO.HTML: spacing, formatting.

2025-07-30  Gavin Smith <gavinsmith0123@gmail.com>

	* TODO.HTML: re-order to put discussion of info.js, webkitgtk-info
	at the end of the file.

2025-07-30  Gavin Smith <gavinsmith0123@gmail.com>

	* TODO.HTML: edit slightly, update.

2025-07-30  Gavin Smith <gavinsmith0123@gmail.com>

	* js/info.js (init_index_page, init_sidebar, init_iframe):
	Add comments to make the "context initializers" easier to find
	as these are long functions that contain many other functions.

2025-07-30 Patrice Dumas  <pertusus@free.fr>

	* tta/C/main/build_perl_info.c (build_minimal_document): do not retain
	a reference to the document tree root element in C before registering
	the Perl object in the C element structure.

2025-07-30 Patrice Dumas  <pertusus@free.fr>

	* tta/C/Makefile.am (C_libtexinfo_main_sources),
	tta/C/convert/swig_element_types.h (TXI_CM_FLAGS_LIST)
	(TXI_CM_OTHER_FLAGS_LIST, TXI_TY_FLAGS_LIST),
	tta/C/convert/swig_element_data.h,
	tta/C/convert/swig_text_options_types.h
	(TEXT_INDICATOR_CONVERTER_OPTIONS), tta/C/convert/swig_text_options.h:
	split #define of swig_element_data.h out to a new file
	swig_element_types.h and swig_text_options.h #define to
	swig_text_options_types.h. 

	* tta/C/convert/swig_interface.c, tta/C/convert/swig_text_options.h,
	tta/C/convert/swig_element_data.h, tta/swig/texinfo.i: prefix swig
	interface function names by txi_ext_.

2025-07-30  Gavin Smith <gavinsmith0123@gmail.com>

	* js/info.js (resolve_page): remove debugging code committed
	by accident.

2025-07-30  Gavin Smith <gavinsmith0123@gmail.com>

	* js/info.js: remove commented-out block of code checking
	screen width.  This was commented out on 2021-02-24 when
	a button to hide the sidebar was added.

2025-07-30  Gavin Smith <gavinsmith0123@gmail.com>

	Reduce info.js indirection

	* js/info.js (Store): Do not pass "reducer" argument to
	constructor.  There is only one Store object and it is only
	ever used with the 'updater' function.
	(Store.prototype.dispatch): Hardcode use of 'updater'.

2025-07-30 Patrice Dumas  <pertusus@free.fr>

	* tta/swig/perl/Makefile.am (all-local, .libs/auto/Texinfo),
	tta/swig/perl/_Texinfo_Tests.pm: add the all-local rule to setup the
	link from .libs/auto/Texinfo to .libs to have in-build XS extension
	found before other extensions in @INC auto/Texinfo subdirectories.
	Remove from _Texinfo_Tests.pm the code doing the link. 

2025-07-30 Patrice Dumas  <pertusus@free.fr>

	* tta/C/Makefile.am (libperlcall_utils_la_SOURCES)
	(libperlcall_utils_la_CPPFLAGS), tta/C/main/use_interpreter_types.h
	(enum interpreter_use): add enum interpreter_use.

	* tta/C/main/set_perl_interpreter.c
	(tta/C/main/set_perl_interpreter.c): rename get_use_perl_interpreter
	as has_perl_interpreter.  Update callers. 

	* tta/C/convert/texinfo.c (txi_setup_main_load_interpreter)
	(txi_load_init_file, txi_stop_interpreter), tta/swig/texinfo.i
	(setup), tta/C/main/set_perl_interpreter.c (set_use_perl_interpreter)
	(has_perl_interpreter): use enum interpreter_use as argument and as
	variable.  Update callers.

2025-07-30 Patrice Dumas  <pertusus@free.fr>

	Initialize the C library when Texinfo modules are loaded but not XS

	* tta/perl/Texinfo/DocumentXS.pm ($XS_package): set $XS_package as
	Texinfo::XSLoader::init return value.

	* tta/C/main/call_perl_function.c (call_eval_load_texinfo_modules):
	return -1 (or croak) if the Perl modules could not be used.  Return
	the Texinfo::DocumentXS::XSLoader true or false value if the modules
	could be used, such that the caller knows if the Document XS module
	was loaded.  It is in this XS module that the C library is
	initialized.

	* tta/C/convert/texinfo.c (txi_setup_main_load_interpreter): check the
	return value of call_eval_load_texinfo_modules and initialize the C
	library and set use interpreter accordingly.

2025-07-30 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/Texinfo/StructTransfXS.pm: do not set $XS_package, it is not
	used anywhere.

	Do not set Texinfo::XSLoader::init return value if not used.

	* tta/swig/perl/t/40convert_to_text.t: minor changes in code and
	comment.

2025-07-30 Patrice Dumas  <pertusus@free.fr>

	* tta/C/convert/convert_html.c: remove html_translate_string, it is
	not used anymore.

	* tta/C/main/manipulate_tree.c (copy_tree): rename copy variable as
	copy_tree and current variable as element.

	* tta/C/main/manipulate_tree.c (set_element_tree_numbers): make a
	simple no-op as it does nothing currently, and rename the
	implementation.

	Changes in comments and TODO

	* tta/swig/perl/t/*.t: move code around.

	* tta/swig/perl/t/20index_sort.t: change in spacing.

2025-07-30  Gavin Smith <gavinsmith0123@gmail.com>

	* js/info.css (.highlight): Change background (used for search
	matches from "lightgrey" to #FFCC33 (orange-yellow) as the
	grey highlighting is easy to miss.

2025-07-30  Gavin Smith <gavinsmith0123@gmail.com>

	Don't accumulate <datalist> elements under text input box

	* js/info.js (Text_input.prototype.show): Check if <datalist>
	element already exists before creating it.  Previously, multiple
	<datalist> elements would accumulate within the <index type=search>
	as 'i' was repeatedly used.

2025-07-30  Gavin Smith <gavinsmith0123@gmail.com>

	* js/info.js (init_iframe) <on_load>, (actions.cache_index_links):
	Inline most of actions.cache_index_links into on_load.  This way
	actions.cache_index_links is focused on the structure of the message.

2025-07-30  Gavin Smith <gavinsmith0123@gmail.com>

	* NEWS: mention info.js fix

2025-07-30  Gavin Smith <gavinsmith0123@gmail.com>

	* js/info.js (on_keydown): Check that no modifiers (namely,
	Alt, Ctrl nor Meta) are pressed.  This means specifically that
	C-l can still select the location bar and C-r can refresh the page.

2025-07-30  Gavin Smith <gavinsmith0123@gmail.com>

	Make clicking on links on Top node not so broken

	* js/info.js (config) <TOP_ID>: Change from "top" to "index".
	Links in the Top node are still rewritten to have href attributes
	that look like "index.html#index.toc-Nodes" and the value "index"
	is needed to make sure that the check for the Top node in
	'resolve_page' works.  This reverses change on 2024-10-07 (before
	which TOP_ID was called "INDEX_ID".)
	
	Before this, clicking on links in a short table of contents, or
	clicking on the copiable anchor in the manual title, would lead
	"index.html" to be loaded in the main iframe and two copies of the
	navigation interface would be visible.

2025-07-29  Gavin Smith <gavinsmith0123@gmail.com>

	Fewer functions called 'render'

	* js/info.js
	(Help_page.prototype.render, Minibuffer.prototype.render)
	(Echo_area.prototype.render, Sidebar.prototype.render)
	(Pages.prototype.render):
	Rather than defining all of these as "function render", use the
	names help_page_render, minibuffer_render, echo_area_render,
	sidebar_render, and pages_render respectively.

	This makes the output of "console.trace()" easier to understand.

2025-07-29 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/ext/tex4ht.pm (tex4ht_prepare): warn if there was an error
	with close.

2025-07-29 Patrice Dumas  <pertusus@free.fr>

	Remove the Texinfo::TeX4HT customization package

	* NEWS, tta/perl/ext/tex4ht.pm (tex4ht_prepare)
	(tex4ht_process_format): remove the Texinfo::TeX4HT customization
	package, replace by the defaults.  If customization is needed, it
	should be implemented through customization variables.

	* tta/perl/t/init/t2h_singular.init: replace the use of long gone
	Texinfo::TeX4HT STYLE by setting T4H_TEX_CONVERSION and
	T4H_MATH_CONVERSION to latex.

2025-07-29 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/ext/latex2html.pm (l2h_retrieve_from_html): do not modify
	image file names.  Remove l2h_change_image_file_names.

2025-07-29  Gavin Smith <gavinsmith0123@gmail.com>

	* js/info.js (on_load):
	Store "components" as an array rather than as a hash
	called "components" containing an array called "components".
	(Store.prototype.dispatch): Update.

2025-07-29  Gavin Smith <gavinsmith0123@gmail.com>

	* doc/texinfo.texi (@sp): Include argument within @code in
	section title.

2025-07-29  Gavin Smith <gavinsmith0123@gmail.com>

	* js/info.js (Store.prototype.dispatch):
	Inline contents of "render" function.
	(init_index_page) <on_load>: Remove "render" as a property
	of "components" object referencing a function.

2025-07-29  Gavin Smith <gavinsmith0123@gmail.com>

	Eliminate "listeners" abstraction

	* js/info.js (Store): Do not set 'listeners' array.
	(Store.prototype.dispatch): Call 'render' function directly
	rather than looping over 'listeners'.
	(init_index_page) <on_load>: Save 'components' array on
	'store' object, rather than adding a single function to 'listeners'.

	Historically, the "listeners" paradigm was inspired by the
	"Redux" library (private May 2017 discussion).	However,
	it appears to be unnecessary here as there was only only one
	listener.

2025-07-29 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/ext/latex2html.pm (l2h_finish): warn if unlink did not
	succeed.

2025-07-29 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/ext/latex2html.pm (l2h_to_latex, l2h_retrieve_from_html)
	(l2h_init_cache, l2h_store_cache): check close error condition and
	warn.

	* tta/perl/ext/latex2html.pm (l2h_process)
	(l2h_change_image_file_names, l2h_retrieve_from_html): handle empty
	destination_directory.

	* tta/perl/t/test_utils.pl: change in spacing.

2025-07-29  Gavin Smith <gavinsmith0123@gmail.com>

	* info/echo-area.c (ea_scroll_completions_window):
	Reinstate removed lines but use result as intended in call
	to set_window_pagetop.

2025-07-29  Gavin Smith <gavinsmith0123@gmail.com>

	* info/man.c (get_manpage_from_formatter): Keep on going
	if return value from 'get_output_from_program' is non-zero,
	in line with following comment.

2025-07-29  Gavin Smith <gavinsmith0123@gmail.com>

	* info/run-external.c (get_output_from_program):
	Enclose use of WIFEXITED and WEXITSTATUS in HAVE_SYS_WAIT_H
	check.  Report from Patrice.

2025-07-29  Gavin Smith <gavinsmith0123@gmail.com>

	* info/run-external.c (get_output_from_program) [!PIPE_USE_FORK]:
	Check if return value of pclose is -1 before using WEXITSTATUS etc.
	on it.  Report from Patrice.

2025-07-29 Patrice Dumas  <pertusus@free.fr>

	Code cleanups based on compiler warnings

	* info/echo-area.c (ea_scroll_completions_window): remove unused lines
	variable and associated code.

	* info/makedoc.c (process_one_file): remove line_start variable, set
	but not used.

	* info/session-cmd.c (info_get_node_with_defaults)
	(info_select_reference): remove unused variables.

	* tta/swig/texinfo.i (setup): initialize variables to silence compiler
	warning (they are not used anywhere if texinfo_uninstalled is set).

2025-07-29  Gavin Smith <gavinsmith0123@gmail.com>

	* info/run-external.c (get_output_from_program):
	Use WIFEXITED on exit status from wait or popen before
	using WEXITSTATUS.  Return 127 as a general error code
	if WIFEXITED is false.  Report from Patrice.

2025-07-28  Gavin Smith <gavinsmith0123@gmail.com>

	Remove annoying tooltip for Top node with info.js
	
	(updater): Add new action type "window-title-of-linkid".
	Not much is done in this function.
	(Pages.prototype.render): This called indirectly and is where a
	lot of the real processing is done after the main "store"
	receives an action.  Handle "window-title-of-linkid" action.
	
	(init_iframe) <on_load>: Initiate "window-title-of-linkid"
	action.  This contains the ID of the node as well as the new
	title to use, leading the "title" to be updated on the correct
	<div>.	We get the ID from the window location.  This is more
	reliable than the "window-title" action as that seemed to try
	to use whichever node was currently being displayed, which was
	wrong when the index nodes were read in at start up.  This led
	to a "title" attribute being set incorrectly on some element in
	the Top node, which would lead to a tool-tip appearing with the
	title of whichever Index node was read in last.

	(actions) (window_title_of_linkid): Add for "window-title-of-linkid"
	message.

2025-07-28  Gavin Smith <gavinsmith0123@gmail.com>

	* info.js (init_sidebar) <add_header>:
	Remove 'a.copiable-link' element from main title in sidebar.
	This often contains a large ¶ symbol which is unnecessary.

2025-07-28 Patrice Dumas  <pertusus@free.fr>

	* tta/perl/XSTexinfo/Makefile.am (ReaderXS_la_LIBADD): add dependency
	on libtexinfo.la.

2025-07-28  Gavin Smith <gavinsmith0123@gmail.com>

	Less recommendation of @menu

